#ifndef __GPIO_H__
#define __GPIO_H__

#include "common.h"
#include <assert.h>

#define GPIO_SUCC  0
#define	GPIO_ERR   1

typedef enum
{ 
	GPIO_Control_DIG   = 0, /*!< GPIO Control Digital */
	GPIO_Control_ANA	 = 1, /*!< GPIO Control Analogy  */
}GPIOControl_TypeDef;
#define IS_GPIO_Control(Ctrl) (((Ctrl) == GPIO_Control_ANA)  || ((Ctrl) == GPIO_Control_DIG) )? 1:0

typedef enum
{ 
	GPIO_Mode_OUT  = 0, /*!< GPIO Output Mode */
	GPIO_Mode_IN	 = 1, /*!< GPIO Input Mode */
}GPIOMode_TypeDef;
#define IS_GPIO_MODE(MODE) (((MODE) == GPIO_Mode_IN)  || ((MODE) == GPIO_Mode_OUT) )? 1:0

typedef enum
{ 
	GPIO_OType_PP = 0,//普通输出
	GPIO_OType_OD = 1 //开漏输出
}GPIOOType_TypeDef;
#define IS_GPIO_OTYPE(OTYPE) (((OTYPE) == GPIO_OType_PP) || ((OTYPE) == GPIO_OType_OD))? 1:0
typedef enum
{ 
	GPIO_PuPd_NOPULL = 0x00,
	GPIO_PuPd_UP     = 0x01,
	GPIO_PuPd_DOWN   = 0x02
}GPIOPuPd_TypeDef;
#define IS_GPIO_PUPD(PUPD) (((PUPD) == GPIO_PuPd_NOPULL) || ((PUPD) == GPIO_PuPd_UP) || \
                            ((PUPD) == GPIO_PuPd_DOWN))? 1:0
typedef enum
{ 
	GPIO_Level_LOW	= 0x00,
	GPIO_Level_HIGH = 0x01,
}GPIOInit_Level;

//typedef enum
//{ 
//	GPIO_PORT0 = 0x00,
//	GPIO_PORT1 = 0x01,		
//	GPIO_PORT2 = 0x02,
//	GPIO_PORT3 = 0x03,
//	GPIO_PORT4 = 0x04,
//	GPIO_PORT5 = 0x05,
//	GPIO_PORT6 = 0x06,
//	GPIO_PORT7 = 0x07,

//	GPIO_PORT12 = 0x0C,
//	GPIO_PORT13 = 0x0D,
//	GPIO_PORT14 = 0x0E,
//}GPIO_Port_t;

typedef enum
{ 
	GPIO_PORTA = 0x00,
	GPIO_PORTB = 0x01,		
	GPIO_PORTC = 0x02,
	GPIO_PORTD = 0x03,
	GPIO_PORTH = 0x08,

}GPIO_Port_t;

#define IS_GPIO_ALL_PERIPH(PERIPH) (((PERIPH) == GPIO_PORTA) || \
									((PERIPH) == GPIO_PORTB) || \
									((PERIPH) == GPIO_PORTC) || \
									((PERIPH) == GPIO_PORTD)|| \
									((PERIPH) == GPIO_PORTH))? 1:0

/** 
  * @brief  GPIO Bit SET and Bit RESET enumeration 
  */ 
typedef enum
{ 
  Bit_RESET = 0,
  Bit_SET
}BitAction;
#define IS_GPIO_BIT_ACTION(ACTION) (((ACTION) == Bit_RESET) || ((ACTION) == Bit_SET))



#define GPIO_Pin_0                 ((uint16_t)0x0001)  /* Pin 0 selected */
#define GPIO_Pin_1                 ((uint16_t)0x0002)  /* Pin 1 selected */
#define GPIO_Pin_2                 ((uint16_t)0x0004)  /* Pin 2 selected */
#define GPIO_Pin_3                 ((uint16_t)0x0008)  /* Pin 3 selected */
#define GPIO_Pin_4                 ((uint16_t)0x0010)  /* Pin 4 selected */
#define GPIO_Pin_5                 ((uint16_t)0x0020)  /* Pin 5 selected */
#define GPIO_Pin_6                 ((uint16_t)0x0040)  /* Pin 6 selected */
#define GPIO_Pin_7                 ((uint16_t)0x0080)  /* Pin 7 selected */
#define GPIO_Pin_8                 ((uint16_t)0x0100)  /* Pin 8 selected */
#define GPIO_Pin_9                 ((uint16_t)0x0200)  /* Pin 9 selected */
#define GPIO_Pin_10                ((uint16_t)0x0400)  /* Pin 10 selected */
#define GPIO_Pin_11                ((uint16_t)0x0800)  /* Pin 11 selected */
#define GPIO_Pin_12                ((uint16_t)0x1000)  /* Pin 12 selected */
#define GPIO_Pin_13                ((uint16_t)0x2000)  /* Pin 13 selected */
#define GPIO_Pin_14                ((uint16_t)0x4000)  /* Pin 14 selected */
#define GPIO_Pin_15                ((uint16_t)0x8000)  /* Pin 15 selected */



#define GPIO_PIN_MASK              ((uint16_t)0xFFFF) /* PIN mask for assert test */
#define IS_GPIO_PIN(PIN)           (((PIN) & GPIO_PIN_MASK ) != (uint16_t)0x00) ? 1:0

#define IS_GET_GPIO_PIN(PIN) (((PIN) == GPIO_Pin_0) || \
                              ((PIN) == GPIO_Pin_1) || \
                              ((PIN) == GPIO_Pin_2) || \
                              ((PIN) == GPIO_Pin_3) || \
                              ((PIN) == GPIO_Pin_4) || \
                              ((PIN) == GPIO_Pin_5) || \
                              ((PIN) == GPIO_Pin_6) || \
                              ((PIN) == GPIO_Pin_7))? 1:0
															

typedef enum
{
	GROUP_AF_ODEFAULT = 0,	//ANIxx or GPIO

	
	GROUP_AF_OPA0DA = 0x00,
	GROUP_AF_DAC0 = 0x00,
	GROUP_AF_SWDIO = 0x00,	
	GROUP_AF_SWCLK = 0x00,	
	GROUP_AF_AVREFM = 0x00,
	GROUP_AF_AVREFP = 0x00,
	
	
	GROUP_AF_RXD0 = 0x01,
	GROUP_AF_RXD1 = 0x01,
	GROUP_AF_RXD2 = 0x01,
	GROUP_AF_TXD0 = 0x01,
	GROUP_AF_TXD1 = 0x01,
	GROUP_AF_TXD2 = 0x01,	
	
	GROUP_AF_SDO00 = 0x01,
	GROUP_AF_SDO01 = 0x01,
	GROUP_AF_SDO10 = 0x01,
  GROUP_AF_SDO11 = 0x01,	
	GROUP_AF_SDO20 = 0x01,
	GROUP_AF_SDO21 = 0x01,
	
	GROUP_AF_SDI00 = 0x01,
	GROUP_AF_SDI01 = 0x01,
	GROUP_AF_SDI10 = 0x01,
	GROUP_AF_SDI11 = 0x01,
	GROUP_AF_SDI20 = 0x01,	
	GROUP_AF_SDI21 = 0x01,
	
	GROUP_AF_SDA00 = 0x01,
	GROUP_AF_SDA01 = 0x01,
	GROUP_AF_SDA10 = 0x01,
	GROUP_AF_SDA11 = 0x01,
	GROUP_AF_SDA20 = 0x01,	
	GROUP_AF_SDA21 = 0x01,
	
	GROUP_AF_SS00 = 0x01,
	GROUP_AF_SS01 = 0x01,
	GROUP_AF_SS10 = 0x01,
	GROUP_AF_SS11 = 0x01,
	GROUP_AF_SS20 = 0x01,
	GROUP_AF_SS21 = 0x01,
	
	GROUP_AF_SCLK00 = 0x01,
	GROUP_AF_SCLK01 = 0x01,
	GROUP_AF_SCLK10 = 0x01,
	GROUP_AF_SCLK11 = 0x01,
	GROUP_AF_SCLK20 = 0x01,
	GROUP_AF_SCLK21 = 0x01,
	
	GROUP_AF_SCL00 = 0x01,	
	GROUP_AF_SCL01 = 0x01,
	GROUP_AF_SCL10 = 0x01,	
	GROUP_AF_SCL11 = 0x01,
	GROUP_AF_SCL20 = 0x01,	
	GROUP_AF_SCL21 = 0x01,

	GROUP_AF_TI00 = 0x02,
	GROUP_AF_SCLA0 = 0x02,
	GROUP_AF_SDAA0 = 0x02,	

	GROUP_AF_TO00 = 0x03,
	GROUP_AF_TO01 = 0x03,
	GROUP_AF_TO02 = 0x03,	
	GROUP_AF_TO03 = 0x03,
	GROUP_AF_TO04 = 0x03,
	GROUP_AF_TO05 = 0x03,	
	GROUP_AF_TO06 = 0x03,
	GROUP_AF_TO07 = 0x03,
	
	GROUP_AF_TI01 = 0x03,		
	GROUP_AF_TI02 = 0x03,		
	GROUP_AF_TI03 = 0x03,	
	GROUP_AF_TI04 = 0x03,
	GROUP_AF_TI05 = 0x03,		
	GROUP_AF_TI06 = 0x03,
	GROUP_AF_TI07 = 0x03,	
	

	GROUP_AF_TI00GATE = 0x04,	
	GROUP_AF_TI01GATE = 0x04,
	GROUP_AF_TI02GATE = 0x04,	
	GROUP_AF_TI03GATE = 0x04,
	GROUP_AF_TI04GATE = 0x04,
	GROUP_AF_TI05GATE = 0x04,
  GROUP_AF_TI06GATE = 0x04,	
  GROUP_AF_TI07GATE = 0x04,	
	GROUP_AF_RTC1HZ = 0x04,		
	
  GROUP_AF_PB09TI00 = 0x05,
//	GROUP_AF_SPI0SI = 0x05,
//	GROUP_AF_SPI0SO = 0x05,
	GROUP_AF_SPI0MISO = 0x05,
	GROUP_AF_SPI0MOSI = 0x05,
	GROUP_AF_SPI0NSS = 0x05,
	GROUP_AF_SPI0SCK = 0x05,
		
	GROUP_AF_VC0OUT = 0x06,
	GROUP_AF_VC1OUT = 0x06,	
	
	GROUP_AF_KR0 = 0x06,
	GROUP_AF_KR1 = 0x06,
	GROUP_AF_KR2 = 0x06,
	GROUP_AF_KR3 = 0x06,
	GROUP_AF_KR4 = 0x06,	
	GROUP_AF_KR5 = 0x06,
	GROUP_AF_KR6 = 0x06,
	GROUP_AF_KR7 = 0x06,
	
	GROUP_AF_TATI = 0x06,
	GROUP_AF_TATO = 0x06,
	GROUP_AF_TATON = 0x06,
		
	GROUP_AF_PCLBUZ0 = 0x07,	
	GROUP_AF_PCLBUZ1 = 0x07,

}GROUP_AF_t;

//typedef enum
//{
//	GROUP_AF_ODEFAULT = 0,
//	/*GPIO used as output function configuration*/	
//	GROUP_AF_TO10 = 0x01,
//	GROUP_AF_TO11 = 0x02,
//	GROUP_AF_TO12 = 0x03,
//	GROUP_AF_TO13 = 0x04,

//	GROUP_AF_TXD0 = 0x05,
//	GROUP_AF_SDO00= 0x05,
//	
//	GROUP_AF_SDO20= 0x06,
//	GROUP_AF_TXD2 = 0x06,
//	
//	GROUP_AF_CLKBUZ0= 0x07,
//	
//	GROUP_AF_SCKO00=0x08,
//	GROUP_AF_SCKO20=0x09,
//	GROUP_AF_TXD1 = 0x0A,
//	GROUP_AF_SDO10= 0x0A,
//	/*GPIO used as input function configuration*/
//	GROUP_AF_TI10 = 0x60,
//	GROUP_AF_TI11 = 0x61,
//	GROUP_AF_TI12 = 0x62,
//	GROUP_AF_TI13 = 0x63,
//	GROUP_AF_INTP0 = 0x64,
//	GROUP_AF_INTP1 = 0x65,
//	GROUP_AF_INTP2 = 0x66,
//	GROUP_AF_INTP3 = 0x67,
//	
//	GROUP_AF_RXD0 = 0x68,
//	GROUP_AF_SDI00 = 0x68,
//	GROUP_AF_SDA00 = 0x68,
//	
//	GROUP_AF_SCLKI00=0x69,
//	GROUP_AF_SS00  =0x6A,
//	
//	GROUP_AF_RXD2 = 0x6B,
//	GROUP_AF_SDI20 = 0x6B,
//	GROUP_AF_IRRXD = 0x6B,
//	
//	GROUP_AF_SCLKI20=0x6C,
//	GROUP_AF_SDAA0 = 0x6D,
//	GROUP_AF_SCLAA0 = 0x6E,	
//	
//	GROUP_AF_RXD1 = 0x6F,
//	GROUP_AF_SDI10 = 0x6F,
//	GROUP_AF_SDA10 = 0x6F,	
//	
//	GROUP_AF_SPIP = 0x7E,	
//}GROUP_AF_t;


#define IS_GPIO_AF(GPIO_AF) (((GPIO_AF) == GROUP_AF_ODEFAULT  || \
						(GPIO_AF) == GROUP_AF_OPA0DA || (GPIO_AF) == GROUP_AF_DAC0 || (GPIO_AF) == GROUP_AF_SWDIO || (GPIO_AF) == GROUP_AF_SWCLK || \
						(GPIO_AF) == GROUP_AF_AVREFM || (GPIO_AF) == GROUP_AF_AVREFP || (GPIO_AF) == GROUP_AF_RXD0 || (GPIO_AF) == GROUP_AF_RXD1 || (GPIO_AF) == GROUP_AF_RXD2 || \
						(GPIO_AF) == GROUP_AF_TXD0 || (GPIO_AF) == GROUP_AF_TXD1 || (GPIO_AF) == GROUP_AF_TXD2 || (GPIO_AF) == GROUP_AF_SDO00 || (GPIO_AF) == GROUP_AF_SDO01 || \
						(GPIO_AF) == GROUP_AF_SDO10 || (GPIO_AF) == GROUP_AF_SDO11 || (GPIO_AF) == GROUP_AF_SDO20 || (GPIO_AF) == GROUP_AF_SDO21 || (GPIO_AF) == GROUP_AF_SDI00 || \
						(GPIO_AF) == GROUP_AF_SDI01 || (GPIO_AF) == GROUP_AF_SDI10 || (GPIO_AF) == GROUP_AF_SDI11 || (GPIO_AF) == GROUP_AF_SDI20 || (GPIO_AF) == GROUP_AF_SDI21 || \
						(GPIO_AF) == GROUP_AF_SDA00 || (GPIO_AF) == GROUP_AF_SDA01 || (GPIO_AF) == GROUP_AF_SDA10 || (GPIO_AF) == GROUP_AF_SDA11 || (GPIO_AF) == GROUP_AF_SDA20 || \
						(GPIO_AF) == GROUP_AF_SDA21 || (GPIO_AF) == GROUP_AF_SS00 || (GPIO_AF) == GROUP_AF_SS01 || (GPIO_AF) == GROUP_AF_SS10 || (GPIO_AF) == GROUP_AF_SS11 || \
						(GPIO_AF) == GROUP_AF_SS20 || (GPIO_AF) == GROUP_AF_SS21 || (GPIO_AF) == GROUP_AF_SCLK00 || (GPIO_AF) == GROUP_AF_SCLK01 || (GPIO_AF) == GROUP_AF_SCLK10 || \
						(GPIO_AF) == GROUP_AF_SCLK11 || (GPIO_AF) == GROUP_AF_SCLK20 || (GPIO_AF) == GROUP_AF_SCLK21 || (GPIO_AF) == GROUP_AF_SCL00 || (GPIO_AF) == GROUP_AF_SCL01 || \
						(GPIO_AF) == GROUP_AF_SCL10 || (GPIO_AF) == GROUP_AF_SCL11 || (GPIO_AF) == GROUP_AF_SCL20 || (GPIO_AF) == GROUP_AF_SCL21 || (GPIO_AF) == GROUP_AF_TI00 || \
						(GPIO_AF) == GROUP_AF_SCLA0 || (GPIO_AF) == GROUP_AF_SDAA0 || (GPIO_AF) == GROUP_AF_TO00 || (GPIO_AF) == GROUP_AF_TO01 || (GPIO_AF) == GROUP_AF_TO02 || \
						(GPIO_AF) == GROUP_AF_TO03 || (GPIO_AF) == GROUP_AF_TO04 || (GPIO_AF) == GROUP_AF_TO05 || (GPIO_AF) == GROUP_AF_TO06 || (GPIO_AF) == GROUP_AF_TO07 || \
						(GPIO_AF) == GROUP_AF_TI01 || (GPIO_AF) == GROUP_AF_TI02 || (GPIO_AF) == GROUP_AF_TI03 || (GPIO_AF) == GROUP_AF_TI04 || (GPIO_AF) == GROUP_AF_TI05 || \
						(GPIO_AF) == GROUP_AF_TI06 || (GPIO_AF) == GROUP_AF_TI07 || (GPIO_AF) == GROUP_AF_TI00GATE || (GPIO_AF) == GROUP_AF_TI01GATE || (GPIO_AF) == GROUP_AF_TI02GATE || \
						(GPIO_AF) == GROUP_AF_TI03GATE || (GPIO_AF) == GROUP_AF_TI04GATE || (GPIO_AF) == GROUP_AF_TI05GATE || (GPIO_AF) == GROUP_AF_TI06GATE || (GPIO_AF) == GROUP_AF_TI07GATE || \
						(GPIO_AF) == GROUP_AF_RTC1HZ || (GPIO_AF) == GROUP_AF_PB09TI00 || (GPIO_AF) == GROUP_AF_SPI0MISO || (GPIO_AF) == GROUP_AF_SPI0MOSI || (GPIO_AF) ==  GROUP_AF_SPI0NSS||\
						(GPIO_AF) == GROUP_AF_SPI0SCK || (GPIO_AF) == GROUP_AF_VC0OUT || (GPIO_AF) == GROUP_AF_VC1OUT || (GPIO_AF) == GROUP_AF_KR0 || (GPIO_AF) == GROUP_AF_KR1 ||\
						(GPIO_AF) == GROUP_AF_KR2 || (GPIO_AF) == GROUP_AF_KR3 || (GPIO_AF) == GROUP_AF_KR4 || (GPIO_AF) == GROUP_AF_KR5 || (GPIO_AF) == GROUP_AF_KR6 ||\
						(GPIO_AF) == GROUP_AF_KR7 || (GPIO_AF) == GROUP_AF_TATI || (GPIO_AF) == GROUP_AF_TATO || (GPIO_AF) == GROUP_AF_TATON || (GPIO_AF) == GROUP_AF_PCLBUZ0 ||(GPIO_AF) == GROUP_AF_PCLBUZ1 \
					)? 1:0)


//#define IS_GPIO_AF_OUT(GPIO_AF) (((GPIO_AF) == GROUP_AF_ODEFAULT || (GPIO_AF) == GROUP_AF_TO10 ||(GPIO_AF) == GROUP_AF_TO11 || (GPIO_AF) == GROUP_AF_TO12 || (GPIO_AF) == GROUP_AF_TO13 || \
//						         (GPIO_AF) == GROUP_AF_TXD0 || (GPIO_AF) == GROUP_AF_SDO00 || (GPIO_AF) == GROUP_AF_SDO20 || (GPIO_AF) == GROUP_AF_TXD2 || (GPIO_AF) == GROUP_AF_CLKBUZ0 || \
//						         (GPIO_AF) == GROUP_AF_SCKO00 || (GPIO_AF) == GROUP_AF_SCKO20 || (GPIO_AF) == GROUP_AF_TXD1 \
//								)? 1:0)

//#define IS_GPIO_AF_IN(GPIO_AF) (((GPIO_AF) == GROUP_AF_TI10 || (GPIO_AF) == GROUP_AF_TI11 || (GPIO_AF) == GROUP_AF_TI12 || (GPIO_AF) == GROUP_AF_TI13 || (GPIO_AF) == GROUP_AF_INTP0 ||\
//						 (GPIO_AF) == GROUP_AF_INTP1 || (GPIO_AF) == GROUP_AF_INTP2 || (GPIO_AF) == GROUP_AF_INTP3 || (GPIO_AF) == GROUP_AF_RXD0 || (GPIO_AF) == GROUP_AF_SDI00 || \
//                         (GPIO_AF) == GROUP_AF_SDA00 || (GPIO_AF) == GROUP_AF_SCLKI00 ||(GPIO_AF) == GROUP_AF_SS00 || (GPIO_AF) == GROUP_AF_RXD2 || (GPIO_AF) == GROUP_AF_SDI20 || \
//						 (GPIO_AF) == GROUP_AF_IRRXD || (GPIO_AF) == GROUP_AF_SCLKI20 ||(GPIO_AF) == GROUP_AF_SDAA0 || (GPIO_AF) == GROUP_AF_SCLAA0 || (GPIO_AF) == GROUP_AF_RXD1 ||\
//						 (GPIO_AF) == GROUP_AF_SDI10 || (GPIO_AF) == GROUP_AF_SDA10 ||(GPIO_AF) == GROUP_AF_SPIP \
//								)? 1:0)

//typedef enum {
//	PIN0 = 0,
//	PIN1,
//	PIN2,
//	PIN3,
//	PIN4,
//	PIN5,
//	PIN6,
//	PIN7,
//	PIN8,
//	PIN9,
//	PIN10,
//	PIN11,
//	PIN12,
//	PIN13,
//	PIN14,
//	PIN15,
//}PIN_TypeDef;

typedef enum
{
	GPIO_PIN_START = 0x00, 
	GPIO_PA00 = 0x01,
	GPIO_PA01 = 0x02,
	GPIO_PA02 = 0x03,
	GPIO_PA03 = 0x04,
	GPIO_PA04 = 0x05,
	GPIO_PA05 = 0x06,
	GPIO_PA06 = 0x07,
	GPIO_PA07 = 0x08,
	GPIO_PA08 = 0x09,
	GPIO_PA09 = 0x0A,
	GPIO_PA10 = 0x0B,
	GPIO_PA11 = 0x0C,
	GPIO_PA12 = 0x0D,
	GPIO_PA13 = 0x0E,
	GPIO_PA14 = 0x0F,
	GPIO_PA15 = 0x10,
	GPIO_PB00 = 0x11,
	GPIO_PB01 = 0x12,
	GPIO_PB02 = 0x13,
	GPIO_PB03 = 0x14,
	GPIO_PB04 = 0x15,
	GPIO_PB05 = 0x16,
	GPIO_PB06 = 0x17,
	GPIO_PB07 = 0x18,
	GPIO_PB08 = 0x19,
	GPIO_PB09 = 0x1A,
	GPIO_PB10 = 0x1B,
	GPIO_PB11 = 0x1C,
	GPIO_PB12 = 0x1D,
	GPIO_PB13 = 0x1E,
	GPIO_PB14 = 0x1F,
	GPIO_PB15 = 0x20,
	GPIO_PC00 = 0x21,
	GPIO_PC01 = 0x22,
	GPIO_PC02 = 0x23,
	GPIO_PC03 = 0x24,
	GPIO_PC04 = 0x25,
	GPIO_PC05 = 0x26,
	GPIO_PC06 = 0x27,
	GPIO_PC07 = 0x28,
	GPIO_PC08 = 0x29,
	GPIO_PC09 = 0x2A,
	GPIO_PC10 = 0x2B,
	GPIO_PC11 = 0x2C,
	GPIO_PC12 = 0x2D,
	GPIO_PC13 = 0x2E,	
	GPIO_PC14 = 0x2F,	
	GPIO_PD00 = 0x30,	
	GPIO_PD01 = 0x31,		
	GPIO_PD02 = 0x32,		
	GPIO_PD03 = 0x33,		
	GPIO_PD04 = 0x34,		
	GPIO_PD05 = 0x35,		
	GPIO_PD06 = 0x36,		
	GPIO_PD07 = 0x37,		
	GPIO_PH01 = 0x38,		
	GPIO_PH02 = 0x39,			
	GPIO_PH03 = 0x3A,			
	GPIO_PH04 = 0x3B,			
	GPIO_PIN_END = 0x3C,
}GPIO_Source_t;

 

typedef struct 
{
	uint16_t GPIO_Pin;						/*!< Specifies the GPIO pins to be configured.
										  This parameter can be any value of @ref GPIO_pins_define */
	GPIOMode_TypeDef GPIO_Mode;	  /*!< Specifies the operating mode for the selected pins.
									   This parameter can be a value of @ref GPIOMode_TypeDef */
	GPIOControl_TypeDef GPIO_Ctrl;    /*!< Specifies the control mode for the selected pins.
									   This parameter can be a value of @ref GPIOControl_TypeDef */
	GPIOOType_TypeDef GPIO_OType;   /*!< Specifies the operating output type for the selected pins.
										This parameter can be a value of @ref GPIOOType_TypeDef */
	GPIOPuPd_TypeDef GPIO_PuPd; 	/*!< Specifies the operating Pull-up/Pull down for the selected pins.
										 This parameter can be a value of @ref GPIOPuPd_TypeDef */
	GPIOInit_Level GPIO_Level;  /*!< Specifies the gpio init level for the selected pins.
										  This parameter can be a value of @ref GPIOInit_Level */
}GPIO_InitTypeDef;

/***************************************************************
*  PinCFG: PA00CFG, PA01CFG, ....PH04CFG
*  MuxMode: GROUP_AF_RXD0,GROUP_AF_RXD1, .....,GROUP_AF_PCLBUZ1
******************************************************************/
#define SYS_SET_IOCFG(PinCFG, MuxMode)	PinCFG = MuxMode;


void GPIO_Output_Enable(__IO uint16_t *port, uint16_t pinMsk);
void GPIO_Input_Enable(__IO uint16_t *port, uint16_t pinMsk);
void GPIO_PullUp_Enable(__IO uint16_t *port, uint16_t pinMsk);
void GPIO_PullUp_Disable(__IO uint16_t *port, uint16_t pinMsk);
void GPIO_PullDown_Enable(__IO uint16_t *port, uint16_t pinMsk);
void GPIO_PullDown_Disable(__IO uint16_t *port, uint16_t pinMsk);
void GPIO_Set_Value(__IO uint16_t *port, uint16_t value);
//uint8_t GPIO_Get_Value(__IO uint8_t *port);

uint8_t GPIO_ReadInputDataBit(GPIO_Port_t PORTx, uint16_t GPIO_Pin);
uint8_t GPIO_ReadOutputDataBit(GPIO_Port_t PORTx, uint16_t GPIO_Pin);
void GPIO_SetBits(GPIO_Port_t  PORTx, uint16_t GPIO_Pin);
void GPIO_ResetBits(GPIO_Port_t PORTx, uint16_t GPIO_Pin);
void GPIO_Init(GPIO_Port_t PORTx,GPIO_InitTypeDef* GPIO_InitStruct);
int GPIO_PinAFConfig(GPIO_Port_t PORTx, uint16_t GPIO_Pin, GROUP_AF_t GPIO_AF);
//void GPIO_SPI_GroupConfig(uint8_t groupNum);
#endif

