/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G127
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "adc_demo.h"

#define ADC_ENABLE   1

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t   g_AdcIntTaken;

uint16_t get_value[8];


int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t tempAdc;
    double voltage = 5.0;
    int i = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);
	//-----------------------------------------------------------------------
	// ADC Samples the voltage of Temperature Sensor
	//-----------------------------------------------------------------------
    Adc_Init();
    tempAdc = ADC_Converse(ADC_TemperSensor0, sizeof(get_value) / sizeof(get_value[0]), get_value);
	  printf("ADC Value of Temperature Sensor:\n");
    for (i = 0; i < 8; i++)
    {
        printf("Reference Voltage = %3.2fV, ADC Get Value = %04d, Voltage = %3.2fV\n", voltage, get_value[i], (double)get_value[i] * voltage / 4096);
    }

    //-----------------------------------------------------------------------
    // ADC Samples the voltage of Internal reference voltage (1.45V)
    //-----------------------------------------------------------------------
#if 1
    tempAdc = ADC_Converse(ADC_InterRefVolt, sizeof(get_value) / sizeof(get_value[0]), get_value);
    printf("ADC Value of Internal reference voltage (1.45V):\n");

    for (i = 0; i < sizeof(get_value) / sizeof(get_value[0]); i++)
    {
        printf("Reference Voltage = %3.2fV, ADC Get Value = %04d, Voltage = %3.2fV\n", voltage, get_value[i], (double)get_value[i] * voltage / 4096);
    }

#endif


}


