/******************************************************************************
*
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              
*
*******************************************************************************
*
* FileName      : lcd_demo.c                                                  *
* Author        
:                                                              *
* Version       : 1.0                                                          *
* Date          : 2022.11.28                                                   *
* Description   
:                                                              *
* Function List 
:                                                              *
*******************************************************************************
*/
#include "lcd_demo.h"


/***********************************************************************************************************************
* Function Name: LCD_Start
* Description  : This function set all PGIOs to LCD function.
*                   ݾʹöӦIO
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void LCD_GPIOInit(void)
{
		PORT->PMCA=0x0000;				//set the GPIOA to LCD
    PORT->PMCB=0x0000;				//set the GPIOB to LCD
    PORT->PMCC=0x0000;				//set the GPIOC to LCD
    PORT->PMCD=0x0000;				//set the GPIOD to LCD

    PORT->PA=0x00000;					// LCD IO output 0
    PORT->PB=0x00000;					// LCD IO output 0
    PORT->PC=0x00000;					// LCD IO output 0
    PORT->PD=0x00000;					// LCD IO output 0
}

/***********************************************************************************************************************
* Function Name: LCD_FunIOInit
* Description  : This function select all SEG IOs.
*                   ݾʹѡӦSEGĹ
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void LCD_FunIOInit(void)
{
		PPORGA->SEGEN0 = 0x00ff;		//SEG00~03 COM0~7 to be SEG and COM output
    PPORGA->SEGEN1 = 0x0fff;		//SEG04~15 to be SEG output
    PPORGA->SEGEN2 = 0xffff;		//SEG16~31 to be SEG output
    PPORGA->SEGEN3 = 0x03ff;		//SEG32~41 to be SEG output
}

/******************************************************************************
*****************************************
* Function Name: LCD_Init
* @brief  
* @param  bound
* @return init status
*******************************************************************************
****************************************/
void LCD_Init(void)
{
	LCD_InitTypeDef LCD_InitStructure = {0};
	
	LCD_Stop();				//رLCDʱ
	/*LCD GPIO CONFIG*/
	LCD_GPIOInit();
	LCD_FunIOInit();
  /*LCD CONFIG*/  
	LCD_InitStructure.Bias = LCD_Bias_Third;
	LCD_InitStructure.CLKSel = LCD_DIV_fSUBfIL7;
	LCD_InitStructure.LCDWave = LCD_Wave_A;
	LCD_InitStructure.VoltageVM = LCD_Init_Voltage2700MV;
	LCD_InitStructure.TimeSlice = LCD_TimeSlice4;
	LCD_InitStructure.VoltageMode = LCD_Voltage_CapDiv;
	LCD_InitStructure.VContrast = LCD_Voltage_1V;
	LCDApi_Init(&LCD_InitStructure); 
	
	/*smitt CONFIG*/
	LCD_SmitContrl(LCD_SMIT_VLxOFF,LCD_SMIT_CAPLHOFF);
	/*Graphic area CONFIG*/
	LCD_DispAreaSelect(LCD_AreaA_Select);
	/*Voltage open*/
	LCD_Voltage_On();
	/*Display ON*/
	LCD_Start();
}

