/*
 * ARM Limited (ARM) is supplying this software for use with Cortex-M
 * processor based microcontroller, but can be equally used for other
 * suitable processor architectures. This file can be freely distributed.
 * Modifications to this file shall be clearly marked.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * @file     BAT32G127.h
 * @brief    CMSIS HeaderFile
 * @version  1.0
 * @date     12. August 2022
 * @note     Generated by SVDConv V3.3.18 on Friday, 12.08.2022 14:27:34
 *           from File 'Files/SVD/BAT32G127.svd',
 *           last modified on Friday, 12.08.2022 03:59:39
 */



/** @addtogroup Cmsemicon
  * @{
  */


/** @addtogroup BAT32G127
  * @{
  */


#ifndef BAT32G127_H
#define BAT32G127_H

#ifdef __cplusplus
extern "C" {
#endif


/** @addtogroup Configuration_of_CMSIS
  * @{
  */



/* =========================================================================================================================== */
/* ================                                Interrupt Number Definition                                ================ */
/* =========================================================================================================================== */

typedef enum {
/* =======================================  ARM Cortex-M0+ Specific Interrupt Numbers  ======================================= */
  Reset_IRQn                = -15,              /*!< -15  Reset Vector, invoked on Power up and warm reset                     */
  NonMaskableInt_IRQn       = -14,              /*!< -14  Non maskable Interrupt, cannot be stopped or preempted               */
  HardFault_IRQn            = -13,              /*!< -13  Hard Fault, all classes of Fault                                     */
  SVCall_IRQn               =  -5,              /*!< -5 System Service Call via SVC instruction                                */
  PendSV_IRQn               =  -2,              /*!< -2 Pendable request for system service                                    */
  SysTick_IRQn              =  -1,              /*!< -1 System Tick Timer                                                      */
/* =========================================  BAT32G127 Specific Interrupt Numbers  ========================================== */
  LVI_IRQn                  =   0,              /*!< 0  Low Voltage detection interrupt                                        */
  INTP0_IRQn                =   1,              /*!< 1  INTP0 External interrupt request                                       */
  INTP1_IRQn                =   2,              /*!< 2  INTP1 External interrupt request                                       */
  INTP2_IRQn                =   3,              /*!< 3  INTP2 External interrupt request                                       */
  INTP3_IRQn                =   4,              /*!< 4  INTP3 External interrupt request                                       */
  INTP4_IRQn                =   5,              /*!< 5  INTP4 External interrupt request                                       */
  INTP5_IRQn                =   6,              /*!< 6  INTP5 External interrupt request                                       */
  KEY_IRQn                  =   7,              /*!< 7  KEY return interrupt request                                           */
  RTC_IRQn                  =   8,              /*!< 8  Real-Time Clock interrupt request                                      */
  IT_IRQn                   =   9,              /*!< 9  15-bit interval timer interrupt request                                */
  ST0_IRQn                  =  10,              /*!< 10 UART0 transmission transfer end or buffer empty                        */
  SPI00_IRQn                =  10,              /*!< 10 SPI00 transfer end or buffer empty                                     */
  IIC00_IRQn                =  10,              /*!< 10 IIC00 transfer end                                                     */
  SR0_IRQn                  =  11,              /*!< 11 UART0 rerception transfer                                              */
  SPI01_IRQn                =  11,              /*!< 11 SPI01 transfer end or buffer empty                                     */
  IIC01_IRQn                =  11,              /*!< 11 IIC01 transfer end                                                     */
  ST1_IRQn                  =  12,              /*!< 12 UART1 transmission transfer end or buffer empty                        */
  SPI10_IRQn                =  12,              /*!< 12 SPI10 transfer end or buffer empty                                     */
  IIC10_IRQn                =  12,              /*!< 12 IIC10 transfer end                                                     */
  SR1_IRQn                  =  13,              /*!< 13 UART1 rerception transfer                                              */
  SPI11_IRQn                =  13,              /*!< 13 SPI11 transfer end or buffer empty                                     */
  IIC11_IRQn                =  13,              /*!< 13 IIC11 transfer end                                                     */
  ST2_IRQn                  =  14,              /*!< 14 UART2 transmission transfer end or buffer empty                        */
  SPI20_IRQn                =  14,              /*!< 14 SPI20 transfer end or buffer empty                                     */
  IIC20_IRQn                =  14,              /*!< 14 IIC20 transfer end                                                     */
  SR2_IRQn                  =  15,              /*!< 15 UART2 rerception transfer                                              */
  SPI21_IRQn                =  15,              /*!< 15 SPI21 transfer end or buffer empty                                     */
  IIC21_IRQn                =  15,              /*!< 15 IIC21 transfer end                                                     */
  IICA_IRQn                 =  16,              /*!< 16 IICA0 interrupt request                                                */
  SPI_IRQn                  =  17,              /*!< 17 SPIHS0 interrupt request                                               */
  TM00_IRQn                 =  18,              /*!< 18 TM81 channel 0 interrupt request                                       */
  TM01_IRQn                 =  19,              /*!< 19 TM81 channel 1 interrupt request                                       */
  TM02_IRQn                 =  20,              /*!< 20 TM81 channel 2 interrupt request                                       */
  TM03_IRQn                 =  21,              /*!< 21 TM81 channel 3 interrupt request                                       */
  TM04_IRQn                 =  22,              /*!< 22 TM81 channel 4 interrupt request                                       */
  TM05_IRQn                 =  23,              /*!< 23 TM81 channel 5 interrupt request                                       */
  TM06_IRQn                 =  24,              /*!< 24 TM81 channel 6 interrupt request                                       */
  TM07_IRQn                 =  25,              /*!< 25 TM81 channel 7 interrupt request                                       */
  TMA0_IRQn                 =  26,              /*!< 26 TimerA underflow                                                       */
  ADC_IRQn                  =  27,              /*!< 27 ADC interrupt request                                                  */
  CMP0_IRQn                 =  28,              /*!< 28 CMP0 interrupt request                                                 */
  CMP1_IRQn                 =  29,              /*!< 29 CMP1 interrupt request                                                 */
  OSDC_IRQn                 =  30,              /*!< 30 Oscillator stop detection                                              */
  FMC_IRQn                  =  31               /*!< 31 Flash programming finish                                               */
} IRQn_Type;



/* =========================================================================================================================== */
/* ================                           Processor and Core Peripheral Section                           ================ */
/* =========================================================================================================================== */

/* ==========================  Configuration of the ARM Cortex-M0+ Processor and Core Peripherals  =========================== */
#define __CM0PLUS_REV                 0x0001U   /*!< CM0PLUS Core Revision                                                     */
#define __NVIC_PRIO_BITS               2        /*!< Number of Bits used for Priority Levels                                   */
#define __Vendor_SysTickConfig         0        /*!< Set to 1 if different SysTick Config is used                              */
#define __VTOR_PRESENT                 1        /*!< Set to 1 if CPU supports Vector Table Offset Register                     */


/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm0plus.h"                       /*!< ARM Cortex-M0+ processor and core peripherals                             */
#include "system_BAT32G127.h"                   /*!< BAT32G127 System                                                          */

#ifndef __IM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __IM   __I
#endif
#ifndef __OM                                    /*!< Fallback for older CMSIS versions                                         */
  #define __OM   __O
#endif
#ifndef __IOM                                   /*!< Fallback for older CMSIS versions                                         */
  #define __IOM  __IO
#endif


/* ========================================  Start of section using anonymous unions  ======================================== */
#if defined (__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined (__ICCARM__)
  #pragma language=extended
#elif defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic push
  #pragma clang diagnostic ignored "-Wc11-extensions"
  #pragma clang diagnostic ignored "-Wreserved-id-macro"
  #pragma clang diagnostic ignored "-Wgnu-anonymous-struct"
  #pragma clang diagnostic ignored "-Wnested-anon-types"
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning 586
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#else
  #warning Not supported compiler type
#endif


/* =========================================================================================================================== */
/* ================                              Device Specific Cluster Section                              ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_clusters
  * @{
  */


/**
  * @brief DMAVEC_CTRL [CTRL] (DMA control data area)
  */
typedef struct {
  __IOM uint16_t  DMACR;                        /*!< (@ 0x00000000) DMA Control register                                       */
  __IOM uint16_t  DMBLS;                        /*!< (@ 0x00000002) DMA Block Size register                                    */
  __IOM uint16_t  DMACT;                        /*!< (@ 0x00000004) DMA Transfer Count register                                */
  __IOM uint16_t  DMRLD;                        /*!< (@ 0x00000006) DMA Transfer Count Reload register                         */
  __IOM uint32_t  DMSAR;                        /*!< (@ 0x00000008) DMA Source Address register                                */
  __IOM uint32_t  DMDAR;                        /*!< (@ 0x0000000C) DMA Destination Address register                           */
} DMAVEC_CTRL_Type;                             /*!< Size = 16 (0x10)                                                          */


/**
  * @brief INT_IF [IF] (Interrupt flag register)
  */
typedef struct {
  __IOM uint8_t   IFL;                          /*!< (@ 0x00000000) Interrupt flag register                                    */
  __IM  uint8_t   RESERVED[3];
} INT_IF_Type;                                  /*!< Size = 4 (0x4)                                                            */


/**
  * @brief INT_MK [MK] (Interrupt mask register)
  */
typedef struct {
  __IOM uint8_t   MKL;                          /*!< (@ 0x00000000) Interrupt mask register                                    */
  __IM  uint8_t   RESERVED[3];
} INT_MK_Type;                                  /*!< Size = 4 (0x4)                                                            */


/** @} */ /* End of group Device_Peripheral_clusters */


/* =========================================================================================================================== */
/* ================                            Device Specific Peripheral Section                             ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                            CGC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock Generate Control (CGC)
  */

typedef struct {                                /*!< (@ 0x40020400) CGC Structure                                              */
  __IOM uint8_t   CMC;                          /*!< (@ 0x00000000) Clock operaton Mode Control Register                       */
  __IOM uint8_t   CSC;                          /*!< (@ 0x00000001) Clock operation Status Register                            */
  __IM  uint8_t   OSTC;                         /*!< (@ 0x00000002) Oscillation stabilization time counter status              */
  __IOM uint8_t   OSTS;                         /*!< (@ 0x00000003) Oscillation stabilization time select register             */
  __IOM uint8_t   CKC;                          /*!< (@ 0x00000004) System clock control register                              */
  __IM  uint8_t   RESERVED[2];
  __IOM uint8_t   SUBCKSEL;                     /*!< (@ 0x00000007) Subsystem Clock select register                            */
  __IM  uint8_t   RESERVED1[4];
  __IOM uint8_t   RSTM;                         /*!< (@ 0x0000000C) External reset port mask register                          */
  __IM  uint8_t   RESERVED2[19];
  __IOM uint8_t   PER0;                         /*!< (@ 0x00000020) Peripheral enable register 0                               */
  __IM  uint8_t   RESERVED3[2];
  __IOM uint8_t   OSMC;                         /*!< (@ 0x00000023) Subsystem clock supply mode control register               */
  __IM  uint8_t   RESERVED4[1014];
  __IOM uint8_t   PER1;                         /*!< (@ 0x0000041A) Peripheral enable register 1                               */
  __IM  uint8_t   RESERVED5[5093];
  __IOM uint8_t   HIOTRM;                       /*!< (@ 0x00001800) High-speed on-chip oscillator trimming register            */
  __IM  uint8_t   RESERVED6[31];
  __IOM uint8_t   HOCODIV;                      /*!< (@ 0x00001820) High-speed on-chip oscillator frequency select
                                                                    register                                                   */
} CGC_Type;                                     /*!< Size = 6177 (0x1821)                                                      */



/* =========================================================================================================================== */
/* ================                                            RST                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Reset Function (RST)
  */

typedef struct {                                /*!< (@ 0x40020420) RST Structure                                              */
  __IM  uint8_t   RESERVED[32];
  __IM  uint8_t   RESF;                         /*!< (@ 0x00000020) Reset flag register                                        */
} RST_Type;                                     /*!< Size = 33 (0x21)                                                          */



/* =========================================================================================================================== */
/* ================                                            LVD                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Voltage detector (LVD)
  */

typedef struct {                                /*!< (@ 0x40020440) LVD Structure                                              */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   LVIM;                         /*!< (@ 0x00000001) Voltage detection register                                 */
  __IOM uint8_t   LVIS;                         /*!< (@ 0x00000002) Voltage detection level register                           */
} LVD_Type;                                     /*!< Size = 3 (0x3)                                                            */



/* =========================================================================================================================== */
/* ================                                           PORT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Port functions (PORT)
  */

typedef struct {                                /*!< (@ 0x40040000) PORT Structure                                             */
  __IOM uint16_t  PA;                           /*!< (@ 0x00000000) Port register A                                            */
  __IOM uint16_t  PB;                           /*!< (@ 0x00000002) Port register B                                            */
  __IOM uint16_t  PC;                           /*!< (@ 0x00000004) Port register C                                            */
  __IOM uint16_t  PD;                           /*!< (@ 0x00000006) Port register D                                            */
  __IM  uint16_t  RESERVED[3];
  __IOM uint16_t  PH;                           /*!< (@ 0x0000000E) Port register H                                            */
  __IOM uint16_t  PMA;                          /*!< (@ 0x00000010) Port mode register A                                       */
  __IOM uint16_t  PMB;                          /*!< (@ 0x00000012) Port mode register B                                       */
  __IOM uint16_t  PMC;                          /*!< (@ 0x00000014) Port mode register C                                       */
  __IOM uint16_t  PMD;                          /*!< (@ 0x00000016) Port mode register D                                       */
  __IM  uint16_t  RESERVED1[3];
  __IOM uint16_t  PMH;                          /*!< (@ 0x0000001E) Port mode register H                                       */
  __IOM uint16_t  PUA;                          /*!< (@ 0x00000020) Pull-up resistor option register A                         */
  __IOM uint16_t  PUB;                          /*!< (@ 0x00000022) Pull-up resistor option register B                         */
  __IOM uint16_t  PUC;                          /*!< (@ 0x00000024) Pull-up resistor option register C                         */
  __IOM uint16_t  PUD;                          /*!< (@ 0x00000026) Pull-up resistor option register D                         */
  __IM  uint16_t  RESERVED2[3];
  __IOM uint16_t  PUH;                          /*!< (@ 0x0000002E) Pull-up resistor option register H                         */
  __IOM uint16_t  PDA;                          /*!< (@ 0x00000030) Pull-down resistor option register A                       */
  __IOM uint16_t  PDB;                          /*!< (@ 0x00000032) Pull-down resistor option register B                       */
  __IOM uint16_t  PDC;                          /*!< (@ 0x00000034) Pull-down resistor option register C                       */
  __IOM uint16_t  PDD;                          /*!< (@ 0x00000036) Pull-down resistor option register D                       */
  __IM  uint16_t  RESERVED3[3];
  __IOM uint16_t  PDH;                          /*!< (@ 0x0000003E) Pull-down resistor option register H                       */
  __IOM uint16_t  POMA;                         /*!< (@ 0x00000040) Port output mode register A                                */
  __IOM uint16_t  POMB;                         /*!< (@ 0x00000042) Port output mode register B                                */
  __IOM uint16_t  POMC;                         /*!< (@ 0x00000044) Port output mode register C                                */
  __IOM uint16_t  POMD;                         /*!< (@ 0x00000046) Port output mode register D                                */
  __IM  uint16_t  RESERVED4[3];
  __IOM uint16_t  POMH;                         /*!< (@ 0x0000004E) Port output mode register H                                */
  __IOM uint16_t  PMCA;                         /*!< (@ 0x00000050) Port mode control register A                               */
  __IOM uint16_t  PMCB;                         /*!< (@ 0x00000052) Port mode control register B                               */
  __IOM uint16_t  PMCC;                         /*!< (@ 0x00000054) Port mode control register C                               */
  __IOM uint16_t  PMCD;                         /*!< (@ 0x00000056) Port mode control register D                               */
  __IM  uint16_t  RESERVED5[4];
  __IOM uint16_t  PSETA;                        /*!< (@ 0x00000060) Port set register A                                        */
  __IOM uint16_t  PSETB;                        /*!< (@ 0x00000062) Port set register B                                        */
  __IOM uint16_t  PSETC;                        /*!< (@ 0x00000064) Port set register C                                        */
  __IOM uint16_t  PSETD;                        /*!< (@ 0x00000066) Port set register D                                        */
  __IM  uint16_t  RESERVED6[3];
  __IOM uint16_t  PSETH;                        /*!< (@ 0x0000006E) Port set register H                                        */
  __IOM uint16_t  PCLRA;                        /*!< (@ 0x00000070) Port clear register A                                      */
  __IOM uint16_t  PCLRB;                        /*!< (@ 0x00000072) Port clear register B                                      */
  __IOM uint16_t  PCLRC;                        /*!< (@ 0x00000074) Port clear register C                                      */
  __IOM uint16_t  PCLRD;                        /*!< (@ 0x00000076) Port clear register D                                      */
  __IM  uint16_t  RESERVED7[3];
  __IOM uint16_t  PCLRH;                        /*!< (@ 0x0000007E) Port clear register H                                      */
  __IM  uint16_t  PREADA;                       /*!< (@ 0x00000080) Port read register A                                       */
  __IM  uint16_t  PREADB;                       /*!< (@ 0x00000082) Port read register B                                       */
  __IM  uint16_t  PREADC;                       /*!< (@ 0x00000084) Port read register C                                       */
  __IM  uint16_t  PREADD;                       /*!< (@ 0x00000086) Port read register D                                       */
  __IM  uint16_t  RESERVED8[3];
  __IM  uint16_t  PREADH;                       /*!< (@ 0x0000008E) Port read register H                                       */
  __IM  uint16_t  RESERVED9[440];
  __IOM uint8_t   PA00CFG;                      /*!< (@ 0x00000400) Port multiplexing function configuration                   */
  __IOM uint8_t   PA01CFG;                      /*!< (@ 0x00000401) Port multiplexing function configuration                   */
  __IOM uint8_t   PA02CFG;                      /*!< (@ 0x00000402) Port multiplexing function configuration                   */
  __IOM uint8_t   PA03CFG;                      /*!< (@ 0x00000403) Port multiplexing function configuration                   */
  __IOM uint8_t   PA04CFG;                      /*!< (@ 0x00000404) Port multiplexing function configuration                   */
  __IOM uint8_t   PA05CFG;                      /*!< (@ 0x00000405) Port multiplexing function configuration                   */
  __IOM uint8_t   PA06CFG;                      /*!< (@ 0x00000406) Port multiplexing function configuration                   */
  __IOM uint8_t   PA07CFG;                      /*!< (@ 0x00000407) Port multiplexing function configuration                   */
  __IOM uint8_t   PA08CFG;                      /*!< (@ 0x00000408) Port multiplexing function configuration                   */
  __IOM uint8_t   PA09CFG;                      /*!< (@ 0x00000409) Port multiplexing function configuration                   */
  __IOM uint8_t   PA10CFG;                      /*!< (@ 0x0000040A) Port multiplexing function configuration                   */
  __IOM uint8_t   PA11CFG;                      /*!< (@ 0x0000040B) Port multiplexing function configuration                   */
  __IOM uint8_t   PA12CFG;                      /*!< (@ 0x0000040C) Port multiplexing function configuration                   */
  __IOM uint8_t   PA13CFG;                      /*!< (@ 0x0000040D) Port multiplexing function configuration                   */
  __IOM uint8_t   PA14CFG;                      /*!< (@ 0x0000040E) Port multiplexing function configuration                   */
  __IOM uint8_t   PA15CFG;                      /*!< (@ 0x0000040F) Port multiplexing function configuration                   */
  __IOM uint8_t   PB00CFG;                      /*!< (@ 0x00000410) Port multiplexing function configuration                   */
  __IOM uint8_t   PB01CFG;                      /*!< (@ 0x00000411) Port multiplexing function configuration                   */
  __IOM uint8_t   PB02CFG;                      /*!< (@ 0x00000412) Port multiplexing function configuration                   */
  __IOM uint8_t   PB03CFG;                      /*!< (@ 0x00000413) Port multiplexing function configuration                   */
  __IOM uint8_t   PB04CFG;                      /*!< (@ 0x00000414) Port multiplexing function configuration                   */
  __IOM uint8_t   PB05CFG;                      /*!< (@ 0x00000415) Port multiplexing function configuration                   */
  __IOM uint8_t   PB06CFG;                      /*!< (@ 0x00000416) Port multiplexing function configuration                   */
  __IOM uint8_t   PB07CFG;                      /*!< (@ 0x00000417) Port multiplexing function configuration                   */
  __IOM uint8_t   PB08CFG;                      /*!< (@ 0x00000418) Port multiplexing function configuration                   */
  __IOM uint8_t   PB09CFG;                      /*!< (@ 0x00000419) Port multiplexing function configuration                   */
  __IOM uint8_t   PB10CFG;                      /*!< (@ 0x0000041A) Port multiplexing function configuration                   */
  __IOM uint8_t   PB11CFG;                      /*!< (@ 0x0000041B) Port multiplexing function configuration                   */
  __IOM uint8_t   PB12CFG;                      /*!< (@ 0x0000041C) Port multiplexing function configuration                   */
  __IOM uint8_t   PB13CFG;                      /*!< (@ 0x0000041D) Port multiplexing function configuration                   */
  __IOM uint8_t   PB14CFG;                      /*!< (@ 0x0000041E) Port multiplexing function configuration                   */
  __IOM uint8_t   PB15CFG;                      /*!< (@ 0x0000041F) Port multiplexing function configuration                   */
  __IOM uint8_t   PC00CFG;                      /*!< (@ 0x00000420) Port multiplexing function configuration                   */
  __IOM uint8_t   PC01CFG;                      /*!< (@ 0x00000421) Port multiplexing function configuration                   */
  __IOM uint8_t   PC02CFG;                      /*!< (@ 0x00000422) Port multiplexing function configuration                   */
  __IOM uint8_t   PC03CFG;                      /*!< (@ 0x00000423) Port multiplexing function configuration                   */
  __IOM uint8_t   PC04CFG;                      /*!< (@ 0x00000424) Port multiplexing function configuration                   */
  __IOM uint8_t   PC05CFG;                      /*!< (@ 0x00000425) Port multiplexing function configuration                   */
  __IOM uint8_t   PC06CFG;                      /*!< (@ 0x00000426) Port multiplexing function configuration                   */
  __IOM uint8_t   PC07CFG;                      /*!< (@ 0x00000427) Port multiplexing function configuration                   */
  __IOM uint8_t   PC08CFG;                      /*!< (@ 0x00000428) Port multiplexing function configuration                   */
  __IOM uint8_t   PC09CFG;                      /*!< (@ 0x00000429) Port multiplexing function configuration                   */
  __IOM uint8_t   PC10CFG;                      /*!< (@ 0x0000042A) Port multiplexing function configuration                   */
  __IOM uint8_t   PC11CFG;                      /*!< (@ 0x0000042B) Port multiplexing function configuration                   */
  __IOM uint8_t   PC12CFG;                      /*!< (@ 0x0000042C) Port multiplexing function configuration                   */
  __IOM uint8_t   PC13CFG;                      /*!< (@ 0x0000042D) Port multiplexing function configuration                   */
  __IOM uint8_t   PC14CFG;                      /*!< (@ 0x0000042E) Port multiplexing function configuration                   */
	__IM  uint8_t  RESERVED13[1];
//  __IOM uint8_t   PC15CFG;                      /*!< (@ 0x0000042F) Port multiplexing function configuration                   */
  __IOM uint8_t   PD00CFG;                      /*!< (@ 0x00000430) Port multiplexing function configuration                   */
  __IOM uint8_t   PD01CFG;                      /*!< (@ 0x00000431) Port multiplexing function configuration                   */
  __IOM uint8_t   PD02CFG;                      /*!< (@ 0x00000432) Port multiplexing function configuration                   */
  __IOM uint8_t   PD03CFG;                      /*!< (@ 0x00000433) Port multiplexing function configuration                   */
  __IOM uint8_t   PD04CFG;                      /*!< (@ 0x00000434) Port multiplexing function configuration                   */
  __IOM uint8_t   PD05CFG;                      /*!< (@ 0x00000435) Port multiplexing function configuration                   */
  __IOM uint8_t   PD06CFG;                      /*!< (@ 0x00000436) Port multiplexing function configuration                   */
  __IOM uint8_t   PD07CFG;                      /*!< (@ 0x00000437) Port multiplexing function configuration                   */
  __IOM uint8_t   PD08CFG;                      /*!< (@ 0x00000438) Port multiplexing function configuration                   */
  __IOM uint8_t   PD09CFG;                      /*!< (@ 0x00000439) Port multiplexing function configuration                   */
//  __IOM uint8_t   PD10CFG;                      /*!< (@ 0x0000043A) Port multiplexing function configuration                   */
//  __IOM uint8_t   PD11CFG;                      /*!< (@ 0x0000043B) Port multiplexing function configuration                   */
//  __IOM uint8_t   PD12CFG;                      /*!< (@ 0x0000043C) Port multiplexing function configuration                   */
//  __IOM uint8_t   PD13CFG;                      /*!< (@ 0x0000043D) Port multiplexing function configuration                   */
//  __IOM uint8_t   PD14CFG;                      /*!< (@ 0x0000043E) Port multiplexing function configuration                   */
//  __IOM uint8_t   PD15CFG;                      /*!< (@ 0x0000043F) Port multiplexing function configuration                   */
  __IM  uint16_t  RESERVED10[38];
  __IOM uint8_t   PH00CFG;                      /*!< (@ 0x00000480) Port multiplexing function configuration                   */
  __IOM uint8_t   PH01CFG;                      /*!< (@ 0x00000481) Port multiplexing function configuration                   */
  __IOM uint8_t   PH02CFG;                      /*!< (@ 0x00000482) Port multiplexing function configuration                   */
  __IOM uint8_t   PH03CFG;                      /*!< (@ 0x00000483) Port multiplexing function configuration                   */
  __IOM uint8_t   PH04CFG;                      /*!< (@ 0x00000484) Port multiplexing function configuration                   */
  __IM  uint8_t   RESERVED11;
  __IM  uint16_t  RESERVED12[45];
  __IOM uint8_t   INTP0PCFG;                    /*!< (@ 0x000004E0) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP1PCFG;                    /*!< (@ 0x000004E1) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP2PCFG;                    /*!< (@ 0x000004E2) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP3PCFG;                    /*!< (@ 0x000004E3) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP4PCFG;                    /*!< (@ 0x000004E4) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP5PCFG;                    /*!< (@ 0x000004E5) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP6PCFG;                    /*!< (@ 0x000004E6) Alternate INTP pin configuration register                  */
  __IOM uint8_t   INTP7PCFG;                    /*!< (@ 0x000004E7) Alternate INTP pin configuration register                  */
} PORT_Type;                                    /*!< Size = 1256 (0x4e8)                                                       */



/* =========================================================================================================================== */
/* ================                                            TM8                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief General Purpose Timer 8 (TM8)
  */

typedef struct {                                /*!< (@ 0x40043000) TM8 Structure                                              */
  __IM  uint16_t  TCR00;                        /*!< (@ 0x00000000) Timer count register 00                                    */
  __IM  uint16_t  TCR01;                        /*!< (@ 0x00000002) Timer count register 01                                    */
  __IM  uint16_t  TCR02;                        /*!< (@ 0x00000004) Timer count register 02                                    */
  __IM  uint16_t  TCR03;                        /*!< (@ 0x00000006) Timer count register 03                                    */
  __IM  uint16_t  TCR04;                        /*!< (@ 0x00000008) Timer count register 04                                    */
  __IM  uint16_t  TCR05;                        /*!< (@ 0x0000000A) Timer count register 05                                    */
  __IM  uint16_t  TCR06;                        /*!< (@ 0x0000000C) Timer count register 06                                    */
  __IM  uint16_t  TCR07;                        /*!< (@ 0x0000000E) Timer count register 07                                    */
  __IOM uint16_t  TMR00;                        /*!< (@ 0x00000010) Timer mode register mn                                     */
  __IOM uint16_t  TMR01;                        /*!< (@ 0x00000012) Timer mode register mn                                     */
  __IOM uint16_t  TMR02;                        /*!< (@ 0x00000014) Timer mode register mn                                     */
  __IOM uint16_t  TMR03;                        /*!< (@ 0x00000016) Timer mode register mn                                     */
  __IOM uint16_t  TMR04;                        /*!< (@ 0x00000018) Timer mode register mn                                     */
  __IOM uint16_t  TMR05;                        /*!< (@ 0x0000001A) Timer mode register mn                                     */
  __IOM uint16_t  TMR06;                        /*!< (@ 0x0000001C) Timer mode register mn                                     */
  __IOM uint16_t  TMR07;                        /*!< (@ 0x0000001E) Timer mode register mn                                     */
  __IM  uint16_t  TSR00;                        /*!< (@ 0x00000020) Timer status register mn                                   */
  __IM  uint16_t  TSR01;                        /*!< (@ 0x00000022) Timer status register mn                                   */
  __IM  uint16_t  TSR02;                        /*!< (@ 0x00000024) Timer status register mn                                   */
  __IM  uint16_t  TSR03;                        /*!< (@ 0x00000026) Timer status register mn                                   */
  __IM  uint16_t  TSR04;                        /*!< (@ 0x00000028) Timer status register mn                                   */
  __IM  uint16_t  TSR05;                        /*!< (@ 0x0000002A) Timer status register mn                                   */
  __IM  uint16_t  TSR06;                        /*!< (@ 0x0000002C) Timer status register mn                                   */
  __IM  uint16_t  TSR07;                        /*!< (@ 0x0000002E) Timer status register mn                                   */
  __IM  uint16_t  TE0;                          /*!< (@ 0x00000030) Timer channel enable status register m                     */
  __IOM uint16_t  TS0;                          /*!< (@ 0x00000032) Timer channel start register 0                             */
  __IOM uint16_t  TT0;                          /*!< (@ 0x00000034) Timer channel stop register 0                              */
  __IOM uint16_t  TPS0;                         /*!< (@ 0x00000036) Timer clock select register 0                              */
  __IOM uint16_t  TO0;                          /*!< (@ 0x00000038) Timer output register 0                                    */
  __IOM uint16_t  TOE0;                         /*!< (@ 0x0000003A) Timer output enable register 0                             */
  __IOM uint16_t  TOL0;                         /*!< (@ 0x0000003C) Timer output level register 0                              */
  __IOM uint16_t  TOM0;                         /*!< (@ 0x0000003E) Timer output mode register 0                               */
  __IOM uint16_t  TDR00;                        /*!< (@ 0x00000040) Timer data register 00                                     */
  __IOM uint16_t  TDR01;                        /*!< (@ 0x00000042) Timer data register 01                                     */
  __IOM uint16_t  TDR02;                        /*!< (@ 0x00000044) Timer data register 02                                     */
  __IOM uint16_t  TDR03;                        /*!< (@ 0x00000046) Timer data register 03                                     */
  __IOM uint16_t  TDR04;                        /*!< (@ 0x00000048) Timer data register 04                                     */
  __IOM uint16_t  TDR05;                        /*!< (@ 0x0000004A) Timer data register 05                                     */
  __IOM uint16_t  TDR06;                        /*!< (@ 0x0000004C) Timer data register 06                                     */
  __IOM uint16_t  TDR07;                        /*!< (@ 0x0000004E) Timer data register 07                                     */
} TM8_Type;                                     /*!< Size = 80 (0x50)                                                          */



/* =========================================================================================================================== */
/* ================                                            TMA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief timer A (TMA)
  */

typedef struct {                                /*!< (@ 0x40044000) TMA Structure                                              */
  __IOM uint8_t   TACR0;                        /*!< (@ 0x00000000) Timer A control register 0                                 */
  __IOM uint8_t   TAIOC0;                       /*!< (@ 0x00000001) Timer A I/O control register 0                             */
  __IOM uint8_t   TAMR0;                        /*!< (@ 0x00000002) Timer A mode control register 0                            */
  __IOM uint8_t   TAISR0;                       /*!< (@ 0x00000003) Timer A event pin selection register 0                     */
  __IOM uint16_t  TA0;                          /*!< (@ 0x00000004) Timer A count register 0                                   */
} TMA_Type;                                     /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                            RTC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Real-Time clock (RTC)
  */

typedef struct {                                /*!< (@ 0x40042400) RTC Structure                                              */
  __IOM uint16_t  ITMC;                         /*!< (@ 0x00000000) 15-bit interval timer control register                     */
  __IOM uint8_t   SEC;                          /*!< (@ 0x00000002) Second count register                                      */
  __IOM uint8_t   MIN;                          /*!< (@ 0x00000003) Minute count register                                      */
  __IOM uint8_t   HOUR;                         /*!< (@ 0x00000004) Hour count register                                        */
  __IOM uint8_t   WEEK;                         /*!< (@ 0x00000005) Week count register                                        */
  __IOM uint8_t   DAY;                          /*!< (@ 0x00000006) Day count register                                         */
  __IOM uint8_t   MONTH;                        /*!< (@ 0x00000007) Month count register                                       */
  __IOM uint8_t   YEAR;                         /*!< (@ 0x00000008) Year count register                                        */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   ALARMWM;                      /*!< (@ 0x0000000A) Alarm minute register                                      */
  __IOM uint8_t   ALARMWH;                      /*!< (@ 0x0000000B) Alarm hour register                                        */
  __IOM uint8_t   ALARMWW;                      /*!< (@ 0x0000000C) Alarm week register                                        */
  __IOM uint8_t   RTCC0;                        /*!< (@ 0x0000000D) Real-time clock control register 0                         */
  __IOM uint8_t   RTCC1;                        /*!< (@ 0x0000000E) Real-time clock control register 1                         */
  __IM  uint8_t   RESERVED1;
  __IM  uint16_t  RESERVED2[2];
  __IOM uint16_t  SUBCUD;                       /*!< (@ 0x00000014) Watch error correction register                            */
} RTC_Type;                                     /*!< Size = 22 (0x16)                                                          */



/* =========================================================================================================================== */
/* ================                                           PCBZ                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Clock/Buzzer output controller (PCBZ)
  */

typedef struct {                                /*!< (@ 0x40041000) PCBZ Structure                                             */
  __IOM uint8_t   CKS1;                         /*!< (@ 0x00000000) Clock output select registers 1                            */
  __IOM uint8_t   CKS0;                         /*!< (@ 0x00000001) Clock output select registers 0                            */
} PCBZ_Type;                                    /*!< Size = 2 (0x2)                                                            */



/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Watchdog Timer with window (WDT)
  */

typedef struct {                                /*!< (@ 0x40020404) WDT Structure                                              */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   LOCKCTL;                      /*!< (@ 0x00000001) Lockup Watchdog timer enable register                      */
  __IOM uint8_t   PRCR;                         /*!< (@ 0x00000002) Lockup Watchdog timer enable protect register              */
  __IM  uint8_t   RESERVED1;
  __IOM uint8_t   WDTCFG0;                      /*!< (@ 0x00000004) WDTCFG0 configuration register                             */
  __IOM uint8_t   WDTCFG1;                      /*!< (@ 0x00000005) WDTCFG1 configuration register                             */
  __IOM uint8_t   WDTCFG2;                      /*!< (@ 0x00000006) WDTCFG2 configuration register                             */
  __IOM uint8_t   WDTCFG3;                      /*!< (@ 0x00000007) WDTCFG3 configuration register                             */
  __IM  uint8_t   RESERVED2[3061];
  __IOM uint8_t   WDTE;                         /*!< (@ 0x00000BFD) Watchdog timer enable register                             */
} WDT_Type;                                     /*!< Size = 3070 (0xbfe)                                                       */



/* =========================================================================================================================== */
/* ================                                            ADC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief A/D Converter (ADC)
  */

typedef struct {                                /*!< (@ 0x40045000) ADC Structure                                              */
  __IOM uint8_t   ADM0;                         /*!< (@ 0x00000000) A/D mode register 0                                        */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   ADM1;                         /*!< (@ 0x00000002) A/D mode register 1                                        */
  __IM  uint8_t   RESERVED1;
  __IOM uint8_t   ADM2;                         /*!< (@ 0x00000004) A/D mode register 2                                        */
  __IM  uint8_t   RESERVED2;
  __IOM uint8_t   ADTRG;                        /*!< (@ 0x00000006) A/D mode register 2                                        */
  __IM  uint8_t   RESERVED3;
  __IOM uint8_t   ADS;                          /*!< (@ 0x00000008) Analog input channel specification register                */
  __IM  uint8_t   RESERVED4;
  __IOM uint8_t   ADLL;                         /*!< (@ 0x0000000A) Conversion result comparison lower limit setting
                                                                    register                                                   */
  __IOM uint8_t   ADUL;                         /*!< (@ 0x0000000B) Conversion result comparison upper limit setting
                                                                    register                                                   */
  __IOM uint8_t   ADNSMP;                       /*!< (@ 0x0000000C) A/D sampling time control register                         */
  __IM  uint8_t   RESERVED5;
  
  union {
    __IM  uint16_t ADCR;                        /*!< (@ 0x0000000E) 12-bit A/D conversion result register                      */
    
    struct {
      __IM  uint8_t RESERVED6;
      __IM  uint8_t ADCRH;                      /*!< (@ 0x0000000F) Higher 8-bit A/D conversion result register                */
    };
  };
  __IOM uint8_t   ADTES;                        /*!< (@ 0x00000010) A/D test register                                          */
  __IOM uint8_t   ADNDIS;                       /*!< (@ 0x00000011) A/D charge/discharge control register                      */
  __IM  uint16_t  RESERVED7;
  __IM  uint8_t   RESERVED8;
  __IOM uint8_t   ADSMPWAIT;                    /*!< (@ 0x00000015) A/D sampling wait control register                         */
} ADC_Type;                                     /*!< Size = 22 (0x16)                                                          */



/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Programmable Gain Amplifier (DAC)
  */

typedef struct {                                /*!< (@ 0x40045400) DAC Structure                                              */
  __IOM uint8_t   DACS0;                        /*!< (@ 0x00000000) D/A conversion value setting register 0                    */
  __IOM uint8_t   RESERVED;
  __IOM uint8_t   DAM;                          /*!< (@ 0x00000002) Mode register of D/A converter                             */
} DAC_Type;                                     /*!< Size = 3 (0x3)                                                            */



/* =========================================================================================================================== */
/* ================                                            CMP                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Comparator (CMP)
  */

typedef struct {                                /*!< (@ 0x40045800) CMP Structure                                              */
  __IOM uint8_t   COMPMDR;                      /*!< (@ 0x00000000) Comparator mode setting register                           */
  __IOM uint8_t   COMPFIR;                      /*!< (@ 0x00000001) Comparator filter control register                         */
  __IOM uint8_t   COMPOCR;                      /*!< (@ 0x00000002) Comparator output control register                         */
  __IM  uint8_t   RESERVED[5];
  __IOM uint8_t   C0REFS;                       /*!< (@ 0x00000008) Negative end reference selection register of
                                                                    comparator 0                                               */
  __IOM uint8_t   C1REFS;                       /*!< (@ 0x00000009) Negative end reference selection register of
                                                                    comparator 1                                               */
  __IOM uint8_t   CMPSEL0;                      /*!< (@ 0x0000000A) Comparator 0 input signal selection control register       */
  __IOM uint8_t   CMPSEL1;                      /*!< (@ 0x0000000B) Comparator 1 input signal selection control register       */
  __IM  uint8_t   RESERVED1[2];
  __IOM uint8_t   CMP0HY;                       /*!< (@ 0x0000000E) Comparator 0 input voltage hysteresis control
                                                                    register                                                   */
  __IOM uint8_t   CMP1HY;                       /*!< (@ 0x0000000F) Comparator 1 input voltage hysteresis control
                                                                    register                                                   */
} CMP_Type;                                     /*!< Size = 16 (0x10)                                                          */



/* =========================================================================================================================== */
/* ================                                            OPA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Operational amplifier (OPA)
  */

typedef struct {                                /*!< (@ 0x40045C00) OPA Structure                                              */
  __IOM uint8_t   OPACTL;                       /*!< (@ 0x00000000) Operational amplifier control register                     */
  __IM  uint8_t   RESERVED[3];
  __IOM uint8_t   OPADAC;                       /*!< (@ 0x00000004) Operational amplifier digital analog control
                                                                    register                                                   */
} OPA_Type;                                     /*!< Size = 5 (0x5)                                                            */



/* =========================================================================================================================== */
/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 0 with UART, SPI and simplified I2C supported (SCI0)
  */

typedef struct {                                /*!< (@ 0x40046000) SCI0 Structure                                             */
  __IM  uint16_t  SSR00;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR01;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR00;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR01;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR00;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR01;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR00;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR01;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE0;                          /*!< (@ 0x00000010) Serial channel enable status register m                    */
  __IOM uint16_t  SS0;                          /*!< (@ 0x00000012) Serial channel start register 0                            */
  __IOM uint16_t  ST0;                          /*!< (@ 0x00000014) Serial channel stop register 0                             */
  __IOM uint16_t  SPS0;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO0;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE0;                         /*!< (@ 0x0000001A) Serial output enable register 0                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL0;                         /*!< (@ 0x00000020) Serial output level register 0                             */
  __IOM uint16_t  SSE0;                         /*!< (@ 0x00000022) Slave selection function enable register 0                 */
  __IOM uint16_t  SSC0;                         /*!< (@ 0x00000024) Serial standby control register 0                          */
  __IM  uint16_t  RESERVED1[13];
  
  union {
    __IOM uint16_t SDR00;                       /*!< (@ 0x00000040) Serial data register 00                                    */
    __IOM uint8_t SIO00;                        /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint8_t TXD0;                         /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR01;                       /*!< (@ 0x00000042) Serial data register 01                                    */
    __IOM uint8_t SIO01;                        /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint8_t RXD0;                         /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI0_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


typedef struct {
	__IM  uint16_t  TSSR;						/*!< */
	__IM  uint16_t  RSSR;						/*!< */
	__IOM uint16_t  TSIR;						/*!< */
	__IOM uint16_t  RSIR;						/*!< */	
	__IOM uint16_t  TSMR;						/*!< */
	__IOM uint16_t  RSMR;						/*!< */
	__IOM uint16_t  TSCR;						/*!< */
	__IOM uint16_t  RSCR;						/*!< */	
	__IM  uint16_t  SE :  2;					/*!< */
	__IM  uint16_t     : 14;
	
	__IOM uint16_t  SS :  2;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t  ST :  2;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     : 12;

	__IOM uint16_t     :  2;
	__IOM uint16_t  SO :  2;					/*!< */
	__IOM uint16_t	   : 12;	
//	__IOM uint16_t  SO;							/*!< */

	__IOM uint16_t  SOE:  2;					/*!< */
	__IOM uint16_t	   : 14;
//	__IOM uint16_t  SOE;						/*!< */
	__IM  uint16_t  RESERVED5[2];
	__IOM uint16_t  SOL;						/*!< */
	__IOM uint16_t  SSE;                         /*!<                 */
  __IOM uint16_t  SSC;                         /*!<                   */
	__IM  uint16_t  RESERVED6[13];

	__IOM uint16_t TXD : 9;
	__IOM uint16_t TSDR: 7;
	__IOM uint16_t RXD : 9;						/*!< */
	__IOM uint16_t RSDR: 7;
} UART0_TypeDef;



typedef struct {
	__IM  uint16_t  SSR;						/*!< */
	__IM  uint16_t  RESERVED1[1];

	__IOM uint16_t  SIR;						/*!< */
	__IOM uint16_t  RESERVED2[1];
	
	__IOM uint16_t  SMR;						/*!< */
	__IOM uint16_t  RESERVED3[1];
	
	__IOM uint16_t  SCR;						/*!< */
	__IOM uint16_t  RESERVED4[1];
	
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  15;
	
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 15;

	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     : 12;
	
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
  __IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  7;

	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 15;

  __IM  uint16_t  RESERVED7[3];
	
	__IOM uint16_t  SSE:  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IM  uint16_t  RESERVED5[14];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

	__IM  uint16_t  RESERVED6[1];
} I2C0_TypeDef;

typedef struct {
	__IM  uint16_t  RESERVED1[1];
	__IM  uint16_t  SSR;						/*!< */

	__IOM uint16_t  RESERVED3[1];
	__IOM uint16_t  SIR;						/*!< */
	
	__IOM uint16_t  RESERVED5[1];
	__IOM uint16_t  SMR;						/*!< */
	
	__IOM uint16_t  RESERVED7[1];
	__IOM uint16_t  SCR;						/*!< */
	
	__IM  uint16_t     :  1;
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  14;
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t     :  4;
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  8;
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  6;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 14;

  __IM  uint16_t  RESERVED8[3];
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SSE:  1;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IM  uint16_t  RESERVED9[15];
	
//	__IM  uint16_t  RESERVED9[19];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

//	__IM  uint16_t  RESERVED10[26];
} I2C1_TypeDef;



typedef struct {                                /*!< (@ 0x40046000) SCI0 Structure                                             */
	union {
		SCI0_TypeDef	SCI;
		UART0_TypeDef 	UART0;
		I2C0_TypeDef	I2C0;
		I2C1_TypeDef	I2C1;

	};
} SCI0_Type;                                    /*!< Size = 584 (0x248)                  																				*/



/* =========================================================================================================================== * /
/ * ================                                           SCI1                                            ================ * /
/ * =========================================================================================================================== */



/* *
  * @brief Serial Communication Interface 1 with UART, SPI and simplified I2C supported (SCI1)
  */

typedef struct {                                /*!< (@ 0x40046400) SCI1 Structure                                             */
  __IM  uint16_t  SSR10;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR11;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR10;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR11;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR10;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR11;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR10;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR11;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE1;                          /*!< (@ 0x00000010) Serial channel enable status register 1                    */
  __IOM uint16_t  SS1;                          /*!< (@ 0x00000012) Serial channel start register 1                            */
  __IOM uint16_t  ST1;                          /*!< (@ 0x00000014) Serial channel stop register 1                             */
  __IOM uint16_t  SPS1;                         /*!< (@ 0x00000016) Serial clock select register 1                             */
  __IOM uint16_t  SO1;                          /*!< (@ 0x00000018) Serial output register 1                                   */
  __IOM uint16_t  SOE1;                         /*!< (@ 0x0000001A) Serial output enable register 1                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL1;                         /*!< (@ 0x00000020) Serial output level register 1                             */
  __IOM uint16_t  SSE0;                         /*!< (@ 0x00000022) Slave selection function enable register 0                 */
  __IOM uint16_t  SSC1;                         /*!< (@ 0x00000024) Serial standby control register 1                          */
  __IM  uint16_t  RESERVED1[13];
  
  union {
    __IOM uint16_t SDR10;                       /*!< (@ 0x00000040) Serial data register 10                                    */
    __IOM uint8_t SIO10;                        /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint8_t TXD1;                         /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR11;                       /*!< (@ 0x00000042) Serial data register 11                                    */
    __IOM uint8_t SIO11;                        /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint8_t RXD1;                         /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI1_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


typedef struct {
	__IM  uint16_t  TSSR;						/*!< */
	__IM  uint16_t  RSSR;						/*!< */
	__IOM uint16_t  TSIR;						/*!< */
	__IOM uint16_t  RSIR;						/*!< */	
	__IOM uint16_t  TSMR;						/*!< */
	__IOM uint16_t  RSMR;						/*!< */
	__IOM uint16_t  TSCR;						/*!< */
	__IOM uint16_t  RSCR;						/*!< */
	
	__IM  uint16_t  SE :  2;					/*!< */
	__IM  uint16_t     :  14;
	
	__IOM uint16_t  SS :  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IOM uint16_t  ST :  2;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t  SPS: 4;						/*!< */
	__IOM uint16_t     :12;

	__IOM uint16_t     :  2;					/*!< */	
	__IOM uint16_t  SO :  2;					/*!< */
	__IOM uint16_t	   : 12;
	__IOM uint16_t  SOE:  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IM  uint16_t  RESERVED5[2];
	__IOM uint16_t  SOL;						/*!< */
	__IOM uint16_t  SSE;                         /*!< (@ 0x00000022) Slave selection function enable register 0                 */
  __IOM uint16_t  SSC;                         /*!< (@ 0x00000024) Serial standby control register 1 */
	__IM  uint16_t  RESERVED6[13];

	__IOM uint16_t TXD : 9;
	__IOM uint16_t TSDR: 7;
	__IOM uint16_t RXD : 9;						/*!< */
	__IOM uint16_t RSDR: 7;
} UART1_TypeDef;

typedef struct {
	__IM  uint16_t  SSR;						/*!< */
	__IM  uint16_t  RESERVED1[1];
	
	__IOM uint16_t  SIR;						/*!< */
	__IOM uint16_t  RESERVED2[1];
	
	__IOM uint16_t  SMR;						/*!< */
	__IOM uint16_t  RESERVED3[1];
	
	__IOM uint16_t  SCR;						/*!< */
	__IOM uint16_t  RESERVED4[1];
	
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  15;

	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 15;

	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     : 12;
	
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  7;

	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 15;

  __IM  uint16_t  RESERVED7[3];
	
	__IOM uint16_t  SSE:  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IM  uint16_t  RESERVED5[14];
	
//	__IM  uint16_t  RESERVED5[18];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

	__IM  uint16_t  RESERVED6;
} I2C2_TypeDef;

typedef struct {
	__IM  uint16_t  RESERVED1;
	__IM  uint16_t  SSR;						/*!< */
	
	__IM  uint16_t  RESERVED3;
	__IOM uint16_t  SIR;						/*!< */
	
	__IM  uint16_t  RESERVED5;
	__IOM uint16_t  SMR;						/*!< */
	
	__IM  uint16_t  RESERVED7;
	__IOM uint16_t  SCR;						/*!< */
	
	__IM  uint16_t     :  1;
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t     :  4;
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  8;
	
	__IOM uint16_t	   :  1;
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  6;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 14;

  __IM  uint16_t  RESERVED8[3];
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SSE:  1;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IM  uint16_t  RESERVED9[15];
//	__IM  uint16_t  RESERVED9[19];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t	  : 1;
	__IOM uint16_t SDR: 7;
} I2C3_TypeDef;

typedef struct {                                /*!< (@ 0x40046400) SCI1 Structure                                             */
	union {
		SCI1_TypeDef	SCI;
		UART1_TypeDef	UART1;
		I2C2_TypeDef	I2C2;
		I2C3_TypeDef	I2C3;
	};
} SCI1_Type;                                    /*!< Size = 524 (0x20c)                                                        */


/* =========================================================================================================================== * /
/ * ================                                           SCI2                                            ================ * /
/ * =========================================================================================================================== */


/**
  * @brief Serial Communication Interface 2 with UART, SPI and simplified I2C supported (SCI2)
  */

typedef struct {                                /*!< (@ 0x40046800) SCI2 Structure                                             */
  __IM  uint16_t  SSR20;                        /*!< (@ 0x00000000) Serial status register mn                                  */
  __IM  uint16_t  SSR21;                        /*!< (@ 0x00000002) Serial status register mn                                  */
  __IOM uint16_t  SIR20;                        /*!< (@ 0x00000004) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SIR21;                        /*!< (@ 0x00000006) Serial flag clear trigger register mn                      */
  __IOM uint16_t  SMR20;                        /*!< (@ 0x00000008) Serial mode register mn                                    */
  __IOM uint16_t  SMR21;                        /*!< (@ 0x0000000A) Serial mode register mn                                    */
  __IOM uint16_t  SCR20;                        /*!< (@ 0x0000000C) Serial communication operation setting register
                                                                    mn                                                         */
  __IOM uint16_t  SCR21;                        /*!< (@ 0x0000000E) Serial communication operation setting register
                                                                    mn                                                         */
  __IM  uint16_t  SE2;                          /*!< (@ 0x00000010) Serial channel enable status register 2                    */
  __IOM uint16_t  SS2;                          /*!< (@ 0x00000012) Serial channel start register 2                            */
  __IOM uint16_t  ST2;                          /*!< (@ 0x00000014) Serial channel stop register 2                             */
  __IOM uint16_t  SPS2;                         /*!< (@ 0x00000016) Serial clock select register 0                             */
  __IOM uint16_t  SO2;                          /*!< (@ 0x00000018) Serial output register 0                                   */
  __IOM uint16_t  SOE2;                         /*!< (@ 0x0000001A) Serial output enable register 2                            */
  __IM  uint16_t  RESERVED[2];
  __IOM uint16_t  SOL2;                         /*!< (@ 0x00000020) Serial output level register 2                             */
  __IOM uint16_t  SSE0;                         /*!< (@ 0x00000022) Slave selection function enable register 0                 */
  __IOM uint16_t  SSC2;                         /*!< (@ 0x00000024) Serial standby control register 2                          */
  __IM  uint16_t  RESERVED1[13];
  
  union {
    __IOM uint16_t SDR20;                       /*!< (@ 0x00000040) Serial data register 20                                    */
    __IOM uint8_t SIO20;                        /*!< (@ 0x00000040) SPI data register                                          */
    __IOM uint8_t TXD2;                         /*!< (@ 0x00000040) UART transmit data register                                */
  };
  
  union {
    __IOM uint16_t SDR21;                       /*!< (@ 0x00000042) Serial data register 21                                    */
    __IOM uint8_t SIO21;                        /*!< (@ 0x00000042) SPI data register                                          */
    __IOM uint8_t RXD2;                         /*!< (@ 0x00000042) UART receive data register                                 */
  };
} SCI2_TypeDef;                                    /*!< Size = 68 (0x44)                                                          */


typedef struct {
	__IM  uint16_t  TSSR;						/*!< */
	__IM  uint16_t  RSSR;						/*!< */
	
	__IOM uint16_t  TSIR;						/*!< */
	__IOM uint16_t  RSIR;						/*!< */
	
	__IOM uint16_t  TSMR;						/*!< */
	__IOM uint16_t  RSMR;						/*!< */
	
	__IOM uint16_t  TSCR;						/*!< */
	__IOM uint16_t  RSCR;						/*!< */
	
	__IM  uint16_t  SE :  2;					/*!< */
	__IM  uint16_t     :  14;
	
	__IOM uint16_t  SS :  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IOM uint16_t  ST :  2;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IOM uint16_t  SPS: 4;						/*!< */
	__IOM uint16_t     :12;
	
	__IOM uint16_t     :  2;					/*!< */
	__IOM uint16_t  SO :  2;					/*!< */
	__IOM uint16_t	   : 12;
	__IOM uint16_t  SOE:  2;					/*!< */
	__IOM uint16_t	   : 14;
	__IM  uint16_t  RESERVED5[2];
	__IOM uint16_t  SOL;						/*!< */
	__IOM uint16_t  SSE;                         /*!< (@ 0x00000022) Slave selection function enable register 0                 */
  __IOM uint16_t  SSC;                         /*!< (@ 0x00000024) Serial standby control register 2  */ 
	__IM  uint16_t  RESERVED6[13];

	__IOM uint16_t TXD : 9;
	__IOM uint16_t TSDR: 7;
	__IOM uint16_t RXD : 9;						/*!< */
	__IOM uint16_t RSDR: 7;
} UART2_TypeDef;

typedef struct {
	__IM  uint16_t  SSR;						/*!< */
	__IM  uint16_t  RESERVED1[1];
	
	__IOM uint16_t  SIR;						/*!< */
	__IOM uint16_t  RESERVED2[1];
	
	__IOM uint16_t  SMR;						/*!< */
	__IOM uint16_t  RESERVED3[1];
	
	__IOM uint16_t  SCR;						/*!< */
	__IOM uint16_t  RESERVED4[1];
	
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     :  15;

	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 15;

	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  12;
	
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  7;

	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 15;

  __IM  uint16_t  RESERVED7[3];
	
	__IOM uint16_t  SSE:  1;					/*!< */
	__IOM uint16_t	   : 15;
	
	__IM  uint16_t  RESERVED5[14];
//	__IM  uint16_t  RESERVED5[18];

	__IOM uint8_t SIO: 8;
	__IOM uint16_t    : 1;
	__IOM uint16_t SDR: 7;

	__IM  uint16_t  RESERVED6;
} I2C4_TypeDef;

typedef struct {
	__IM  uint16_t  RESERVED1;
	__IM  uint16_t  SSR;						/*!< */
	
	__IM  uint16_t  RESERVED3;
	__IOM uint16_t  SIR;						/*!< */
	
	__IM  uint16_t  RESERVED5;
	__IOM uint16_t  SMR;						/*!< */
	
	__IM  uint16_t  RESERVED7;
	__IOM uint16_t  SCR;						/*!< */
	
	__IM  uint16_t     :  1;
	__IM  uint16_t  SE :  1;					/*!< */
	__IM  uint16_t     : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SS :  1;					/*!< */
	__IOM uint16_t	   : 14;

	__IOM uint16_t     :  1;
	__IOM uint16_t  ST :  1;					/*!< */
	__IOM uint16_t	   : 14;
	
  __IOM uint16_t     :  4;
	__IOM uint16_t  SPS:  4;					/*!< */
	__IOM uint16_t     :  8;
	
	__IOM uint16_t	   :  1;
	__IOM uint16_t  SO :  1;					/*!< */
	__IOM uint16_t	   :  7;
	__IOM uint16_t  CKO:  1;					/*!< */
	__IOM uint16_t	   :  6;

	__IOM uint16_t     :  1;
	__IOM uint16_t  SOE:  1;					/*!< */
	__IOM uint16_t	   : 14;

  __IM  uint16_t  RESERVED8[3];
	
	__IOM uint16_t     :  1;
	__IOM uint16_t  SSE:  1;					/*!< */
	__IOM uint16_t	   : 14;
	
	__IM  uint16_t  RESERVED9[15];
//	__IM  uint16_t  RESERVED9[19];

	__IOM uint16_t SIO: 8;
	__IOM uint16_t	  : 1;
	__IOM uint16_t SDR: 7;
} I2C5_TypeDef;

typedef struct {                                /*!< (@ 0x40046800) SCI1 Structure                                             */
	union {
		SCI2_TypeDef	SCI;
		UART2_TypeDef	UART2;
		I2C4_TypeDef	I2C4;
		I2C5_TypeDef	I2C5;
	};
} SCI2_Type;                                    /*!< Size = 524 (0x20c)                                                        */


/* =========================================================================================================================== */
/* ================                                          SPIHS0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface SPI0 (SPIHS0)
  */

typedef struct {                                /*!< (@ 0x40047800) SPIHS0 Structure                                           */
  __IOM uint32_t  SPIM;                         /*!< (@ 0x00000000) SPI mode control register                                  */
  __IOM uint32_t  SPIC;                         /*!< (@ 0x00000004) SPI control register                                       */
  __IOM uint16_t  SOTB;                         /*!< (@ 0x00000008) Data buffer of transmission                                */
  __IM  uint16_t  RESERVED;
  __IM  uint16_t  SIO;                          /*!< (@ 0x0000000C) Data buffer of reception                                   */
  __IM  uint16_t  RESERVED1;
  __IM  uint32_t  SPIS;                         /*!< (@ 0x00000010) SPI status register                                        */
} SPIHS0_Type;                                  /*!< Size = 20 (0x14)                                                          */



/* =========================================================================================================================== */
/* ================                                           IICA0                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Serial Interface I2C with multimaster and wakeup supported (IICA0)
  */

typedef struct {                                /*!< (@ 0x40047000) IICA0 Structure                                            */
  __IOM uint8_t   IICCTL00;                     /*!< (@ 0x00000000) IICA0 control register 0                                   */
  __IOM uint8_t   IICCTL01;                     /*!< (@ 0x00000001) IICA0 control register 1                                   */
  __IOM uint8_t   IICWL0;                       /*!< (@ 0x00000002) IICA0 low-level width setting register                     */
  __IOM uint8_t   IICWH0;                       /*!< (@ 0x00000003) IICA0 high-level width setting register                    */
  __IOM uint8_t   SVA0;                         /*!< (@ 0x00000004) Slave address register                                     */
  __IM  uint8_t   RESERVED[3];
  __IOM uint8_t   IICA0;                       /*!< (@ 0x00000008) IICA0 shift register                                       */
  __IM  uint8_t   IICS0;                        /*!< (@ 0x00000009) IICA0 status register                                      */
  __IOM uint8_t   IICF0;                        /*!< (@ 0x0000000A) IICA0 flag register                                        */
} IICA_Type;                                   /*!< Size = 11 (0xb)                                                           */



/* =========================================================================================================================== */
/* ================                                           IRDA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief IrDA communication module based on Infrared Data Association stardard 1.0 (IRDA)
  */

typedef struct {                                /*!< (@ 0x40048000) IRDA Structure                                             */
  __IOM uint8_t   IRCR;                         /*!< (@ 0x00000000) IrDA control register                                      */
} IRDA_Type;                                    /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                            LCD                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief LCD Controller (LCD)
  */

typedef struct {                                /*!< (@ 0x40049000) LCD Structure                                              */
  __IOM uint8_t   SEG0;                         /*!< (@ 0x00000000) LCD display data register 0                                */
  __IOM uint8_t   SEG1;                         /*!< (@ 0x00000001) LCD display data register 1                                */
  __IOM uint8_t   SEG2;                         /*!< (@ 0x00000002) LCD display data register 2                                */
  __IOM uint8_t   SEG3;                         /*!< (@ 0x00000003) LCD display data register 3                                */
  __IOM uint8_t   SEG4;                         /*!< (@ 0x00000004) LCD display data register 4                                */
  __IOM uint8_t   SEG5;                         /*!< (@ 0x00000005) LCD display data register 5                                */
  __IOM uint8_t   SEG6;                         /*!< (@ 0x00000006) LCD display data register 6                                */
  __IOM uint8_t   SEG7;                         /*!< (@ 0x00000007) LCD display data register 7                                */
  __IOM uint8_t   SEG8;                         /*!< (@ 0x00000008) LCD display data register 8                                */
  __IOM uint8_t   SEG9;                         /*!< (@ 0x00000009) LCD display data register 9                                */
  __IOM uint8_t   SEG10;                        /*!< (@ 0x0000000A) LCD display data register 10                               */
  __IOM uint8_t   SEG11;                        /*!< (@ 0x0000000B) LCD display data register 11                               */
  __IOM uint8_t   SEG12;                        /*!< (@ 0x0000000C) LCD display data register 12                               */
  __IOM uint8_t   SEG13;                        /*!< (@ 0x0000000D) LCD display data register 13                               */
  __IOM uint8_t   SEG14;                        /*!< (@ 0x0000000E) LCD display data register 14                               */
  __IOM uint8_t   SEG15;                        /*!< (@ 0x0000000F) LCD display data register 15                               */
  __IOM uint8_t   SEG16;                        /*!< (@ 0x00000010) LCD display data register 16                               */
  __IOM uint8_t   SEG17;                        /*!< (@ 0x00000011) LCD display data register 17                               */
  __IOM uint8_t   SEG18;                        /*!< (@ 0x00000012) LCD display data register 18                               */
  __IOM uint8_t   SEG19;                        /*!< (@ 0x00000013) LCD display data register 19                               */
  __IOM uint8_t   SEG20;                        /*!< (@ 0x00000014) LCD display data register 20                               */
  __IOM uint8_t   SEG21;                        /*!< (@ 0x00000015) LCD display data register 21                               */
  __IOM uint8_t   SEG22;                        /*!< (@ 0x00000016) LCD display data register 22                               */
  __IOM uint8_t   SEG23;                        /*!< (@ 0x00000017) LCD display data register 23                               */
  __IOM uint8_t   SEG24;                        /*!< (@ 0x00000018) LCD display data register 24                               */
  __IOM uint8_t   SEG25;                        /*!< (@ 0x00000019) LCD display data register 25                               */
  __IOM uint8_t   SEG26;                        /*!< (@ 0x0000001A) LCD display data register 26                               */
  __IOM uint8_t   SEG27;                        /*!< (@ 0x0000001B) LCD display data register 27                               */
  __IOM uint8_t   SEG28;                        /*!< (@ 0x0000001C) LCD display data register 28                               */
  __IOM uint8_t   SEG29;                        /*!< (@ 0x0000001D) LCD display data register 29                               */
  __IOM uint8_t   SEG30;                        /*!< (@ 0x0000001E) LCD display data register 30                               */
  __IOM uint8_t   SEG31;                        /*!< (@ 0x0000001F) LCD display data register 31                               */
  __IOM uint8_t   SEG32;                        /*!< (@ 0x00000020) LCD display data register 32                               */
  __IOM uint8_t   SEG33;                        /*!< (@ 0x00000021) LCD display data register 33                               */
  __IOM uint8_t   SEG34;                        /*!< (@ 0x00000022) LCD display data register 34                               */
  __IOM uint8_t   SEG35;                        /*!< (@ 0x00000023) LCD display data register 35                               */
  __IOM uint8_t   SEG36;                        /*!< (@ 0x00000024) LCD display data register 36                               */
  __IOM uint8_t   SEG37;                        /*!< (@ 0x00000025) LCD display data register 37                               */
  __IOM uint8_t   SEG38;                        /*!< (@ 0x00000026) LCD display data register 38                               */
  __IOM uint8_t   SEG39;                        /*!< (@ 0x00000027) LCD display data register 39                               */
  __IOM uint8_t   SEG40;                        /*!< (@ 0x00000028) LCD display data register 40                               */
  __IOM uint8_t   SEG41;                        /*!< (@ 0x00000029) LCD display data register 41                               */
  __IM  uint8_t   RESERVED[22];
  __IOM uint8_t   LCDM0;                        /*!< (@ 0x00000040) LCD mode register 0                                        */
  __IOM uint8_t   LCDM1;                        /*!< (@ 0x00000041) LCD mode register 0                                        */
  __IOM uint8_t   LCDC0;                        /*!< (@ 0x00000042) LCD clock control register 0                               */
  __IOM uint8_t   VLCD;                         /*!< (@ 0x00000043) LCB Boost level control register                           */
} LCD_Type;                                     /*!< Size = 68 (0x44)                                                          */



/* =========================================================================================================================== */
/* ================                                            DMA                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Enhanced DMA Controller (DMA)
  */

typedef struct {                                /*!< (@ 0x40005000) DMA Structure                                              */
  __IOM uint8_t   DMAEN0;                       /*!< (@ 0x00000000) DMA activation enable register 0                           */
  __IOM uint8_t   DMAEN1;                       /*!< (@ 0x00000001) DMA activation enable register 1                           */
  __IOM uint8_t   DMAEN2;                       /*!< (@ 0x00000002) DMA activation enable register 2                           */
  __IM  uint8_t   RESERVED;
  __IM  uint32_t  RESERVED1;
  __IOM uint32_t  DMABAR;                       /*!< (@ 0x00000008) DMA base address register                                  */
  __IM  uint32_t  RESERVED2[3];
  __IOM uint8_t   DMSET0;                       /*!< (@ 0x00000018) DMA Set register 0                                         */
  __IOM uint8_t   DMSET1;                       /*!< (@ 0x00000019) DMA Set register 1                                         */
  __IOM uint8_t   DMSET2;                       /*!< (@ 0x0000001A) DMA Set register 2                                         */
  __IM  uint8_t   RESERVED3;
  __IM  uint32_t  RESERVED4;
  __IOM uint8_t   DMCLR0;                       /*!< (@ 0x00000020) DMA Reset register 0                                       */
  __IOM uint8_t   DMCLR1;                       /*!< (@ 0x00000021) DMA Reset register 1                                       */
  __IOM uint8_t   DMCLR2;                       /*!< (@ 0x00000022) DMA Reset register 2                                       */
  __IM  uint8_t   RESERVED5;
} DMA_Type;                                     /*!< Size = 36 (0x24)                                                          */



/* =========================================================================================================================== */
/* ================                                          DMAVEC                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief DMA Vector and Control Data Area (DMAVEC)
  */

typedef struct {                                /*!< (@ 0x20000000) DMAVEC Structure                                           */
  __IOM uint8_t   VEC[24];                      /*!< (@ 0x00000000) DMA vector area                                            */
  __IM  uint32_t  RESERVED[2];
  __IOM DMAVEC_CTRL_Type CTRL[24];              /*!< (@ 0x00000020) DMA control data area                                      */
} DMAVEC_Type;                                  /*!< Size = 448 (0x1c0)                                                        */



/* =========================================================================================================================== */
/* ================                                            ELC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Event Link Controller (ELC)
  */

typedef struct {                                /*!< (@ 0x40041800) ELC Structure                                              */
  __IOM uint8_t   ELSELR00;                     /*!< (@ 0x00000000) Event output destination select register 00                */
  __IOM uint8_t   ELSELR01;                     /*!< (@ 0x00000001) Event output destination select register 01                */
  __IOM uint8_t   ELSELR02;                     /*!< (@ 0x00000002) Event output destination select register 02                */
  __IOM uint8_t   ELSELR03;                     /*!< (@ 0x00000003) Event output destination select register 03                */
  __IOM uint8_t   ELSELR04;                     /*!< (@ 0x00000004) Event output destination select register 04                */
  __IOM uint8_t   ELSELR05;                     /*!< (@ 0x00000005) Event output destination select register 05                */
  __IOM uint8_t   ELSELR06;                     /*!< (@ 0x00000006) Event output destination select register 06                */
  __IOM uint8_t   ELSELR07;                     /*!< (@ 0x00000007) Event output destination select register 07                */
  __IOM uint8_t   ELSELR08;                     /*!< (@ 0x00000008) Event output destination select register 08                */
  __IOM uint8_t   ELSELR09;                     /*!< (@ 0x00000009) Event output destination select register 09                */
  __IOM uint8_t   ELSELR10;                     /*!< (@ 0x0000000A) Event output destination select register 10                */
  __IOM uint8_t   ELSELR11;                     /*!< (@ 0x0000000B) Event output destination select register 11                */
  __IOM uint8_t   ELSELR12;                     /*!< (@ 0x0000000C) Event output destination select register 12                */
  __IOM uint8_t   ELSELR13;                     /*!< (@ 0x0000000D) Event output destination select register 13                */
  __IOM uint8_t   ELSELR14;                     /*!< (@ 0x0000000E) Event output destination select register 14                */
  __IOM uint8_t   ELSELR15;                     /*!< (@ 0x0000000F) Event output destination select register 15                */
} ELC_Type;                                     /*!< Size = 16 (0x10)                                                          */



/* =========================================================================================================================== */
/* ================                                            INT                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Interrupt Controller (INT)
  */

typedef struct {                                /*!< (@ 0x40006000) INT Structure                                              */
  __IOM INT_IF_Type IF[32];                     /*!< (@ 0x00000000) Interrupt flag register                                    */
  __IM  uint8_t   RESERVED[128];
  __IOM INT_MK_Type MK[32];                     /*!< (@ 0x00000100) Interrupt mask register                                    */
} INT_Type;                                     /*!< Size = 384 (0x180)                                                        */



/* =========================================================================================================================== */
/* ================                                           INTM                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Pin input edge detection (INTM)
  */

typedef struct {                                /*!< (@ 0x40041C00) INTM Structure                                             */
  __IOM uint8_t   EGP0;                         /*!< (@ 0x00000000) External interrupt rising edge enable register             */
  __IOM uint8_t   EGN0;                         /*!< (@ 0x00000001) External interrupt falling edge enable register            */
} INTM_Type;                                    /*!< Size = 2 (0x2)                                                            */



/* =========================================================================================================================== */
/* ================                                            KEY                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Key interrupt (KEY)
  */

typedef struct {                                /*!< (@ 0x40042000) KEY Structure                                              */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   KRM;                          /*!< (@ 0x00000001) Key return mode register                                   */
} KEY_Type;                                     /*!< Size = 2 (0x2)                                                            */



/* =========================================================================================================================== */
/* ================                                          PPORGA                                           ================ */
/* =========================================================================================================================== */


/**
  * @brief Selection of reading data (PPORGA)
  */

typedef struct {                                /*!< (@ 0x40040800) PPORGA Structure                                           */
  __IOM uint8_t   PMS;                          /*!< (@ 0x00000000) Clock output select registers 0                            */
  __IOM uint8_t   GDIDIS;                       /*!< (@ 0x00000001) GDIDIS                                                     */
  __IM  uint16_t  RESERVED;
  __IOM uint16_t  ISCLCD;                       /*!< (@ 0x00000004) LCD Input switching control register                       */
  __IOM uint16_t  SEGEN0;                       /*!< (@ 0x00000006) LCD port function register 0                               */
  __IOM uint16_t  SEGEN1;                       /*!< (@ 0x00000008) LCD port function register 1                               */
  __IOM uint16_t  SEGEN2;                       /*!< (@ 0x0000000A) LCD port function register 2                               */
  __IOM uint16_t  SEGEN3;                       /*!< (@ 0x0000000C) LCD port function register 3                               */
} PPORGA_Type;                                  /*!< Size = 14 (0xe)                                                           */



/* =========================================================================================================================== */
/* ================                                           MISC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Miscellaneous function (MISC)
  */

typedef struct {                                /*!< (@ 0x40040C00) MISC Structure                                             */
  __IOM uint8_t   NFEN0;                        /*!< (@ 0x00000000) Noise filter enable register 0                             */
  __IOM uint8_t   RESERVED0;                        /*!< (@ 0x00000001) Noise filter enable register 1                             */
  __IM  uint8_t   RESERVED;
  __IOM uint8_t   ISC;                          /*!< (@ 0x00000003) Input switch control register                              */
  __IOM uint8_t   TIOS0;                        /*!< (@ 0x00000004) Timer I/O select register 0                                */
  __IM  uint8_t   RESERVED1[7];
  __IOM uint8_t   RTCCL;                        /*!< (@ 0x0000000C) Real-time clock select register                            */
} MISC_Type;                                    /*!< Size = 13 (0xd)                                                           */



/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Flash Memory Controller (FMC)
  */

typedef struct {                                /*!< (@ 0x40020000) FMC Structure                                              */
  __IOM uint32_t  FLSTS;                        /*!< (@ 0x00000000) Flash status register                                      */
  __IOM uint32_t  FLOPMD1;                      /*!< (@ 0x00000004) Flash operation mode register 1                            */
  __IOM uint32_t  FLOPMD2;                      /*!< (@ 0x00000008) Flash operation mode register 2                            */
  __IOM uint32_t  FLERMD;                       /*!< (@ 0x0000000C) Flash erase mode register                                  */
  __IOM uint32_t  FLCERCNT;                     /*!< (@ 0x00000010) Flash chip erase control register                          */
  __IOM uint32_t  FLSERCNT;                     /*!< (@ 0x00000014) Flash sector erase control register                        */
  __IOM uint32_t  FLNVSCNT;                     /*!< (@ 0x00000018) Flash address setup time (Tnvs) control register           */
  __IOM uint32_t  FLPROCNT;                     /*!< (@ 0x0000001C) Flash program control register                             */
  __IOM uint32_t  FLPROT;                       /*!< (@ 0x00000020) Flash protect control register                             */
  __IM  uint32_t  RESERVED[6];
  __IOM uint32_t  FLRCVCNT;                     /*!< (@ 0x0000003C) Set the recovery time when flash is written                */
  __IM  uint32_t  RESERVED1[116];
  __IOM uint32_t  FLSECPR;                      /*!< (@ 0x00000210) Flash erase protection control register                    */
} FMC_Type;                                     /*!< Size = 532 (0x214)                                                        */



/* =========================================================================================================================== */
/* ================                                            SAF                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Flash memory CRC operation function (High-Speed CRC) (SAF)
  */

typedef struct {                                /*!< (@ 0x40020100) SAF Structure                                              */
  __IM  uint16_t  RESERVED[402];
  __IM  uint8_t   RESERVED1;
  __IOM uint8_t   RPECTL;                       /*!< (@ 0x00000325) RAM parity error control register                          */
  __IM  uint16_t  RESERVED2[2549];
  __IOM uint8_t   CRC0CTL;                      /*!< (@ 0x00001710) Flash memory CRC control register                          */
  __IM  uint8_t   RESERVED3;
  __IOM uint16_t  PGCRCL;                       /*!< (@ 0x00001712) Flash memory CRC operation result register                 */
  __IM  uint16_t  RESERVED4[63994];
  __IOM uint16_t  SFRGD;                        /*!< (@ 0x00020B08) SFR guard control register                                 */
  __IM  uint16_t  RESERVED5[1019];
  __IOM uint8_t   CRCIN;                        /*!< (@ 0x00021300) CRC input register                                         */
  __IM  uint8_t   RESERVED6;
  __IOM uint16_t  CRCD;                         /*!< (@ 0x00021302) CRC data register                                          */
} SAF_Type;                                     /*!< Size = 135940 (0x21304)                                                   */



/* =========================================================================================================================== */
/* ================                                           OSDC                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Vibration stop detection circuit (OSDC)
  */

typedef struct {                                /*!< (@ 0x40022200) OSDC Structure                                             */
  __IOM uint16_t  SCMCTL;                       /*!< (@ 0x00000000) Vibration stop detection control register                  */
  __IOM uint16_t  SCMMD;                        /*!< (@ 0x00000002) Vibration stop detection mode register                     */
  __IOM uint16_t  SCMST;                        /*!< (@ 0x00000004) Vibration stop detection status register                   */
} OSDC_Type;                                    /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                           OCRV                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief 1 (OCRV)
  */

typedef struct {                                /*!< (@ 0x40022400) OCRV Structure                                             */
  __IOM uint8_t   HOCOFC;                       /*!< (@ 0x00000000) High speed internal vibration frequency correction
                                                                    control register                                           */
} OCRV_Type;                                    /*!< Size = 1 (0x1)                                                            */



/* =========================================================================================================================== */
/* ================                                            DBG                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief DBG Controller (DBG)
  */

typedef struct {                                /*!< (@ 0x4001B000) DBG Structure                                              */
  __IM  uint32_t  DBGSTR;                       /*!< (@ 0x00000000) Debug status register                                      */
  __IOM uint32_t  DBGSTOPCR;                    /*!< (@ 0x00000004) Debug Stop Control register                                */
} DBG_Type;                                     /*!< Size = 8 (0x8)                                                            */



/* =========================================================================================================================== */
/* ================                                            TSN                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief Temperature Sensor calibration data (TSN)
  */

typedef struct {                                /*!< (@ 0x00500C68) TSN Structure                                              */
  __IM  int16_t   TSN85;                        /*!< (@ 0x00000000) The A/D conversion value of Temperature Sensor
                                                                    at 85 degrees and 3.0V reference voltage                   */
  __IM  uint16_t  RESERVED;
  __IM  int16_t   TSN25;                        /*!< (@ 0x00000004) The A/D conversion value of Temperature Sensor
                                                                    at 25 degrees and 3.0V reference voltage                   */
} TSN_Type;                                     /*!< Size = 6 (0x6)                                                            */



/* =========================================================================================================================== */
/* ================                                            UID                                            ================ */
/* =========================================================================================================================== */


/**
  * @brief 128-bit Unique ID (UID)
  */

typedef struct {                                /*!< (@ 0x00500E4C) UID Structure                                              */
  __IM  uint32_t  UID0;                         /*!< (@ 0x00000000) UID word 0                                                 */
  __IM  uint32_t  UID1;                         /*!< (@ 0x00000004) UID word 1                                                 */
  __IM  uint32_t  UID2;                         /*!< (@ 0x00000008) UID word 2                                                 */
  __IM  uint32_t  UID3;                         /*!< (@ 0x0000000C) UID word 3                                                 */
} UID_Type;                                     /*!< Size = 16 (0x10)                                                          */


/** @} */ /* End of group Device_Peripheral_peripherals */


/* =========================================================================================================================== */
/* ================                          Device Specific Peripheral Address Map                           ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_peripheralAddr
  * @{
  */

#define CGC_BASE                    0x40020400UL
#define RST_BASE                    0x40020420UL
#define LVD_BASE                    0x40020440UL
#define PORT_BASE                   0x40040000UL
#define TM8_BASE                    0x40043000UL
#define TMA_BASE                    0x40044000UL
#define RTC_BASE                    0x40042400UL
#define PCBZ_BASE                   0x40041000UL
#define WDT_BASE                    0x40020404UL
#define ADC_BASE                    0x40045000UL
#define DAC_BASE                    0x40045400UL
#define CMP_BASE                    0x40045800UL
#define OPA_BASE                    0x40045C00UL
#define SCI0_BASE                   0x40046000UL
#define SCI1_BASE                   0x40046400UL
#define SCI2_BASE                   0x40046800UL
#define SPIHS0_BASE                 0x40047800UL
#define IICA_BASE                   0x40047000UL
#define IRDA_BASE                   0x40048000UL
#define LCD_BASE                    0x40049000UL
#define DMA_BASE                    0x40005000UL
#define DMAVEC_BASE                 0x20000000UL
#define ELC_BASE                    0x40041800UL
#define INT_BASE                    0x40006000UL
#define INTM_BASE                   0x40041C00UL
#define KEY_BASE                    0x40042000UL
#define PPORGA_BASE                 0x40040800UL
#define MISC_BASE                   0x40040C00UL
#define FMC_BASE                    0x40020000UL
#define SAF_BASE                    0x40020100UL
#define OSDC_BASE                   0x40022200UL
#define OCRV_BASE                   0x40022400UL
#define DBG_BASE                    0x4001B000UL
#define TSN_BASE                    0x00500C68UL
#define UID_BASE                    0x00500E4CUL

/** @} */ /* End of group Device_Peripheral_peripheralAddr */


/* =========================================================================================================================== */
/* ================                                  Peripheral declaration                                   ================ */
/* =========================================================================================================================== */


/** @addtogroup Device_Peripheral_declaration
  * @{
  */

#define CGC                         ((CGC_Type*)               CGC_BASE)
#define RST                         ((RST_Type*)               RST_BASE)
#define LVD                         ((LVD_Type*)               LVD_BASE)
#define PORT                        ((PORT_Type*)              PORT_BASE)
#define TM8                         ((TM8_Type*)               TM8_BASE)
#define TMA                         ((TMA_Type*)               TMA_BASE)
#define RTC                         ((RTC_Type*)               RTC_BASE)
#define PCBZ                        ((PCBZ_Type*)              PCBZ_BASE)
#define WDT                         ((WDT_Type*)               WDT_BASE)
#define ADC                         ((ADC_Type*)               ADC_BASE)
#define DAC                         ((DAC_Type*)               DAC_BASE)
#define CMP                         ((CMP_Type*)               CMP_BASE)
#define OPA                         ((OPA_Type*)               OPA_BASE)
#define SCI0                        ((SCI0_Type*)              SCI0_BASE)
#define SCI1                        ((SCI1_Type*)              SCI1_BASE)
#define SCI2                        ((SCI2_Type*)              SCI2_BASE)
#define SPI                         ((SPIHS0_Type*)            SPIHS0_BASE)
#define IICA                        ((IICA_Type*)              IICA_BASE)
#define IRDA                        ((IRDA_Type*)              IRDA_BASE)
#define LCD                         ((LCD_Type*)               LCD_BASE)
#define DMA                         ((DMA_Type*)               DMA_BASE)
#define DMAVEC                      ((DMAVEC_Type*)            DMAVEC_BASE)
#define ELC                         ((ELC_Type*)               ELC_BASE)
#define INT                         ((INT_Type*)               INT_BASE)
#define INTM                        ((INTM_Type*)              INTM_BASE)
#define KEY                         ((KEY_Type*)               KEY_BASE)
#define PPORGA                      ((PPORGA_Type*)            PPORGA_BASE)
#define MISC                        ((MISC_Type*)              MISC_BASE)
#define FMC                         ((FMC_Type*)               FMC_BASE)
#define SAF                         ((SAF_Type*)               SAF_BASE)
#define OSDC                        ((OSDC_Type*)              OSDC_BASE)
#define OCRV                        ((OCRV_Type*)              OCRV_BASE)
#define DBG                         ((DBG_Type*)               DBG_BASE)
#define TSN                         ((TSN_Type*)               TSN_BASE)
#define UID                         ((UID_Type*)               UID_BASE)

/** @} */ /* End of group Device_Peripheral_declaration */


/* =========================================  End of section using anonymous unions  ========================================= */
#if defined (__CC_ARM)
  #pragma pop
#elif defined (__ICCARM__)
  /* leave anonymous unions enabled */
#elif (__ARMCC_VERSION >= 6010050)
  #pragma clang diagnostic pop
#elif defined (__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined (__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined (__TASKING__)
  #pragma warning restore
#elif defined (__CSMC__)
  /* anonymous unions are enabled by default */
#endif


/* =========================================================================================================================== */
/* ================                                 Pos/Mask Cluster Section                                  ================ */
/* =========================================================================================================================== */


/** @addtogroup PosMask_clusters
  * @{
  */



/* =========================================================================================================================== */
/* ================                                           CTRL                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  DMACR  ========================================================= */
#define CTRL_DMACR_FIFO_Pos               (8UL)                     /*!< CTRL DMACR: FIFO (Bit 8)                              */
#define CTRL_DMACR_FIFO_Msk               (0x100UL)                 /*!< CTRL DMACR: FIFO (Bitfield-Mask: 0x01)                */
#define CTRL_DMACR_SZ_Pos                 (6UL)                     /*!< CTRL DMACR: SZ (Bit 6)                                */
#define CTRL_DMACR_SZ_Msk                 (0xc0UL)                  /*!< CTRL DMACR: SZ (Bitfield-Mask: 0x03)                  */
#define CTRL_DMACR_RPTINT_Pos             (5UL)                     /*!< CTRL DMACR: RPTINT (Bit 5)                            */
#define CTRL_DMACR_RPTINT_Msk             (0x20UL)                  /*!< CTRL DMACR: RPTINT (Bitfield-Mask: 0x01)              */
#define CTRL_DMACR_CHNE_Pos               (4UL)                     /*!< CTRL DMACR: CHNE (Bit 4)                              */
#define CTRL_DMACR_CHNE_Msk               (0x10UL)                  /*!< CTRL DMACR: CHNE (Bitfield-Mask: 0x01)                */
#define CTRL_DMACR_DAMOD_Pos              (3UL)                     /*!< CTRL DMACR: DAMOD (Bit 3)                             */
#define CTRL_DMACR_DAMOD_Msk              (0x8UL)                   /*!< CTRL DMACR: DAMOD (Bitfield-Mask: 0x01)               */
#define CTRL_DMACR_SAMOD_Pos              (2UL)                     /*!< CTRL DMACR: SAMOD (Bit 2)                             */
#define CTRL_DMACR_SAMOD_Msk              (0x4UL)                   /*!< CTRL DMACR: SAMOD (Bitfield-Mask: 0x01)               */
#define CTRL_DMACR_RPTSEL_Pos             (1UL)                     /*!< CTRL DMACR: RPTSEL (Bit 1)                            */
#define CTRL_DMACR_RPTSEL_Msk             (0x2UL)                   /*!< CTRL DMACR: RPTSEL (Bitfield-Mask: 0x01)              */
#define CTRL_DMACR_MODE_Pos               (0UL)                     /*!< CTRL DMACR: MODE (Bit 0)                              */
#define CTRL_DMACR_MODE_Msk               (0x1UL)                   /*!< CTRL DMACR: MODE (Bitfield-Mask: 0x01)                */
/* =========================================================  DMBLS  ========================================================= */
/* =========================================================  DMACT  ========================================================= */
/* =========================================================  DMRLD  ========================================================= */
/* =========================================================  DMSAR  ========================================================= */
/* =========================================================  DMDAR  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            IF                                             ================ */
/* =========================================================================================================================== */

/* ==========================================================  IFL  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            MK                                             ================ */
/* =========================================================================================================================== */

/* ==========================================================  MKL  ========================================================== */

/** @} */ /* End of group PosMask_clusters */


/* =========================================================================================================================== */
/* ================                                Pos/Mask Peripheral Section                                ================ */
/* =========================================================================================================================== */


/** @addtogroup PosMask_peripherals
  * @{
  */



/* =========================================================================================================================== */
/* ================                                            CGC                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  CMC  ========================================================== */
#define CGC_CMC_AMPH_Pos                  (0UL)                     /*!< CGC CMC: AMPH (Bit 0)                                 */
#define CGC_CMC_AMPH_Msk                  (0x1UL)                   /*!< CGC CMC: AMPH (Bitfield-Mask: 0x01)                   */
#define CGC_CMC_AMPHS_Pos                 (1UL)                     /*!< CGC CMC: AMPHS (Bit 1)                                */
#define CGC_CMC_AMPHS_Msk                 (0x6UL)                   /*!< CGC CMC: AMPHS (Bitfield-Mask: 0x03)                  */
#define CGC_CMC_OSCSELS_Pos               (4UL)                     /*!< CGC CMC: OSCSELS (Bit 4)                              */
#define CGC_CMC_OSCSELS_Msk               (0x10UL)                  /*!< CGC CMC: OSCSELS (Bitfield-Mask: 0x01)                */
#define CGC_CMC_EXCLKS_Pos                (5UL)                     /*!< CGC CMC: EXCLKS (Bit 5)                               */
#define CGC_CMC_EXCLKS_Msk                (0x20UL)                  /*!< CGC CMC: EXCLKS (Bitfield-Mask: 0x01)                 */
#define CGC_CMC_OSCSEL_Pos                (6UL)                     /*!< CGC CMC: OSCSEL (Bit 6)                               */
#define CGC_CMC_OSCSEL_Msk                (0x40UL)                  /*!< CGC CMC: OSCSEL (Bitfield-Mask: 0x01)                 */
#define CGC_CMC_EXCLK_Pos                 (7UL)                     /*!< CGC CMC: EXCLK (Bit 7)                                */
#define CGC_CMC_EXCLK_Msk                 (0x80UL)                  /*!< CGC CMC: EXCLK (Bitfield-Mask: 0x01)                  */
/* ==========================================================  CSC  ========================================================== */
#define CGC_CSC_HIOSTOP_Pos               (0UL)                     /*!< CGC CSC: HIOSTOP (Bit 0)                              */
#define CGC_CSC_HIOSTOP_Msk               (0x1UL)                   /*!< CGC CSC: HIOSTOP (Bitfield-Mask: 0x01)                */
#define CGC_CSC_XTSTOP_Pos                (6UL)                     /*!< CGC CSC: XTSTOP (Bit 6)                               */
#define CGC_CSC_XTSTOP_Msk                (0x40UL)                  /*!< CGC CSC: XTSTOP (Bitfield-Mask: 0x01)                 */
#define CGC_CSC_MSTOP_Pos                 (7UL)                     /*!< CGC CSC: MSTOP (Bit 7)                                */
#define CGC_CSC_MSTOP_Msk                 (0x80UL)                  /*!< CGC CSC: MSTOP (Bitfield-Mask: 0x01)                  */
/* =========================================================  OSTC  ========================================================== */
/* =========================================================  OSTS  ========================================================== */
/* ==========================================================  CKC  ========================================================== */
#define CGC_CKC_MCM0_Pos                  (4UL)                     /*!< CGC CKC: MCM0 (Bit 4)                                 */
#define CGC_CKC_MCM0_Msk                  (0x10UL)                  /*!< CGC CKC: MCM0 (Bitfield-Mask: 0x01)                   */
#define CGC_CKC_MCS_Pos                   (5UL)                     /*!< CGC CKC: MCS (Bit 5)                                  */
#define CGC_CKC_MCS_Msk                   (0x20UL)                  /*!< CGC CKC: MCS (Bitfield-Mask: 0x01)                    */
#define CGC_CKC_CSS_Pos                   (6UL)                     /*!< CGC CKC: CSS (Bit 6)                                  */
#define CGC_CKC_CSS_Msk                   (0x40UL)                  /*!< CGC CKC: CSS (Bitfield-Mask: 0x01)                    */
#define CGC_CKC_CLS_Pos                   (7UL)                     /*!< CGC CKC: CLS (Bit 7)                                  */
#define CGC_CKC_CLS_Msk                   (0x80UL)                  /*!< CGC CKC: CLS (Bitfield-Mask: 0x01)                    */
/* =========================================================  PER0  ========================================================== */
#define CGC_PER0_TM8EN_Pos                (0UL)                     /*!< CGC PER0: TM8EN (Bit 0)                               */
#define CGC_PER0_TM8EN_Msk                (0x1UL)                   /*!< CGC PER0: TM8EN (Bitfield-Mask: 0x01)                 */
#define CGC_PER0_TMAEN_Pos                (1UL)                     /*!< CGC PER0: TMAEN (Bit 1)                               */
#define CGC_PER0_TMAEN_Msk                (0x2UL)                   /*!< CGC PER0: TMAEN (Bitfield-Mask: 0x01)                 */
#define CGC_PER0_SCI0EN_Pos               (2UL)                     /*!< CGC PER0: SCI0EN (Bit 2)                              */
#define CGC_PER0_SCI0EN_Msk               (0x4UL)                   /*!< CGC PER0: SCI0EN (Bitfield-Mask: 0x01)                */
#define CGC_PER0_SCI1EN_Pos               (3UL)                     /*!< CGC PER0: SCI1EN (Bit 3)                              */
#define CGC_PER0_SCI1EN_Msk               (0x8UL)                   /*!< CGC PER0: SCI1EN (Bitfield-Mask: 0x01)                */
#define CGC_PER0_SCI2EN_Pos               (4UL)                     /*!< CGC PER0: SCI2EN (Bit 4)                              */
#define CGC_PER0_SCI2EN_Msk               (0x10UL)                  /*!< CGC PER0: SCI2EN (Bitfield-Mask: 0x01)                */
#define CGC_PER0_IRDAEN_Pos               (5UL)                     /*!< CGC PER0: IRDAEN (Bit 5)                              */
#define CGC_PER0_IRDAEN_Msk               (0x20UL)                  /*!< CGC PER0: IRDAEN (Bitfield-Mask: 0x01)                */
#define CGC_PER0_IICAEN_Pos               (6UL)                     /*!< CGC PER0: IICAEN (Bit 6)                              */
#define CGC_PER0_IICAEN_Msk               (0x40UL)                  /*!< CGC PER0: IICAEN (Bitfield-Mask: 0x01)                */
#define CGC_PER0_RTCEN_Pos                (7UL)                     /*!< CGC PER0: RTCEN (Bit 7)                               */
#define CGC_PER0_RTCEN_Msk                (0x80UL)                  /*!< CGC PER0: RTCEN (Bitfield-Mask: 0x01)                 */
/* =========================================================  PER1  ========================================================== */
#define CGC_PER1_SPIHSEN_Pos              (0UL)                     /*!< CGC PER1: SPIHSEN (Bit 0)                             */
#define CGC_PER1_SPIHSEN_Msk              (0x1UL)                   /*!< CGC PER1: SPIHSEN (Bitfield-Mask: 0x01)               */
#define CGC_PER1_DMAEN_Pos                (1UL)                     /*!< CGC PER1: DMAEN (Bit 1)                               */
#define CGC_PER1_DMAEN_Msk                (0x2UL)                   /*!< CGC PER1: DMAEN (Bitfield-Mask: 0x01)                 */
#define CGC_PER1_OSDCEN_Pos               (2UL)                     /*!< CGC PER1: OSDCEN (Bit 2)                              */
#define CGC_PER1_OSDCEN_Msk               (0x4UL)                   /*!< CGC PER1: OSDCEN (Bitfield-Mask: 0x01)                */
#define CGC_PER1_ADCEN_Pos                (4UL)                     /*!< CGC PER1: ADCEN (Bit 4)                               */
#define CGC_PER1_ADCEN_Msk                (0x10UL)                  /*!< CGC PER1: ADCEN (Bitfield-Mask: 0x01)                 */
#define CGC_PER1_DACEN_Pos                (5UL)                     /*!< CGC PER1: DACEN (Bit 5)                               */
#define CGC_PER1_DACEN_Msk                (0x20UL)                  /*!< CGC PER1: DACEN (Bitfield-Mask: 0x01)                 */
#define CGC_PER1_CMPEN_Pos                (6UL)                     /*!< CGC PER1: CMPEN (Bit 6)                               */
#define CGC_PER1_CMPEN_Msk                (0x40UL)                  /*!< CGC PER1: CMPEN (Bitfield-Mask: 0x01)                 */
#define CGC_PER1_OPAEN_Pos                (7UL)                     /*!< CGC PER1: OPAEN (Bit 7)                               */
#define CGC_PER1_OPAEN_Msk                (0x80UL)                  /*!< CGC PER1: OPAEN (Bitfield-Mask: 0x01)                 */
/* =========================================================  OSMC  ========================================================== */
#define CGC_OSMC_WUTMMCK0_Pos             (4UL)                     /*!< CGC OSMC: WUTMMCK0 (Bit 4)                            */
#define CGC_OSMC_WUTMMCK0_Msk             (0x10UL)                  /*!< CGC OSMC: WUTMMCK0 (Bitfield-Mask: 0x01)              */
#define CGC_OSMC_RTCLPC_Pos               (7UL)                     /*!< CGC OSMC: RTCLPC (Bit 7)                              */
#define CGC_OSMC_RTCLPC_Msk               (0x80UL)                  /*!< CGC OSMC: RTCLPC (Bitfield-Mask: 0x01)                */
/* =======================================================  SUBCKSEL  ======================================================== */
#define CGC_SUBCKSEL_SELLOSC_Pos          (0UL)                     /*!< CGC SUBCKSEL: SELLOSC (Bit 0)                         */
#define CGC_SUBCKSEL_SELLOSC_Msk          (0x1UL)                   /*!< CGC SUBCKSEL: SELLOSC (Bitfield-Mask: 0x01)           */
#define CGC_SUBCKSEL_LOCOSEL_Pos          (1UL)                     /*!< CGC SUBCKSEL: LOCOSEL (Bit 1)                         */
#define CGC_SUBCKSEL_LOCOSEL_Msk          (0x2UL)                   /*!< CGC SUBCKSEL: LOCOSEL (Bitfield-Mask: 0x01)           */
/* =========================================================  RSTM  ========================================================== */
#define CGC_RSTM_RSTM0_Pos                (0UL)                     /*!< CGC RSTM: RSTM0 (Bit 0)                               */
#define CGC_RSTM_RSTM0_Msk                (0x1UL)                   /*!< CGC RSTM: RSTM0 (Bitfield-Mask: 0x01)                 */
/* ========================================================  HOCODIV  ======================================================== */
/* ========================================================  HIOTRM  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            RST                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  RESF  ========================================================== */
#define RST_RESF_LVIRF_Pos                (0UL)                     /*!< RST RESF: LVIRF (Bit 0)                               */
#define RST_RESF_LVIRF_Msk                (0x1UL)                   /*!< RST RESF: LVIRF (Bitfield-Mask: 0x01)                 */
#define RST_RESF_IAWRF_Pos                (1UL)                     /*!< RST RESF: IAWRF (Bit 1)                               */
#define RST_RESF_IAWRF_Msk                (0x2UL)                   /*!< RST RESF: IAWRF (Bitfield-Mask: 0x01)                 */
#define RST_RESF_RPERF_Pos                (2UL)                     /*!< RST RESF: RPERF (Bit 2)                               */
#define RST_RESF_RPERF_Msk                (0x4UL)                   /*!< RST RESF: RPERF (Bitfield-Mask: 0x01)                 */
#define RST_RESF_CLMRF_Pos                (3UL)                     /*!< RST RESF: CLMRF (Bit 3)                               */
#define RST_RESF_CLMRF_Msk                (0x8UL)                   /*!< RST RESF: CLMRF (Bitfield-Mask: 0x01)                 */
#define RST_RESF_WDTRF_Pos                (4UL)                     /*!< RST RESF: WDTRF (Bit 4)                               */
#define RST_RESF_WDTRF_Msk                (0x10UL)                  /*!< RST RESF: WDTRF (Bitfield-Mask: 0x01)                 */
#define RST_RESF_SYSRF_Pos                (7UL)                     /*!< RST RESF: SYSRF (Bit 7)                               */
#define RST_RESF_SYSRF_Msk                (0x80UL)                  /*!< RST RESF: SYSRF (Bitfield-Mask: 0x01)                 */


/* =========================================================================================================================== */
/* ================                                            LVD                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  LVIM  ========================================================== */
#define LVD_LVIM_LVIF_Pos                 (0UL)                     /*!< LVD LVIM: LVIF (Bit 0)                                */
#define LVD_LVIM_LVIF_Msk                 (0x1UL)                   /*!< LVD LVIM: LVIF (Bitfield-Mask: 0x01)                  */
#define LVD_LVIM_LVIOMSK_Pos              (1UL)                     /*!< LVD LVIM: LVIOMSK (Bit 1)                             */
#define LVD_LVIM_LVIOMSK_Msk              (0x2UL)                   /*!< LVD LVIM: LVIOMSK (Bitfield-Mask: 0x01)               */
#define LVD_LVIM_LVISEN_Pos               (7UL)                     /*!< LVD LVIM: LVISEN (Bit 7)                              */
#define LVD_LVIM_LVISEN_Msk               (0x80UL)                  /*!< LVD LVIM: LVISEN (Bitfield-Mask: 0x01)                */
/* =========================================================  LVIS  ========================================================== */
#define LVD_LVIS_LVILV_Pos                (0UL)                     /*!< LVD LVIS: LVILV (Bit 0)                               */
#define LVD_LVIS_LVILV_Msk                (0x1UL)                   /*!< LVD LVIS: LVILV (Bitfield-Mask: 0x01)                 */
#define LVD_LVIS_LVIMD_Pos                (7UL)                     /*!< LVD LVIS: LVIMD (Bit 7)                               */
#define LVD_LVIS_LVIMD_Msk                (0x80UL)                  /*!< LVD LVIS: LVIMD (Bitfield-Mask: 0x01)                 */


/* =========================================================================================================================== */
/* ================                                           PORT                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  PMA  ========================================================== */
/* ==========================================================  PMB  ========================================================== */
/* ==========================================================  PMC  ========================================================== */
/* ==========================================================  PMD  ========================================================== */
/* ==========================================================  PMH  ========================================================== */
/* ==========================================================  PA  =========================================================== */
/* ==========================================================  PB  =========================================================== */
/* ==========================================================  PC  =========================================================== */
/* ==========================================================  PD  =========================================================== */
/* ==========================================================  PH  =========================================================== */
/* =========================================================  PSETA  ========================================================= */
/* =========================================================  PSETB  ========================================================= */
/* =========================================================  PSETC  ========================================================= */
/* =========================================================  PSETD  ========================================================= */
/* =========================================================  PSETH  ========================================================= */
/* =========================================================  PCLRA  ========================================================= */
/* =========================================================  PCLRB  ========================================================= */
/* =========================================================  PCLRC  ========================================================= */
/* =========================================================  PCLRD  ========================================================= */
/* =========================================================  PCLRH  ========================================================= */
/* ==========================================================  PUA  ========================================================== */
/* ==========================================================  PUB  ========================================================== */
/* ==========================================================  PUC  ========================================================== */
/* ==========================================================  PUD  ========================================================== */
/* ==========================================================  PUH  ========================================================== */
/* ==========================================================  PDA  ========================================================== */
/* ==========================================================  PDB  ========================================================== */
/* ==========================================================  PDC  ========================================================== */
/* ==========================================================  PDD  ========================================================== */
/* ==========================================================  PDH  ========================================================== */
/* =========================================================  POMA  ========================================================== */
/* =========================================================  POMB  ========================================================== */
/* =========================================================  POMC  ========================================================== */
/* =========================================================  POMD  ========================================================== */
/* =========================================================  POMH  ========================================================== */
/* =========================================================  PMCA  ========================================================== */
/* =========================================================  PMCB  ========================================================== */
/* =========================================================  PMCC  ========================================================== */
/* =========================================================  PMCD  ========================================================== */
/* ========================================================  PREADA  ========================================================= */
/* ========================================================  PREADB  ========================================================= */
/* ========================================================  PREADC  ========================================================= */
/* ========================================================  PREADD  ========================================================= */
/* ========================================================  PREADH  ========================================================= */
/* =========================================================  PACFG  ========================================================= */
/* =========================================================  PBCFG  ========================================================= */
/* =========================================================  PCCFG  ========================================================= */
/* =========================================================  PDCFG  ========================================================= */
/* ========================================================  PH0CFG  ========================================================= */
/* =======================================================  INTP0PCFG  ======================================================= */
#define PORT_INTP0PCFG_CFG_Pos            (0UL)                     /*!< PORT INTP0PCFG: CFG (Bit 0)                           */
#define PORT_INTP0PCFG_CFG_Msk            (0xfUL)                   /*!< PORT INTP0PCFG: CFG (Bitfield-Mask: 0x0f)             */
/* =======================================================  INTP1PCFG  ======================================================= */
#define PORT_INTP1PCFG_CFG_Pos            (0UL)                     /*!< PORT INTP1PCFG: CFG (Bit 0)                           */
#define PORT_INTP1PCFG_CFG_Msk            (0xfUL)                   /*!< PORT INTP1PCFG: CFG (Bitfield-Mask: 0x0f)             */
/* =======================================================  INTP2PCFG  ======================================================= */
#define PORT_INTP2PCFG_CFG_Pos            (0UL)                     /*!< PORT INTP2PCFG: CFG (Bit 0)                           */
#define PORT_INTP2PCFG_CFG_Msk            (0xfUL)                   /*!< PORT INTP2PCFG: CFG (Bitfield-Mask: 0x0f)             */
/* =======================================================  INTP3PCFG  ======================================================= */
#define PORT_INTP3PCFG_CFG_Pos            (0UL)                     /*!< PORT INTP3PCFG: CFG (Bit 0)                           */
#define PORT_INTP3PCFG_CFG_Msk            (0xfUL)                   /*!< PORT INTP3PCFG: CFG (Bitfield-Mask: 0x0f)             */
/* =======================================================  INTP4PCFG  ======================================================= */
#define PORT_INTP4PCFG_CFG_Pos            (0UL)                     /*!< PORT INTP4PCFG: CFG (Bit 0)                           */
#define PORT_INTP4PCFG_CFG_Msk            (0xfUL)                   /*!< PORT INTP4PCFG: CFG (Bitfield-Mask: 0x0f)             */
/* =======================================================  INTP5PCFG  ======================================================= */
#define PORT_INTP5PCFG_CFG_Pos            (0UL)                     /*!< PORT INTP5PCFG: CFG (Bit 0)                           */
#define PORT_INTP5PCFG_CFG_Msk            (0xfUL)                   /*!< PORT INTP5PCFG: CFG (Bitfield-Mask: 0x0f)             */
/* =======================================================  INTP6PCFG  ======================================================= */
/* =======================================================  INTP7PCFG  ======================================================= */


/* =========================================================================================================================== */
/* ================                                            TM8                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TCR0  ========================================================== */
/* =========================================================  TMR00  ========================================================= */
#define TM8_TMR00_MD_Pos                  (0UL)                     /*!< TM8 TMR00: MD (Bit 0)                                 */
#define TM8_TMR00_MD_Msk                  (0xfUL)                   /*!< TM8 TMR00: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR00_GTS_Pos                 (4UL)                     /*!< TM8 TMR00: GTS (Bit 4)                                */
#define TM8_TMR00_GTS_Msk                 (0x30UL)                  /*!< TM8 TMR00: GTS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR00_CIS_Pos                 (6UL)                     /*!< TM8 TMR00: CIS (Bit 6)                                */
#define TM8_TMR00_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR00: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR00_STS_Pos                 (8UL)                     /*!< TM8 TMR00: STS (Bit 8)                                */
#define TM8_TMR00_STS_Msk                 (0x700UL)                 /*!< TM8 TMR00: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR00_CCS_Pos                 (12UL)                    /*!< TM8 TMR00: CCS (Bit 12)                               */
#define TM8_TMR00_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR00: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR00_CKS_Pos                 (14UL)                    /*!< TM8 TMR00: CKS (Bit 14)                               */
#define TM8_TMR00_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR00: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TMR01  ========================================================= */
#define TM8_TMR01_MD_Pos                  (0UL)                     /*!< TM8 TMR01: MD (Bit 0)                                 */
#define TM8_TMR01_MD_Msk                  (0xfUL)                   /*!< TM8 TMR01: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR01_GTS_Pos                 (4UL)                     /*!< TM8 TMR01: GTS (Bit 4)                                */
#define TM8_TMR01_GTS_Msk                 (0x30UL)                  /*!< TM8 TMR01: GTS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR01_CIS_Pos                 (6UL)                     /*!< TM8 TMR01: CIS (Bit 6)                                */
#define TM8_TMR01_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR01: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR01_STS_Pos                 (8UL)                     /*!< TM8 TMR01: STS (Bit 8)                                */
#define TM8_TMR01_STS_Msk                 (0x700UL)                 /*!< TM8 TMR01: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR01_CCS_Pos                 (12UL)                    /*!< TM8 TMR01: CCS (Bit 12)                               */
#define TM8_TMR01_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR01: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR01_CKS_Pos                 (14UL)                    /*!< TM8 TMR01: CKS (Bit 14)                               */
#define TM8_TMR01_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR01: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TMR02  ========================================================= */
#define TM8_TMR02_MD_Pos                  (0UL)                     /*!< TM8 TMR02: MD (Bit 0)                                 */
#define TM8_TMR02_MD_Msk                  (0xfUL)                   /*!< TM8 TMR02: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR02_GTS_Pos                 (4UL)                     /*!< TM8 TMR02: GTS (Bit 4)                                */
#define TM8_TMR02_GTS_Msk                 (0x30UL)                  /*!< TM8 TMR02: GTS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR02_CIS_Pos                 (6UL)                     /*!< TM8 TMR02: CIS (Bit 6)                                */
#define TM8_TMR02_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR02: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR02_STS_Pos                 (8UL)                     /*!< TM8 TMR02: STS (Bit 8)                                */
#define TM8_TMR02_STS_Msk                 (0x700UL)                 /*!< TM8 TMR02: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR02_MASTER_Pos              (11UL)                    /*!< TM8 TMR02: MASTER (Bit 11)                            */
#define TM8_TMR02_MASTER_Msk              (0x800UL)                 /*!< TM8 TMR02: MASTER (Bitfield-Mask: 0x01)               */
#define TM8_TMR02_CCS_Pos                 (12UL)                    /*!< TM8 TMR02: CCS (Bit 12)                               */
#define TM8_TMR02_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR02: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR02_CKS_Pos                 (14UL)                    /*!< TM8 TMR02: CKS (Bit 14)                               */
#define TM8_TMR02_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR02: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TMR03  ========================================================= */
#define TM8_TMR03_MD_Pos                  (0UL)                     /*!< TM8 TMR03: MD (Bit 0)                                 */
#define TM8_TMR03_MD_Msk                  (0xfUL)                   /*!< TM8 TMR03: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR03_GTS_Pos                 (4UL)                     /*!< TM8 TMR03: GTS (Bit 4)                                */
#define TM8_TMR03_GTS_Msk                 (0x30UL)                  /*!< TM8 TMR03: GTS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR03_CIS_Pos                 (6UL)                     /*!< TM8 TMR03: CIS (Bit 6)                                */
#define TM8_TMR03_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR03: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR03_STS_Pos                 (8UL)                     /*!< TM8 TMR03: STS (Bit 8)                                */
#define TM8_TMR03_STS_Msk                 (0x700UL)                 /*!< TM8 TMR03: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR03_CCS_Pos                 (12UL)                    /*!< TM8 TMR03: CCS (Bit 12)                               */
#define TM8_TMR03_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR03: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR03_CKS_Pos                 (14UL)                    /*!< TM8 TMR03: CKS (Bit 14)                               */
#define TM8_TMR03_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR03: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TMR04  ========================================================= */
#define TM8_TMR04_MD_Pos                  (0UL)                     /*!< TM8 TMR04: MD (Bit 0)                                 */
#define TM8_TMR04_MD_Msk                  (0xfUL)                   /*!< TM8 TMR04: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR04_CIS_Pos                 (6UL)                     /*!< TM8 TMR04: CIS (Bit 6)                                */
#define TM8_TMR04_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR04: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR04_STS_Pos                 (8UL)                     /*!< TM8 TMR04: STS (Bit 8)                                */
#define TM8_TMR04_STS_Msk                 (0x700UL)                 /*!< TM8 TMR04: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR04_MASTER_Pos              (11UL)                    /*!< TM8 TMR04: MASTER (Bit 11)                            */
#define TM8_TMR04_MASTER_Msk              (0x800UL)                 /*!< TM8 TMR04: MASTER (Bitfield-Mask: 0x01)               */
#define TM8_TMR04_CCS_Pos                 (12UL)                    /*!< TM8 TMR04: CCS (Bit 12)                               */
#define TM8_TMR04_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR04: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR04_CKS_Pos                 (14UL)                    /*!< TM8 TMR04: CKS (Bit 14)                               */
#define TM8_TMR04_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR04: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TMR05  ========================================================= */
#define TM8_TMR05_MD_Pos                  (0UL)                     /*!< TM8 TMR05: MD (Bit 0)                                 */
#define TM8_TMR05_MD_Msk                  (0xfUL)                   /*!< TM8 TMR05: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR05_GTS_Pos                 (4UL)                     /*!< TM8 TMR05: GTS (Bit 4)                                */
#define TM8_TMR05_GTS_Msk                 (0x30UL)                  /*!< TM8 TMR05: GTS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR05_CIS_Pos                 (6UL)                     /*!< TM8 TMR05: CIS (Bit 6)                                */
#define TM8_TMR05_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR05: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR05_STS_Pos                 (8UL)                     /*!< TM8 TMR05: STS (Bit 8)                                */
#define TM8_TMR05_STS_Msk                 (0x700UL)                 /*!< TM8 TMR05: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR05_CCS_Pos                 (12UL)                    /*!< TM8 TMR05: CCS (Bit 12)                               */
#define TM8_TMR05_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR05: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR05_CKS_Pos                 (14UL)                    /*!< TM8 TMR05: CKS (Bit 14)                               */
#define TM8_TMR05_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR05: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TMR06  ========================================================= */
#define TM8_TMR06_MD_Pos                  (0UL)                     /*!< TM8 TMR06: MD (Bit 0)                                 */
#define TM8_TMR06_MD_Msk                  (0xfUL)                   /*!< TM8 TMR06: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR06_GTS_Pos                 (4UL)                     /*!< TM8 TMR06: GTS (Bit 4)                                */
#define TM8_TMR06_GTS_Msk                 (0x30UL)                  /*!< TM8 TMR06: GTS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR06_CIS_Pos                 (6UL)                     /*!< TM8 TMR06: CIS (Bit 6)                                */
#define TM8_TMR06_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR06: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR06_STS_Pos                 (8UL)                     /*!< TM8 TMR06: STS (Bit 8)                                */
#define TM8_TMR06_STS_Msk                 (0x700UL)                 /*!< TM8 TMR06: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR06_MASTER_Pos              (11UL)                    /*!< TM8 TMR06: MASTER (Bit 11)                            */
#define TM8_TMR06_MASTER_Msk              (0x800UL)                 /*!< TM8 TMR06: MASTER (Bitfield-Mask: 0x01)               */
#define TM8_TMR06_CCS_Pos                 (12UL)                    /*!< TM8 TMR06: CCS (Bit 12)                               */
#define TM8_TMR06_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR06: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR06_CKS_Pos                 (14UL)                    /*!< TM8 TMR06: CKS (Bit 14)                               */
#define TM8_TMR06_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR06: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TMR07  ========================================================= */
#define TM8_TMR07_MD_Pos                  (0UL)                     /*!< TM8 TMR07: MD (Bit 0)                                 */
#define TM8_TMR07_MD_Msk                  (0xfUL)                   /*!< TM8 TMR07: MD (Bitfield-Mask: 0x0f)                   */
#define TM8_TMR07_GTS_Pos                 (4UL)                     /*!< TM8 TMR07: GTS (Bit 4)                                */
#define TM8_TMR07_GTS_Msk                 (0x30UL)                  /*!< TM8 TMR07: GTS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR07_CIS_Pos                 (6UL)                     /*!< TM8 TMR07: CIS (Bit 6)                                */
#define TM8_TMR07_CIS_Msk                 (0xc0UL)                  /*!< TM8 TMR07: CIS (Bitfield-Mask: 0x03)                  */
#define TM8_TMR07_STS_Pos                 (8UL)                     /*!< TM8 TMR07: STS (Bit 8)                                */
#define TM8_TMR07_STS_Msk                 (0x700UL)                 /*!< TM8 TMR07: STS (Bitfield-Mask: 0x07)                  */
#define TM8_TMR07_CCS_Pos                 (12UL)                    /*!< TM8 TMR07: CCS (Bit 12)                               */
#define TM8_TMR07_CCS_Msk                 (0x1000UL)                /*!< TM8 TMR07: CCS (Bitfield-Mask: 0x01)                  */
#define TM8_TMR07_CKS_Pos                 (14UL)                    /*!< TM8 TMR07: CKS (Bit 14)                               */
#define TM8_TMR07_CKS_Msk                 (0xc000UL)                /*!< TM8 TMR07: CKS (Bitfield-Mask: 0x03)                  */
/* =========================================================  TSR00  ========================================================= */
#define TM8_TSR00_OVF_Pos                 (0UL)                     /*!< TM8 TSR00: OVF (Bit 0)                                */
#define TM8_TSR00_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR00: OVF (Bitfield-Mask: 0x01)                  */
/* =========================================================  TSR01  ========================================================= */
#define TM8_TSR01_OVF_Pos                 (0UL)                     /*!< TM8 TSR01: OVF (Bit 0)                                */
#define TM8_TSR01_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR01: OVF (Bitfield-Mask: 0x01)                  */
/* =========================================================  TSR02  ========================================================= */
#define TM8_TSR02_OVF_Pos                 (0UL)                     /*!< TM8 TSR02: OVF (Bit 0)                                */
#define TM8_TSR02_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR02: OVF (Bitfield-Mask: 0x01)                  */
/* =========================================================  TSR03  ========================================================= */
#define TM8_TSR03_OVF_Pos                 (0UL)                     /*!< TM8 TSR03: OVF (Bit 0)                                */
#define TM8_TSR03_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR03: OVF (Bitfield-Mask: 0x01)                  */
/* =========================================================  TSR04  ========================================================= */
#define TM8_TSR04_OVF_Pos                 (0UL)                     /*!< TM8 TSR04: OVF (Bit 0)                                */
#define TM8_TSR04_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR04: OVF (Bitfield-Mask: 0x01)                  */
/* =========================================================  TSR05  ========================================================= */
#define TM8_TSR05_OVF_Pos                 (0UL)                     /*!< TM8 TSR05: OVF (Bit 0)                                */
#define TM8_TSR05_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR05: OVF (Bitfield-Mask: 0x01)                  */
/* =========================================================  TSR06  ========================================================= */
#define TM8_TSR06_OVF_Pos                 (0UL)                     /*!< TM8 TSR06: OVF (Bit 0)                                */
#define TM8_TSR06_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR06: OVF (Bitfield-Mask: 0x01)                  */
/* =========================================================  TSR07  ========================================================= */
#define TM8_TSR07_OVF_Pos                 (0UL)                     /*!< TM8 TSR07: OVF (Bit 0)                                */
#define TM8_TSR07_OVF_Msk                 (0x1UL)                   /*!< TM8 TSR07: OVF (Bitfield-Mask: 0x01)                  */
/* ==========================================================  TE0  ========================================================== */
#define TM8_TE0_TE00_Pos                  (0UL)                     /*!< TM8 TE0: TE00 (Bit 0)                                 */
#define TM8_TE0_TE00_Msk                  (0x1UL)                   /*!< TM8 TE0: TE00 (Bitfield-Mask: 0x01)                   */
#define TM8_TE0_TE01_Pos                  (1UL)                     /*!< TM8 TE0: TE01 (Bit 1)                                 */
#define TM8_TE0_TE01_Msk                  (0x2UL)                   /*!< TM8 TE0: TE01 (Bitfield-Mask: 0x01)                   */
#define TM8_TE0_TE02_Pos                  (2UL)                     /*!< TM8 TE0: TE02 (Bit 2)                                 */
#define TM8_TE0_TE02_Msk                  (0x4UL)                   /*!< TM8 TE0: TE02 (Bitfield-Mask: 0x01)                   */
#define TM8_TE0_TE03_Pos                  (3UL)                     /*!< TM8 TE0: TE03 (Bit 3)                                 */
#define TM8_TE0_TE03_Msk                  (0x8UL)                   /*!< TM8 TE0: TE03 (Bitfield-Mask: 0x01)                   */
#define TM8_TE0_TE04_Pos                  (4UL)                     /*!< TM8 TE0: TE04 (Bit 4)                                 */
#define TM8_TE0_TE04_Msk                  (0x10UL)                  /*!< TM8 TE0: TE04 (Bitfield-Mask: 0x01)                   */
#define TM8_TE0_TE05_Pos                  (5UL)                     /*!< TM8 TE0: TE05 (Bit 5)                                 */
#define TM8_TE0_TE05_Msk                  (0x20UL)                  /*!< TM8 TE0: TE05 (Bitfield-Mask: 0x01)                   */
#define TM8_TE0_TE06_Pos                  (6UL)                     /*!< TM8 TE0: TE06 (Bit 6)                                 */
#define TM8_TE0_TE06_Msk                  (0x40UL)                  /*!< TM8 TE0: TE06 (Bitfield-Mask: 0x01)                   */
#define TM8_TE0_TE07_Pos                  (7UL)                     /*!< TM8 TE0: TE07 (Bit 7)                                 */
#define TM8_TE0_TE07_Msk                  (0x80UL)                  /*!< TM8 TE0: TE07 (Bitfield-Mask: 0x01)                   */
/* ==========================================================  TS0  ========================================================== */
#define TM8_TS0_TS00_Pos                  (0UL)                     /*!< TM8 TS0: TS00 (Bit 0)                                 */
#define TM8_TS0_TS00_Msk                  (0x1UL)                   /*!< TM8 TS0: TS00 (Bitfield-Mask: 0x01)                   */
#define TM8_TS0_TS01_Pos                  (1UL)                     /*!< TM8 TS0: TS01 (Bit 1)                                 */
#define TM8_TS0_TS01_Msk                  (0x2UL)                   /*!< TM8 TS0: TS01 (Bitfield-Mask: 0x01)                   */
#define TM8_TS0_TS02_Pos                  (2UL)                     /*!< TM8 TS0: TS02 (Bit 2)                                 */
#define TM8_TS0_TS02_Msk                  (0x4UL)                   /*!< TM8 TS0: TS02 (Bitfield-Mask: 0x01)                   */
#define TM8_TS0_TS03_Pos                  (3UL)                     /*!< TM8 TS0: TS03 (Bit 3)                                 */
#define TM8_TS0_TS03_Msk                  (0x8UL)                   /*!< TM8 TS0: TS03 (Bitfield-Mask: 0x01)                   */
#define TM8_TS0_TS04_Pos                  (4UL)                     /*!< TM8 TS0: TS04 (Bit 4)                                 */
#define TM8_TS0_TS04_Msk                  (0x10UL)                  /*!< TM8 TS0: TS04 (Bitfield-Mask: 0x01)                   */
#define TM8_TS0_TS05_Pos                  (5UL)                     /*!< TM8 TS0: TS05 (Bit 5)                                 */
#define TM8_TS0_TS05_Msk                  (0x20UL)                  /*!< TM8 TS0: TS05 (Bitfield-Mask: 0x01)                   */
#define TM8_TS0_TS06_Pos                  (6UL)                     /*!< TM8 TS0: TS06 (Bit 6)                                 */
#define TM8_TS0_TS06_Msk                  (0x40UL)                  /*!< TM8 TS0: TS06 (Bitfield-Mask: 0x01)                   */
#define TM8_TS0_TS07_Pos                  (7UL)                     /*!< TM8 TS0: TS07 (Bit 7)                                 */
#define TM8_TS0_TS07_Msk                  (0x80UL)                  /*!< TM8 TS0: TS07 (Bitfield-Mask: 0x01)                   */
/* ==========================================================  TT0  ========================================================== */
#define TM8_TT0_TT00_Pos                  (0UL)                     /*!< TM8 TT0: TT00 (Bit 0)                                 */
#define TM8_TT0_TT00_Msk                  (0x1UL)                   /*!< TM8 TT0: TT00 (Bitfield-Mask: 0x01)                   */
#define TM8_TT0_TT01_Pos                  (1UL)                     /*!< TM8 TT0: TT01 (Bit 1)                                 */
#define TM8_TT0_TT01_Msk                  (0x2UL)                   /*!< TM8 TT0: TT01 (Bitfield-Mask: 0x01)                   */
#define TM8_TT0_TT02_Pos                  (2UL)                     /*!< TM8 TT0: TT02 (Bit 2)                                 */
#define TM8_TT0_TT02_Msk                  (0x4UL)                   /*!< TM8 TT0: TT02 (Bitfield-Mask: 0x01)                   */
#define TM8_TT0_TT03_Pos                  (3UL)                     /*!< TM8 TT0: TT03 (Bit 3)                                 */
#define TM8_TT0_TT03_Msk                  (0x8UL)                   /*!< TM8 TT0: TT03 (Bitfield-Mask: 0x01)                   */
#define TM8_TT0_TT04_Pos                  (4UL)                     /*!< TM8 TT0: TT04 (Bit 4)                                 */
#define TM8_TT0_TT04_Msk                  (0x10UL)                  /*!< TM8 TT0: TT04 (Bitfield-Mask: 0x01)                   */
#define TM8_TT0_TT05_Pos                  (5UL)                     /*!< TM8 TT0: TT05 (Bit 5)                                 */
#define TM8_TT0_TT05_Msk                  (0x20UL)                  /*!< TM8 TT0: TT05 (Bitfield-Mask: 0x01)                   */
#define TM8_TT0_TT06_Pos                  (6UL)                     /*!< TM8 TT0: TT06 (Bit 6)                                 */
#define TM8_TT0_TT06_Msk                  (0x40UL)                  /*!< TM8 TT0: TT06 (Bitfield-Mask: 0x01)                   */
#define TM8_TT0_TT07_Pos                  (7UL)                     /*!< TM8 TT0: TT07 (Bit 7)                                 */
#define TM8_TT0_TT07_Msk                  (0x80UL)                  /*!< TM8 TT0: TT07 (Bitfield-Mask: 0x01)                   */
/* =========================================================  TPS0  ========================================================== */
#define TM8_TPS0_PRS00_Pos                (0UL)                     /*!< TM8 TPS0: PRS00 (Bit 0)                               */
#define TM8_TPS0_PRS00_Msk                (0xfUL)                   /*!< TM8 TPS0: PRS00 (Bitfield-Mask: 0x0f)                 */
#define TM8_TPS0_PRS01_Pos                (4UL)                     /*!< TM8 TPS0: PRS01 (Bit 4)                               */
#define TM8_TPS0_PRS01_Msk                (0xf0UL)                  /*!< TM8 TPS0: PRS01 (Bitfield-Mask: 0x0f)                 */
#define TM8_TPS0_PRS02_Pos                (8UL)                     /*!< TM8 TPS0: PRS02 (Bit 8)                               */
#define TM8_TPS0_PRS02_Msk                (0x300UL)                 /*!< TM8 TPS0: PRS02 (Bitfield-Mask: 0x03)                 */
#define TM8_TPS0_PRS03_Pos                (12UL)                    /*!< TM8 TPS0: PRS03 (Bit 12)                              */
#define TM8_TPS0_PRS03_Msk                (0x3000UL)                /*!< TM8 TPS0: PRS03 (Bitfield-Mask: 0x03)                 */
/* ==========================================================  TO0  ========================================================== */
#define TM8_TO0_TO00_Pos                  (0UL)                     /*!< TM8 TO0: TO00 (Bit 0)                                 */
#define TM8_TO0_TO00_Msk                  (0x1UL)                   /*!< TM8 TO0: TO00 (Bitfield-Mask: 0x01)                   */
#define TM8_TO0_TO01_Pos                  (1UL)                     /*!< TM8 TO0: TO01 (Bit 1)                                 */
#define TM8_TO0_TO01_Msk                  (0x2UL)                   /*!< TM8 TO0: TO01 (Bitfield-Mask: 0x01)                   */
#define TM8_TO0_TO02_Pos                  (2UL)                     /*!< TM8 TO0: TO02 (Bit 2)                                 */
#define TM8_TO0_TO02_Msk                  (0x4UL)                   /*!< TM8 TO0: TO02 (Bitfield-Mask: 0x01)                   */
#define TM8_TO0_TO03_Pos                  (3UL)                     /*!< TM8 TO0: TO03 (Bit 3)                                 */
#define TM8_TO0_TO03_Msk                  (0x8UL)                   /*!< TM8 TO0: TO03 (Bitfield-Mask: 0x01)                   */
#define TM8_TO0_TO04_Pos                  (4UL)                     /*!< TM8 TO0: TO04 (Bit 4)                                 */
#define TM8_TO0_TO04_Msk                  (0x10UL)                  /*!< TM8 TO0: TO04 (Bitfield-Mask: 0x01)                   */
#define TM8_TO0_TO05_Pos                  (5UL)                     /*!< TM8 TO0: TO05 (Bit 5)                                 */
#define TM8_TO0_TO05_Msk                  (0x20UL)                  /*!< TM8 TO0: TO05 (Bitfield-Mask: 0x01)                   */
#define TM8_TO0_TO06_Pos                  (6UL)                     /*!< TM8 TO0: TO06 (Bit 6)                                 */
#define TM8_TO0_TO06_Msk                  (0x40UL)                  /*!< TM8 TO0: TO06 (Bitfield-Mask: 0x01)                   */
#define TM8_TO0_TO07_Pos                  (7UL)                     /*!< TM8 TO0: TO07 (Bit 7)                                 */
#define TM8_TO0_TO07_Msk                  (0x80UL)                  /*!< TM8 TO0: TO07 (Bitfield-Mask: 0x01)                   */
/* =========================================================  TOE0  ========================================================== */
#define TM8_TOE0_TOE00_Pos                (0UL)                     /*!< TM8 TOE0: TOE00 (Bit 0)                               */
#define TM8_TOE0_TOE00_Msk                (0x1UL)                   /*!< TM8 TOE0: TOE00 (Bitfield-Mask: 0x01)                 */
#define TM8_TOE0_TOE01_Pos                (1UL)                     /*!< TM8 TOE0: TOE01 (Bit 1)                               */
#define TM8_TOE0_TOE01_Msk                (0x2UL)                   /*!< TM8 TOE0: TOE01 (Bitfield-Mask: 0x01)                 */
#define TM8_TOE0_TOE02_Pos                (2UL)                     /*!< TM8 TOE0: TOE02 (Bit 2)                               */
#define TM8_TOE0_TOE02_Msk                (0x4UL)                   /*!< TM8 TOE0: TOE02 (Bitfield-Mask: 0x01)                 */
#define TM8_TOE0_TOE03_Pos                (3UL)                     /*!< TM8 TOE0: TOE03 (Bit 3)                               */
#define TM8_TOE0_TOE03_Msk                (0x8UL)                   /*!< TM8 TOE0: TOE03 (Bitfield-Mask: 0x01)                 */
#define TM8_TOE0_TOE04_Pos                (4UL)                     /*!< TM8 TOE0: TOE04 (Bit 4)                               */
#define TM8_TOE0_TOE04_Msk                (0x10UL)                  /*!< TM8 TOE0: TOE04 (Bitfield-Mask: 0x01)                 */
#define TM8_TOE0_TOE05_Pos                (5UL)                     /*!< TM8 TOE0: TOE05 (Bit 5)                               */
#define TM8_TOE0_TOE05_Msk                (0x20UL)                  /*!< TM8 TOE0: TOE05 (Bitfield-Mask: 0x01)                 */
#define TM8_TOE0_TOE06_Pos                (6UL)                     /*!< TM8 TOE0: TOE06 (Bit 6)                               */
#define TM8_TOE0_TOE06_Msk                (0x40UL)                  /*!< TM8 TOE0: TOE06 (Bitfield-Mask: 0x01)                 */
#define TM8_TOE0_TOE07_Pos                (7UL)                     /*!< TM8 TOE0: TOE07 (Bit 7)                               */
#define TM8_TOE0_TOE07_Msk                (0x80UL)                  /*!< TM8 TOE0: TOE07 (Bitfield-Mask: 0x01)                 */
/* =========================================================  TOL0  ========================================================== */
#define TM8_TOL0_TOL01_Pos                (1UL)                     /*!< TM8 TOL0: TOL01 (Bit 1)                               */
#define TM8_TOL0_TOL01_Msk                (0x2UL)                   /*!< TM8 TOL0: TOL01 (Bitfield-Mask: 0x01)                 */
#define TM8_TOL0_TOL02_Pos                (2UL)                     /*!< TM8 TOL0: TOL02 (Bit 2)                               */
#define TM8_TOL0_TOL02_Msk                (0x4UL)                   /*!< TM8 TOL0: TOL02 (Bitfield-Mask: 0x01)                 */
#define TM8_TOL0_TOL03_Pos                (3UL)                     /*!< TM8 TOL0: TOL03 (Bit 3)                               */
#define TM8_TOL0_TOL03_Msk                (0x8UL)                   /*!< TM8 TOL0: TOL03 (Bitfield-Mask: 0x01)                 */
#define TM8_TOL0_TOL04_Pos                (4UL)                     /*!< TM8 TOL0: TOL04 (Bit 4)                               */
#define TM8_TOL0_TOL04_Msk                (0x10UL)                  /*!< TM8 TOL0: TOL04 (Bitfield-Mask: 0x01)                 */
#define TM8_TOL0_TOL05_Pos                (5UL)                     /*!< TM8 TOL0: TOL05 (Bit 5)                               */
#define TM8_TOL0_TOL05_Msk                (0x20UL)                  /*!< TM8 TOL0: TOL05 (Bitfield-Mask: 0x01)                 */
#define TM8_TOL0_TOL06_Pos                (6UL)                     /*!< TM8 TOL0: TOL06 (Bit 6)                               */
#define TM8_TOL0_TOL06_Msk                (0x40UL)                  /*!< TM8 TOL0: TOL06 (Bitfield-Mask: 0x01)                 */
#define TM8_TOL0_TOL07_Pos                (7UL)                     /*!< TM8 TOL0: TOL07 (Bit 7)                               */
#define TM8_TOL0_TOL07_Msk                (0x80UL)                  /*!< TM8 TOL0: TOL07 (Bitfield-Mask: 0x01)                 */
/* =========================================================  TOM0  ========================================================== */
#define TM8_TOM0_TOM01_Pos                (1UL)                     /*!< TM8 TOM0: TOM01 (Bit 1)                               */
#define TM8_TOM0_TOM01_Msk                (0x2UL)                   /*!< TM8 TOM0: TOM01 (Bitfield-Mask: 0x01)                 */
#define TM8_TOM0_TOM02_Pos                (2UL)                     /*!< TM8 TOM0: TOM02 (Bit 2)                               */
#define TM8_TOM0_TOM02_Msk                (0x4UL)                   /*!< TM8 TOM0: TOM02 (Bitfield-Mask: 0x01)                 */
#define TM8_TOM0_TOM03_Pos                (3UL)                     /*!< TM8 TOM0: TOM03 (Bit 3)                               */
#define TM8_TOM0_TOM03_Msk                (0x8UL)                   /*!< TM8 TOM0: TOM03 (Bitfield-Mask: 0x01)                 */
#define TM8_TOM0_TOM04_Pos                (4UL)                     /*!< TM8 TOM0: TOM04 (Bit 4)                               */
#define TM8_TOM0_TOM04_Msk                (0x10UL)                  /*!< TM8 TOM0: TOM04 (Bitfield-Mask: 0x01)                 */
#define TM8_TOM0_TOM05_Pos                (5UL)                     /*!< TM8 TOM0: TOM05 (Bit 5)                               */
#define TM8_TOM0_TOM05_Msk                (0x20UL)                  /*!< TM8 TOM0: TOM05 (Bitfield-Mask: 0x01)                 */
#define TM8_TOM0_TOM06_Pos                (6UL)                     /*!< TM8 TOM0: TOM06 (Bit 6)                               */
#define TM8_TOM0_TOM06_Msk                (0x40UL)                  /*!< TM8 TOM0: TOM06 (Bitfield-Mask: 0x01)                 */
#define TM8_TOM0_TOM07_Pos                (7UL)                     /*!< TM8 TOM0: TOM07 (Bit 7)                               */
#define TM8_TOM0_TOM07_Msk                (0x80UL)                  /*!< TM8 TOM0: TOM07 (Bitfield-Mask: 0x01)                 */
/* =========================================================  TDR00  ========================================================= */
/* =========================================================  TDR01  ========================================================= */
/* =========================================================  TDR02  ========================================================= */
/* =========================================================  TDR03  ========================================================= */
/* =========================================================  TDR04  ========================================================= */
/* =========================================================  TDR05  ========================================================= */
/* =========================================================  TDR06  ========================================================= */
/* =========================================================  TDR07  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            TMA                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TACR0  ========================================================= */
#define TMA_TACR0_TSTART_Pos              (0UL)                     /*!< TMA TACR0: TSTART (Bit 0)                             */
#define TMA_TACR0_TSTART_Msk              (0x1UL)                   /*!< TMA TACR0: TSTART (Bitfield-Mask: 0x01)               */
#define TMA_TACR0_TCSTF_Pos               (1UL)                     /*!< TMA TACR0: TCSTF (Bit 1)                              */
#define TMA_TACR0_TCSTF_Msk               (0x2UL)                   /*!< TMA TACR0: TCSTF (Bitfield-Mask: 0x01)                */
#define TMA_TACR0_TSTOP_Pos               (2UL)                     /*!< TMA TACR0: TSTOP (Bit 2)                              */
#define TMA_TACR0_TSTOP_Msk               (0x4UL)                   /*!< TMA TACR0: TSTOP (Bitfield-Mask: 0x01)                */
#define TMA_TACR0_TEDGF_Pos               (4UL)                     /*!< TMA TACR0: TEDGF (Bit 4)                              */
#define TMA_TACR0_TEDGF_Msk               (0x10UL)                  /*!< TMA TACR0: TEDGF (Bitfield-Mask: 0x01)                */
#define TMA_TACR0_TUNDF_Pos               (5UL)                     /*!< TMA TACR0: TUNDF (Bit 5)                              */
#define TMA_TACR0_TUNDF_Msk               (0x20UL)                  /*!< TMA TACR0: TUNDF (Bitfield-Mask: 0x01)                */
/* ========================================================  TAIOC0  ========================================================= */
#define TMA_TAIOC0_TEDGSEL_Pos            (0UL)                     /*!< TMA TAIOC0: TEDGSEL (Bit 0)                           */
#define TMA_TAIOC0_TEDGSEL_Msk            (0x1UL)                   /*!< TMA TAIOC0: TEDGSEL (Bitfield-Mask: 0x01)             */
#define TMA_TAIOC0_TOENA_Pos              (2UL)                     /*!< TMA TAIOC0: TOENA (Bit 2)                             */
#define TMA_TAIOC0_TOENA_Msk              (0x4UL)                   /*!< TMA TAIOC0: TOENA (Bitfield-Mask: 0x01)               */
#define TMA_TAIOC0_TIPF_Pos               (4UL)                     /*!< TMA TAIOC0: TIPF (Bit 4)                              */
#define TMA_TAIOC0_TIPF_Msk               (0x30UL)                  /*!< TMA TAIOC0: TIPF (Bitfield-Mask: 0x03)                */
#define TMA_TAIOC0_TIOGT_Pos              (6UL)                     /*!< TMA TAIOC0: TIOGT (Bit 6)                             */
#define TMA_TAIOC0_TIOGT_Msk              (0xc0UL)                  /*!< TMA TAIOC0: TIOGT (Bitfield-Mask: 0x03)               */
/* =========================================================  TAMR0  ========================================================= */
#define TMA_TAMR0_TMOD_Pos                (0UL)                     /*!< TMA TAMR0: TMOD (Bit 0)                               */
#define TMA_TAMR0_TMOD_Msk                (0x7UL)                   /*!< TMA TAMR0: TMOD (Bitfield-Mask: 0x07)                 */
#define TMA_TAMR0_TEDGPL_Pos              (3UL)                     /*!< TMA TAMR0: TEDGPL (Bit 3)                             */
#define TMA_TAMR0_TEDGPL_Msk              (0x8UL)                   /*!< TMA TAMR0: TEDGPL (Bitfield-Mask: 0x01)               */
#define TMA_TAMR0_TCK0_Pos                (4UL)                     /*!< TMA TAMR0: TCK0 (Bit 4)                               */
#define TMA_TAMR0_TCK0_Msk                (0x70UL)                  /*!< TMA TAMR0: TCK0 (Bitfield-Mask: 0x07)                 */
/* ========================================================  TAISR0  ========================================================= */
#define TMA_TAISR0_RCCPSEL_Pos            (0UL)                     /*!< TMA TAISR0: RCCPSEL (Bit 0)                           */
#define TMA_TAISR0_RCCPSEL_Msk            (0x7UL)                   /*!< TMA TAISR0: RCCPSEL (Bitfield-Mask: 0x07)             */
/* ==========================================================  TA0  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            RTC                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  SUBCUD  ========================================================= */
#define RTC_SUBCUD_F_Pos                  (0UL)                     /*!< RTC SUBCUD: F (Bit 0)                                 */
#define RTC_SUBCUD_F_Msk                  (0x1fffUL)                /*!< RTC SUBCUD: F (Bitfield-Mask: 0x1fff)                 */
#define RTC_SUBCUD_DEV_Pos                (15UL)                    /*!< RTC SUBCUD: DEV (Bit 15)                              */
#define RTC_SUBCUD_DEV_Msk                (0x8000UL)                /*!< RTC SUBCUD: DEV (Bitfield-Mask: 0x01)                 */
/* =========================================================  ITMC  ========================================================== */
#define RTC_ITMC_ITCMP_Pos                (0UL)                     /*!< RTC ITMC: ITCMP (Bit 0)                               */
#define RTC_ITMC_ITCMP_Msk                (0x7fffUL)                /*!< RTC ITMC: ITCMP (Bitfield-Mask: 0x7fff)               */
#define RTC_ITMC_RINTE_Pos                (15UL)                    /*!< RTC ITMC: RINTE (Bit 15)                              */
#define RTC_ITMC_RINTE_Msk                (0x8000UL)                /*!< RTC ITMC: RINTE (Bitfield-Mask: 0x01)                 */
/* ==========================================================  SEC  ========================================================== */
/* ==========================================================  MIN  ========================================================== */
/* =========================================================  HOUR  ========================================================== */
/* =========================================================  WEEK  ========================================================== */
/* ==========================================================  DAY  ========================================================== */
/* =========================================================  MONTH  ========================================================= */
/* =========================================================  YEAR  ========================================================== */
/* ========================================================  ALARMWM  ======================================================== */
/* ========================================================  ALARMWH  ======================================================== */
/* ========================================================  ALARMWW  ======================================================== */
/* =========================================================  RTCC0  ========================================================= */
#define RTC_RTCC0_CT_Pos                  (0UL)                     /*!< RTC RTCC0: CT (Bit 0)                                 */
#define RTC_RTCC0_CT_Msk                  (0x7UL)                   /*!< RTC RTCC0: CT (Bitfield-Mask: 0x07)                   */
#define RTC_RTCC0_AMPM_Pos                (3UL)                     /*!< RTC RTCC0: AMPM (Bit 3)                               */
#define RTC_RTCC0_AMPM_Msk                (0x8UL)                   /*!< RTC RTCC0: AMPM (Bitfield-Mask: 0x01)                 */
#define RTC_RTCC0_RCLOE1_Pos              (5UL)                     /*!< RTC RTCC0: RCLOE1 (Bit 5)                             */
#define RTC_RTCC0_RCLOE1_Msk              (0x20UL)                  /*!< RTC RTCC0: RCLOE1 (Bitfield-Mask: 0x01)               */
#define RTC_RTCC0_RTCE_Pos                (7UL)                     /*!< RTC RTCC0: RTCE (Bit 7)                               */
#define RTC_RTCC0_RTCE_Msk                (0x80UL)                  /*!< RTC RTCC0: RTCE (Bitfield-Mask: 0x01)                 */
/* =========================================================  RTCC1  ========================================================= */
#define RTC_RTCC1_RWAIT_Pos               (0UL)                     /*!< RTC RTCC1: RWAIT (Bit 0)                              */
#define RTC_RTCC1_RWAIT_Msk               (0x1UL)                   /*!< RTC RTCC1: RWAIT (Bitfield-Mask: 0x01)                */
#define RTC_RTCC1_RWST_Pos                (1UL)                     /*!< RTC RTCC1: RWST (Bit 1)                               */
#define RTC_RTCC1_RWST_Msk                (0x2UL)                   /*!< RTC RTCC1: RWST (Bitfield-Mask: 0x01)                 */
#define RTC_RTCC1_RIFG_Pos                (3UL)                     /*!< RTC RTCC1: RIFG (Bit 3)                               */
#define RTC_RTCC1_RIFG_Msk                (0x8UL)                   /*!< RTC RTCC1: RIFG (Bitfield-Mask: 0x01)                 */
#define RTC_RTCC1_WAFG_Pos                (4UL)                     /*!< RTC RTCC1: WAFG (Bit 4)                               */
#define RTC_RTCC1_WAFG_Msk                (0x10UL)                  /*!< RTC RTCC1: WAFG (Bitfield-Mask: 0x01)                 */
#define RTC_RTCC1_WALIE_Pos               (6UL)                     /*!< RTC RTCC1: WALIE (Bit 6)                              */
#define RTC_RTCC1_WALIE_Msk               (0x40UL)                  /*!< RTC RTCC1: WALIE (Bitfield-Mask: 0x01)                */
#define RTC_RTCC1_WALE_Pos                (7UL)                     /*!< RTC RTCC1: WALE (Bit 7)                               */
#define RTC_RTCC1_WALE_Msk                (0x80UL)                  /*!< RTC RTCC1: WALE (Bitfield-Mask: 0x01)                 */


/* =========================================================================================================================== */
/* ================                                           PCBZ                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  CKS0  ========================================================== */
#define PCBZ_CKS0_CCS_Pos                 (0UL)                     /*!< PCBZ CKS0: CCS (Bit 0)                                */
#define PCBZ_CKS0_CCS_Msk                 (0x7UL)                   /*!< PCBZ CKS0: CCS (Bitfield-Mask: 0x07)                  */
#define PCBZ_CKS0_CSEL_Pos                (3UL)                     /*!< PCBZ CKS0: CSEL (Bit 3)                               */
#define PCBZ_CKS0_CSEL_Msk                (0x8UL)                   /*!< PCBZ CKS0: CSEL (Bitfield-Mask: 0x01)                 */
#define PCBZ_CKS0_PCLOE_Pos               (7UL)                     /*!< PCBZ CKS0: PCLOE (Bit 7)                              */
#define PCBZ_CKS0_PCLOE_Msk               (0x80UL)                  /*!< PCBZ CKS0: PCLOE (Bitfield-Mask: 0x01)                */
/* =========================================================  CKS1  ========================================================== */
#define PCBZ_CKS1_CCS_Pos                 (0UL)                     /*!< PCBZ CKS1: CCS (Bit 0)                                */
#define PCBZ_CKS1_CCS_Msk                 (0x7UL)                   /*!< PCBZ CKS1: CCS (Bitfield-Mask: 0x07)                  */
#define PCBZ_CKS1_CSEL_Pos                (3UL)                     /*!< PCBZ CKS1: CSEL (Bit 3)                               */
#define PCBZ_CKS1_CSEL_Msk                (0x8UL)                   /*!< PCBZ CKS1: CSEL (Bitfield-Mask: 0x01)                 */
#define PCBZ_CKS1_PCLOE_Pos               (7UL)                     /*!< PCBZ CKS1: PCLOE (Bit 7)                              */
#define PCBZ_CKS1_PCLOE_Msk               (0x80UL)                  /*!< PCBZ CKS1: PCLOE (Bitfield-Mask: 0x01)                */


/* =========================================================================================================================== */
/* ================                                            WDT                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  LOCKCTL  ======================================================== */
/* =========================================================  PRCR  ========================================================== */
/* ========================================================  WDTCFG0  ======================================================== */
/* ========================================================  WDTCFG1  ======================================================== */
/* ========================================================  WDTCFG2  ======================================================== */
/* ========================================================  WDTCFG3  ======================================================== */
/* =========================================================  WDTE  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            ADC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  ADM0  ========================================================== */
#define ADC_ADM0_ADCE_Pos                 (0UL)                     /*!< ADC ADM0: ADCE (Bit 0)                                */
#define ADC_ADM0_ADCE_Msk                 (0x1UL)                   /*!< ADC ADM0: ADCE (Bitfield-Mask: 0x01)                  */
#define ADC_ADM0_FR_Pos                   (3UL)                     /*!< ADC ADM0: FR (Bit 3)                                  */
#define ADC_ADM0_FR_Msk                   (0x38UL)                  /*!< ADC ADM0: FR (Bitfield-Mask: 0x07)                    */
#define ADC_ADM0_ADCS_Pos                 (7UL)                     /*!< ADC ADM0: ADCS (Bit 7)                                */
#define ADC_ADM0_ADCS_Msk                 (0x80UL)                  /*!< ADC ADM0: ADCS (Bitfield-Mask: 0x01)                  */
/* =========================================================  ADM1  ========================================================== */
#define ADC_ADM1_ADMODE_Pos               (0UL)                     /*!< ADC ADM1: ADMODE (Bit 0)                              */
#define ADC_ADM1_ADMODE_Msk               (0x3UL)                   /*!< ADC ADM1: ADMODE (Bitfield-Mask: 0x03)                */
#define ADC_ADM1_ADSCM_Pos                (3UL)                     /*!< ADC ADM1: ADSCM (Bit 3)                               */
#define ADC_ADM1_ADSCM_Msk                (0x8UL)                   /*!< ADC ADM1: ADSCM (Bitfield-Mask: 0x01)                 */
#define ADC_ADM1_SMODE_Pos                (5UL)                     /*!< ADC ADM1: SMODE (Bit 5)                               */
#define ADC_ADM1_SMODE_Msk                (0x60UL)                  /*!< ADC ADM1: SMODE (Bitfield-Mask: 0x03)                 */
#define ADC_ADM1_ADMD_Pos                 (7UL)                     /*!< ADC ADM1: ADMD (Bit 7)                                */
#define ADC_ADM1_ADMD_Msk                 (0x80UL)                  /*!< ADC ADM1: ADMD (Bitfield-Mask: 0x01)                  */
/* =========================================================  ADM2  ========================================================== */
#define ADC_ADM2_CHRDE_Pos                (1UL)                     /*!< ADC ADM2: CHRDE (Bit 1)                               */
#define ADC_ADM2_CHRDE_Msk                (0x2UL)                   /*!< ADC ADM2: CHRDE (Bitfield-Mask: 0x01)                 */
#define ADC_ADM2_ADRCK_Pos                (3UL)                     /*!< ADC ADM2: ADRCK (Bit 3)                               */
#define ADC_ADM2_ADRCK_Msk                (0x8UL)                   /*!< ADC ADM2: ADRCK (Bitfield-Mask: 0x01)                 */
#define ADC_ADM2_ADREFM_Pos               (5UL)                     /*!< ADC ADM2: ADREFM (Bit 5)                              */
#define ADC_ADM2_ADREFM_Msk               (0x20UL)                  /*!< ADC ADM2: ADREFM (Bitfield-Mask: 0x01)                */
#define ADC_ADM2_ADREFP_Pos               (6UL)                     /*!< ADC ADM2: ADREFP (Bit 6)                              */
#define ADC_ADM2_ADREFP_Msk               (0xc0UL)                  /*!< ADC ADM2: ADREFP (Bitfield-Mask: 0x03)                */
/* =========================================================  ADTRG  ========================================================= */
#define ADC_ADTRG_ADTRS_Pos               (0UL)                     /*!< ADC ADTRG: ADTRS (Bit 0)                              */
#define ADC_ADTRG_ADTRS_Msk               (0x3UL)                   /*!< ADC ADTRG: ADTRS (Bitfield-Mask: 0x03)                */
#define ADC_ADTRG_ADTMD_Pos               (6UL)                     /*!< ADC ADTRG: ADTMD (Bit 6)                              */
#define ADC_ADTRG_ADTMD_Msk               (0xc0UL)                  /*!< ADC ADTRG: ADTMD (Bitfield-Mask: 0x03)                */
/* ==========================================================  ADS  ========================================================== */
/* =========================================================  ADLL  ========================================================== */
/* =========================================================  ADUL  ========================================================== */
/* ========================================================  ADNSMP  ========================================================= */
/* =========================================================  ADCR  ========================================================== */
/* =========================================================  ADCRH  ========================================================= */
/* =========================================================  ADTES  ========================================================= */
/* ========================================================  ADNDIS  ========================================================= */
/* =======================================================  ADSMPWAIT  ======================================================= */


/* =========================================================================================================================== */
/* ================                                            DAC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  DACS0  ========================================================= */
#define DAC_DACS0_DACS0_Pos               (0UL)                     /*!< DAC DACS0: DACS0 (Bit 0)                              */
#define DAC_DACS0_DACS0_Msk               (0xffUL)                  /*!< DAC DACS0: DACS0 (Bitfield-Mask: 0xff)                */
/* ==========================================================  DAM  ========================================================== */
#define DAC_DAM_DAMD0_Pos                 (0UL)                     /*!< DAC DAM: DAMD0 (Bit 0)                                */
#define DAC_DAM_DAMD0_Msk                 (0x1UL)                   /*!< DAC DAM: DAMD0 (Bitfield-Mask: 0x01)                  */
#define DAC_DAM_DACE0_Pos                 (4UL)                     /*!< DAC DAM: DACE0 (Bit 4)                                */
#define DAC_DAM_DACE0_Msk                 (0x10UL)                  /*!< DAC DAM: DACE0 (Bitfield-Mask: 0x01)                  */


/* =========================================================================================================================== */
/* ================                                            CMP                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  COMPMDR  ======================================================== */
#define CMP_COMPMDR_C0ENB_Pos             (0UL)                     /*!< CMP COMPMDR: C0ENB (Bit 0)                            */
#define CMP_COMPMDR_C0ENB_Msk             (0x1UL)                   /*!< CMP COMPMDR: C0ENB (Bitfield-Mask: 0x01)              */
#define CMP_COMPMDR_C0MON_Pos             (3UL)                     /*!< CMP COMPMDR: C0MON (Bit 3)                            */
#define CMP_COMPMDR_C0MON_Msk             (0x8UL)                   /*!< CMP COMPMDR: C0MON (Bitfield-Mask: 0x01)              */
#define CMP_COMPMDR_C1ENB_Pos             (4UL)                     /*!< CMP COMPMDR: C1ENB (Bit 4)                            */
#define CMP_COMPMDR_C1ENB_Msk             (0x10UL)                  /*!< CMP COMPMDR: C1ENB (Bitfield-Mask: 0x01)              */
#define CMP_COMPMDR_C1MON_Pos             (7UL)                     /*!< CMP COMPMDR: C1MON (Bit 7)                            */
#define CMP_COMPMDR_C1MON_Msk             (0x80UL)                  /*!< CMP COMPMDR: C1MON (Bitfield-Mask: 0x01)              */
/* ========================================================  COMPFIR  ======================================================== */
#define CMP_COMPFIR_C0FCK_Pos             (0UL)                     /*!< CMP COMPFIR: C0FCK (Bit 0)                            */
#define CMP_COMPFIR_C0FCK_Msk             (0x3UL)                   /*!< CMP COMPFIR: C0FCK (Bitfield-Mask: 0x03)              */
#define CMP_COMPFIR_C0EPO_Pos             (2UL)                     /*!< CMP COMPFIR: C0EPO (Bit 2)                            */
#define CMP_COMPFIR_C0EPO_Msk             (0x4UL)                   /*!< CMP COMPFIR: C0EPO (Bitfield-Mask: 0x01)              */
#define CMP_COMPFIR_C0EDG_Pos             (3UL)                     /*!< CMP COMPFIR: C0EDG (Bit 3)                            */
#define CMP_COMPFIR_C0EDG_Msk             (0x8UL)                   /*!< CMP COMPFIR: C0EDG (Bitfield-Mask: 0x01)              */
#define CMP_COMPFIR_C1FCK_Pos             (4UL)                     /*!< CMP COMPFIR: C1FCK (Bit 4)                            */
#define CMP_COMPFIR_C1FCK_Msk             (0x30UL)                  /*!< CMP COMPFIR: C1FCK (Bitfield-Mask: 0x03)              */
#define CMP_COMPFIR_C1EPO_Pos             (6UL)                     /*!< CMP COMPFIR: C1EPO (Bit 6)                            */
#define CMP_COMPFIR_C1EPO_Msk             (0x40UL)                  /*!< CMP COMPFIR: C1EPO (Bitfield-Mask: 0x01)              */
#define CMP_COMPFIR_C1EDG_Pos             (7UL)                     /*!< CMP COMPFIR: C1EDG (Bit 7)                            */
#define CMP_COMPFIR_C1EDG_Msk             (0x80UL)                  /*!< CMP COMPFIR: C1EDG (Bitfield-Mask: 0x01)              */
/* ========================================================  COMPOCR  ======================================================== */
#define CMP_COMPOCR_C0IE_Pos              (0UL)                     /*!< CMP COMPOCR: C0IE (Bit 0)                             */
#define CMP_COMPOCR_C0IE_Msk              (0x1UL)                   /*!< CMP COMPOCR: C0IE (Bitfield-Mask: 0x01)               */
#define CMP_COMPOCR_C0OE_Pos              (1UL)                     /*!< CMP COMPOCR: C0OE (Bit 1)                             */
#define CMP_COMPOCR_C0OE_Msk              (0x2UL)                   /*!< CMP COMPOCR: C0OE (Bitfield-Mask: 0x01)               */
#define CMP_COMPOCR_C0OP_Pos              (2UL)                     /*!< CMP COMPOCR: C0OP (Bit 2)                             */
#define CMP_COMPOCR_C0OP_Msk              (0x4UL)                   /*!< CMP COMPOCR: C0OP (Bitfield-Mask: 0x01)               */
#define CMP_COMPOCR_C1IE_Pos              (4UL)                     /*!< CMP COMPOCR: C1IE (Bit 4)                             */
#define CMP_COMPOCR_C1IE_Msk              (0x10UL)                  /*!< CMP COMPOCR: C1IE (Bitfield-Mask: 0x01)               */
#define CMP_COMPOCR_C1OE_Pos              (5UL)                     /*!< CMP COMPOCR: C1OE (Bit 5)                             */
#define CMP_COMPOCR_C1OE_Msk              (0x20UL)                  /*!< CMP COMPOCR: C1OE (Bitfield-Mask: 0x01)               */
#define CMP_COMPOCR_C1OP_Pos              (6UL)                     /*!< CMP COMPOCR: C1OP (Bit 6)                             */
#define CMP_COMPOCR_C1OP_Msk              (0x40UL)                  /*!< CMP COMPOCR: C1OP (Bitfield-Mask: 0x01)               */
#define CMP_COMPOCR_C1OTWMD_Pos           (7UL)                     /*!< CMP COMPOCR: C1OTWMD (Bit 7)                          */
#define CMP_COMPOCR_C1OTWMD_Msk           (0x80UL)                  /*!< CMP COMPOCR: C1OTWMD (Bitfield-Mask: 0x01)            */
/* ========================================================  C0REFS  ========================================================= */
/* ========================================================  C1REFS  ========================================================= */
/* ========================================================  CMPSEL0  ======================================================== */
/* ========================================================  CMPSEL1  ======================================================== */
/* ========================================================  CMP0HY  ========================================================= */
#define CMP_CMP0HY_C0HYSLS_Pos            (0UL)                     /*!< CMP CMP0HY: C0HYSLS (Bit 0)                           */
#define CMP_CMP0HY_C0HYSLS_Msk            (0x3UL)                   /*!< CMP CMP0HY: C0HYSLS (Bitfield-Mask: 0x03)             */
#define CMP_CMP0HY_C0HYSVS_Pos            (4UL)                     /*!< CMP CMP0HY: C0HYSVS (Bit 4)                           */
#define CMP_CMP0HY_C0HYSVS_Msk            (0x30UL)                  /*!< CMP CMP0HY: C0HYSVS (Bitfield-Mask: 0x03)             */
/* ========================================================  CMP1HY  ========================================================= */
#define CMP_CMP1HY_C1HYSLS_Pos            (0UL)                     /*!< CMP CMP1HY: C1HYSLS (Bit 0)                           */
#define CMP_CMP1HY_C1HYSLS_Msk            (0x3UL)                   /*!< CMP CMP1HY: C1HYSLS (Bitfield-Mask: 0x03)             */
#define CMP_CMP1HY_C1HYSVS_Pos            (4UL)                     /*!< CMP CMP1HY: C1HYSVS (Bit 4)                           */
#define CMP_CMP1HY_C1HYSVS_Msk            (0x30UL)                  /*!< CMP CMP1HY: C1HYSVS (Bitfield-Mask: 0x03)             */


/* =========================================================================================================================== */
/* ================                                            OPA                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  OPACTL  ========================================================= */
#define OPA_OPACTL_INPSEL_Pos             (2UL)                     /*!< OPA OPACTL: INPSEL (Bit 2)                            */
#define OPA_OPACTL_INPSEL_Msk             (0x4UL)                   /*!< OPA OPACTL: INPSEL (Bitfield-Mask: 0x01)              */
#define OPA_OPACTL_OPAMODE_Pos            (4UL)                     /*!< OPA OPACTL: OPAMODE (Bit 4)                           */
#define OPA_OPACTL_OPAMODE_Msk            (0x10UL)                  /*!< OPA OPACTL: OPAMODE (Bitfield-Mask: 0x01)             */
#define OPA_OPACTL_RPDMODE_Pos            (5UL)                     /*!< OPA OPACTL: RPDMODE (Bit 5)                           */
#define OPA_OPACTL_RPDMODE_Msk            (0x20UL)                  /*!< OPA OPACTL: RPDMODE (Bitfield-Mask: 0x01)             */
#define OPA_OPACTL_OPAEN_Pos              (7UL)                     /*!< OPA OPACTL: OPAEN (Bit 7)                             */
#define OPA_OPACTL_OPAEN_Msk              (0x80UL)                  /*!< OPA OPACTL: OPAEN (Bitfield-Mask: 0x01)               */
/* ========================================================  OPADAC  ========================================================= */
#define OPA_OPADAC_OPADAO_Pos             (0UL)                     /*!< OPA OPADAC: OPADAO (Bit 0)                            */
#define OPA_OPADAC_OPADAO_Msk             (0x1fUL)                  /*!< OPA OPADAC: OPADAO (Bitfield-Mask: 0x1f)              */
#define OPA_OPADAC_OPADAP_Pos             (7UL)                     /*!< OPA OPADAC: OPADAP (Bit 7)                            */
#define OPA_OPADAC_OPADAP_Msk             (0x80UL)                  /*!< OPA OPADAC: OPADAP (Bitfield-Mask: 0x01)              */


/* =========================================================================================================================== */
/* ================                                           SCI0                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR00  ========================================================= */
#define SCI0_SSR00_OVF_Pos                (0UL)                     /*!< SCI0 SSR00: OVF (Bit 0)                               */
#define SCI0_SSR00_OVF_Msk                (0x1UL)                   /*!< SCI0 SSR00: OVF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR00_PEF_Pos                (1UL)                     /*!< SCI0 SSR00: PEF (Bit 1)                               */
#define SCI0_SSR00_PEF_Msk                (0x2UL)                   /*!< SCI0 SSR00: PEF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR00_FEF_Pos                (2UL)                     /*!< SCI0 SSR00: FEF (Bit 2)                               */
#define SCI0_SSR00_FEF_Msk                (0x4UL)                   /*!< SCI0 SSR00: FEF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR00_BFF_Pos                (5UL)                     /*!< SCI0 SSR00: BFF (Bit 5)                               */
#define SCI0_SSR00_BFF_Msk                (0x20UL)                  /*!< SCI0 SSR00: BFF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR00_TSF_Pos                (6UL)                     /*!< SCI0 SSR00: TSF (Bit 6)                               */
#define SCI0_SSR00_TSF_Msk                (0x40UL)                  /*!< SCI0 SSR00: TSF (Bitfield-Mask: 0x01)                 */
/* =========================================================  SSR01  ========================================================= */
#define SCI0_SSR01_OVF_Pos                (0UL)                     /*!< SCI0 SSR01: OVF (Bit 0)                               */
#define SCI0_SSR01_OVF_Msk                (0x1UL)                   /*!< SCI0 SSR01: OVF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR01_PEF_Pos                (1UL)                     /*!< SCI0 SSR01: PEF (Bit 1)                               */
#define SCI0_SSR01_PEF_Msk                (0x2UL)                   /*!< SCI0 SSR01: PEF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR01_FEF_Pos                (2UL)                     /*!< SCI0 SSR01: FEF (Bit 2)                               */
#define SCI0_SSR01_FEF_Msk                (0x4UL)                   /*!< SCI0 SSR01: FEF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR01_BFF_Pos                (5UL)                     /*!< SCI0 SSR01: BFF (Bit 5)                               */
#define SCI0_SSR01_BFF_Msk                (0x20UL)                  /*!< SCI0 SSR01: BFF (Bitfield-Mask: 0x01)                 */
#define SCI0_SSR01_TSF_Pos                (6UL)                     /*!< SCI0 SSR01: TSF (Bit 6)                               */
#define SCI0_SSR01_TSF_Msk                (0x40UL)                  /*!< SCI0 SSR01: TSF (Bitfield-Mask: 0x01)                 */
/* =========================================================  SIR00  ========================================================= */
#define SCI0_SIR00_OVCT_Pos               (0UL)                     /*!< SCI0 SIR00: OVCT (Bit 0)                              */
#define SCI0_SIR00_OVCT_Msk               (0x1UL)                   /*!< SCI0 SIR00: OVCT (Bitfield-Mask: 0x01)                */
#define SCI0_SIR00_PECT_Pos               (1UL)                     /*!< SCI0 SIR00: PECT (Bit 1)                              */
#define SCI0_SIR00_PECT_Msk               (0x2UL)                   /*!< SCI0 SIR00: PECT (Bitfield-Mask: 0x01)                */
#define SCI0_SIR00_FECT_Pos               (2UL)                     /*!< SCI0 SIR00: FECT (Bit 2)                              */
#define SCI0_SIR00_FECT_Msk               (0x4UL)                   /*!< SCI0 SIR00: FECT (Bitfield-Mask: 0x01)                */
/* =========================================================  SIR01  ========================================================= */
#define SCI0_SIR01_OVCT_Pos               (0UL)                     /*!< SCI0 SIR01: OVCT (Bit 0)                              */
#define SCI0_SIR01_OVCT_Msk               (0x1UL)                   /*!< SCI0 SIR01: OVCT (Bitfield-Mask: 0x01)                */
#define SCI0_SIR01_PECT_Pos               (1UL)                     /*!< SCI0 SIR01: PECT (Bit 1)                              */
#define SCI0_SIR01_PECT_Msk               (0x2UL)                   /*!< SCI0 SIR01: PECT (Bitfield-Mask: 0x01)                */
#define SCI0_SIR01_FECT_Pos               (2UL)                     /*!< SCI0 SIR01: FECT (Bit 2)                              */
#define SCI0_SIR01_FECT_Msk               (0x4UL)                   /*!< SCI0 SIR01: FECT (Bitfield-Mask: 0x01)                */
/* =========================================================  SMR00  ========================================================= */
#define SCI0_SMR00_MD_Pos                 (0UL)                     /*!< SCI0 SMR00: MD (Bit 0)                                */
#define SCI0_SMR00_MD_Msk                 (0x7UL)                   /*!< SCI0 SMR00: MD (Bitfield-Mask: 0x07)                  */
#define SCI0_SMR00_SIS_Pos                (6UL)                     /*!< SCI0 SMR00: SIS (Bit 6)                               */
#define SCI0_SMR00_SIS_Msk                (0x40UL)                  /*!< SCI0 SMR00: SIS (Bitfield-Mask: 0x01)                 */
#define SCI0_SMR00_STS_Pos                (8UL)                     /*!< SCI0 SMR00: STS (Bit 8)                               */
#define SCI0_SMR00_STS_Msk                (0x100UL)                 /*!< SCI0 SMR00: STS (Bitfield-Mask: 0x01)                 */
#define SCI0_SMR00_CCS_Pos                (14UL)                    /*!< SCI0 SMR00: CCS (Bit 14)                              */
#define SCI0_SMR00_CCS_Msk                (0x4000UL)                /*!< SCI0 SMR00: CCS (Bitfield-Mask: 0x01)                 */
#define SCI0_SMR00_CKS_Pos                (15UL)                    /*!< SCI0 SMR00: CKS (Bit 15)                              */
#define SCI0_SMR00_CKS_Msk                (0x8000UL)                /*!< SCI0 SMR00: CKS (Bitfield-Mask: 0x01)                 */
/* =========================================================  SMR01  ========================================================= */
#define SCI0_SMR01_MD_Pos                 (0UL)                     /*!< SCI0 SMR01: MD (Bit 0)                                */
#define SCI0_SMR01_MD_Msk                 (0x7UL)                   /*!< SCI0 SMR01: MD (Bitfield-Mask: 0x07)                  */
#define SCI0_SMR01_SIS_Pos                (6UL)                     /*!< SCI0 SMR01: SIS (Bit 6)                               */
#define SCI0_SMR01_SIS_Msk                (0x40UL)                  /*!< SCI0 SMR01: SIS (Bitfield-Mask: 0x01)                 */
#define SCI0_SMR01_STS_Pos                (8UL)                     /*!< SCI0 SMR01: STS (Bit 8)                               */
#define SCI0_SMR01_STS_Msk                (0x100UL)                 /*!< SCI0 SMR01: STS (Bitfield-Mask: 0x01)                 */
#define SCI0_SMR01_CCS_Pos                (14UL)                    /*!< SCI0 SMR01: CCS (Bit 14)                              */
#define SCI0_SMR01_CCS_Msk                (0x4000UL)                /*!< SCI0 SMR01: CCS (Bitfield-Mask: 0x01)                 */
#define SCI0_SMR01_CKS_Pos                (15UL)                    /*!< SCI0 SMR01: CKS (Bit 15)                              */
#define SCI0_SMR01_CKS_Msk                (0x8000UL)                /*!< SCI0 SMR01: CKS (Bitfield-Mask: 0x01)                 */
/* =========================================================  SCR00  ========================================================= */
#define SCI0_SCR00_DLS_Pos                (0UL)                     /*!< SCI0 SCR00: DLS (Bit 0)                               */
#define SCI0_SCR00_DLS_Msk                (0xfUL)                   /*!< SCI0 SCR00: DLS (Bitfield-Mask: 0x0f)                 */
#define SCI0_SCR00_SLC_Pos                (4UL)                     /*!< SCI0 SCR00: SLC (Bit 4)                               */
#define SCI0_SCR00_SLC_Msk                (0x30UL)                  /*!< SCI0 SCR00: SLC (Bitfield-Mask: 0x03)                 */
#define SCI0_SCR00_DIR_Pos                (7UL)                     /*!< SCI0 SCR00: DIR (Bit 7)                               */
#define SCI0_SCR00_DIR_Msk                (0x80UL)                  /*!< SCI0 SCR00: DIR (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR00_PTC_Pos                (8UL)                     /*!< SCI0 SCR00: PTC (Bit 8)                               */
#define SCI0_SCR00_PTC_Msk                (0x300UL)                 /*!< SCI0 SCR00: PTC (Bitfield-Mask: 0x03)                 */
#define SCI0_SCR00_CKP_Pos                (12UL)                    /*!< SCI0 SCR00: CKP (Bit 12)                              */
#define SCI0_SCR00_CKP_Msk                (0x1000UL)                /*!< SCI0 SCR00: CKP (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR00_DAP_Pos                (13UL)                    /*!< SCI0 SCR00: DAP (Bit 13)                              */
#define SCI0_SCR00_DAP_Msk                (0x2000UL)                /*!< SCI0 SCR00: DAP (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR00_RXE_Pos                (14UL)                    /*!< SCI0 SCR00: RXE (Bit 14)                              */
#define SCI0_SCR00_RXE_Msk                (0x4000UL)                /*!< SCI0 SCR00: RXE (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR00_TXE_Pos                (15UL)                    /*!< SCI0 SCR00: TXE (Bit 15)                              */
#define SCI0_SCR00_TXE_Msk                (0x8000UL)                /*!< SCI0 SCR00: TXE (Bitfield-Mask: 0x01)                 */
/* =========================================================  SCR01  ========================================================= */
#define SCI0_SCR01_DLS_Pos                (0UL)                     /*!< SCI0 SCR01: DLS (Bit 0)                               */
#define SCI0_SCR01_DLS_Msk                (0xfUL)                   /*!< SCI0 SCR01: DLS (Bitfield-Mask: 0x0f)                 */
#define SCI0_SCR01_SLC_Pos                (4UL)                     /*!< SCI0 SCR01: SLC (Bit 4)                               */
#define SCI0_SCR01_SLC_Msk                (0x30UL)                  /*!< SCI0 SCR01: SLC (Bitfield-Mask: 0x03)                 */
#define SCI0_SCR01_DIR_Pos                (7UL)                     /*!< SCI0 SCR01: DIR (Bit 7)                               */
#define SCI0_SCR01_DIR_Msk                (0x80UL)                  /*!< SCI0 SCR01: DIR (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR01_PTC_Pos                (8UL)                     /*!< SCI0 SCR01: PTC (Bit 8)                               */
#define SCI0_SCR01_PTC_Msk                (0x300UL)                 /*!< SCI0 SCR01: PTC (Bitfield-Mask: 0x03)                 */
#define SCI0_SCR01_CKP_Pos                (12UL)                    /*!< SCI0 SCR01: CKP (Bit 12)                              */
#define SCI0_SCR01_CKP_Msk                (0x1000UL)                /*!< SCI0 SCR01: CKP (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR01_DAP_Pos                (13UL)                    /*!< SCI0 SCR01: DAP (Bit 13)                              */
#define SCI0_SCR01_DAP_Msk                (0x2000UL)                /*!< SCI0 SCR01: DAP (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR01_RXE_Pos                (14UL)                    /*!< SCI0 SCR01: RXE (Bit 14)                              */
#define SCI0_SCR01_RXE_Msk                (0x4000UL)                /*!< SCI0 SCR01: RXE (Bitfield-Mask: 0x01)                 */
#define SCI0_SCR01_TXE_Pos                (15UL)                    /*!< SCI0 SCR01: TXE (Bit 15)                              */
#define SCI0_SCR01_TXE_Msk                (0x8000UL)                /*!< SCI0 SCR01: TXE (Bitfield-Mask: 0x01)                 */
/* ==========================================================  SE0  ========================================================== */
#define SCI0_SE0_SE00_Pos                 (0UL)                     /*!< SCI0 SE0: SE00 (Bit 0)                                */
#define SCI0_SE0_SE00_Msk                 (0x1UL)                   /*!< SCI0 SE0: SE00 (Bitfield-Mask: 0x01)                  */
#define SCI0_SE0_SE01_Pos                 (1UL)                     /*!< SCI0 SE0: SE01 (Bit 1)                                */
#define SCI0_SE0_SE01_Msk                 (0x2UL)                   /*!< SCI0 SE0: SE01 (Bitfield-Mask: 0x01)                  */
/* ==========================================================  SS0  ========================================================== */
#define SCI0_SS0_SS00_Pos                 (0UL)                     /*!< SCI0 SS0: SS00 (Bit 0)                                */
#define SCI0_SS0_SS00_Msk                 (0x1UL)                   /*!< SCI0 SS0: SS00 (Bitfield-Mask: 0x01)                  */
#define SCI0_SS0_SS01_Pos                 (1UL)                     /*!< SCI0 SS0: SS01 (Bit 1)                                */
#define SCI0_SS0_SS01_Msk                 (0x2UL)                   /*!< SCI0 SS0: SS01 (Bitfield-Mask: 0x01)                  */
/* ==========================================================  ST0  ========================================================== */
#define SCI0_ST0_ST00_Pos                 (0UL)                     /*!< SCI0 ST0: ST00 (Bit 0)                                */
#define SCI0_ST0_ST00_Msk                 (0x1UL)                   /*!< SCI0 ST0: ST00 (Bitfield-Mask: 0x01)                  */
#define SCI0_ST0_ST01_Pos                 (1UL)                     /*!< SCI0 ST0: ST01 (Bit 1)                                */
#define SCI0_ST0_ST01_Msk                 (0x2UL)                   /*!< SCI0 ST0: ST01 (Bitfield-Mask: 0x01)                  */
/* =========================================================  SPS0  ========================================================== */
#define SCI0_SPS0_PRS00_Pos               (0UL)                     /*!< SCI0 SPS0: PRS00 (Bit 0)                              */
#define SCI0_SPS0_PRS00_Msk               (0xfUL)                   /*!< SCI0 SPS0: PRS00 (Bitfield-Mask: 0x0f)                */
#define SCI0_SPS0_PRS01_Pos               (4UL)                     /*!< SCI0 SPS0: PRS01 (Bit 4)                              */
#define SCI0_SPS0_PRS01_Msk               (0xf0UL)                  /*!< SCI0 SPS0: PRS01 (Bitfield-Mask: 0x0f)                */
/* ==========================================================  SO0  ========================================================== */
#define SCI0_SO0_SO00_Pos                 (0UL)                     /*!< SCI0 SO0: SO00 (Bit 0)                                */
#define SCI0_SO0_SO00_Msk                 (0x1UL)                   /*!< SCI0 SO0: SO00 (Bitfield-Mask: 0x01)                  */
#define SCI0_SO0_SO01_Pos                 (1UL)                     /*!< SCI0 SO0: SO01 (Bit 1)                                */
#define SCI0_SO0_SO01_Msk                 (0x2UL)                   /*!< SCI0 SO0: SO01 (Bitfield-Mask: 0x01)                  */
#define SCI0_SO0_CKO00_Pos                (8UL)                     /*!< SCI0 SO0: CKO00 (Bit 8)                               */
#define SCI0_SO0_CKO00_Msk                (0x100UL)                 /*!< SCI0 SO0: CKO00 (Bitfield-Mask: 0x01)                 */
#define SCI0_SO0_CKO01_Pos                (9UL)                     /*!< SCI0 SO0: CKO01 (Bit 9)                               */
#define SCI0_SO0_CKO01_Msk                (0x200UL)                 /*!< SCI0 SO0: CKO01 (Bitfield-Mask: 0x01)                 */
/* =========================================================  SOE0  ========================================================== */
#define SCI0_SOE0_SOE00_Pos               (0UL)                     /*!< SCI0 SOE0: SOE00 (Bit 0)                              */
#define SCI0_SOE0_SOE00_Msk               (0x1UL)                   /*!< SCI0 SOE0: SOE00 (Bitfield-Mask: 0x01)                */
#define SCI0_SOE0_SOE01_Pos               (1UL)                     /*!< SCI0 SOE0: SOE01 (Bit 1)                              */
#define SCI0_SOE0_SOE01_Msk               (0x2UL)                   /*!< SCI0 SOE0: SOE01 (Bitfield-Mask: 0x01)                */
/* =========================================================  SOL0  ========================================================== */
#define SCI0_SOL0_SOL00_Pos               (0UL)                     /*!< SCI0 SOL0: SOL00 (Bit 0)                              */
#define SCI0_SOL0_SOL00_Msk               (0x1UL)                   /*!< SCI0 SOL0: SOL00 (Bitfield-Mask: 0x01)                */
/* =========================================================  SSE0  ========================================================== */
#define SCI0_SSE0_SSIEmn_Pos              (0UL)                     /*!< SCI0 SSE0: SSIEmn (Bit 0)                             */
#define SCI0_SSE0_SSIEmn_Msk              (0x3UL)                   /*!< SCI0 SSE0: SSIEmn (Bitfield-Mask: 0x03)               */
/* =========================================================  SSC0  ========================================================== */
#define SCI0_SSC0_SWC0_Pos                (0UL)                     /*!< SCI0 SSC0: SWC0 (Bit 0)                               */
#define SCI0_SSC0_SWC0_Msk                (0x1UL)                   /*!< SCI0 SSC0: SWC0 (Bitfield-Mask: 0x01)                 */
#define SCI0_SSC0_SSEC0_Pos               (1UL)                     /*!< SCI0 SSC0: SSEC0 (Bit 1)                              */
#define SCI0_SSC0_SSEC0_Msk               (0x2UL)                   /*!< SCI0 SSC0: SSEC0 (Bitfield-Mask: 0x01)                */
/* =========================================================  SDR0  ========================================================== */
/* =========================================================  SIO00  ========================================================= */
/* =========================================================  SIO01  ========================================================= */
/* =========================================================  TXD0  ========================================================== */
/* =========================================================  RXD0  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           SCI1                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR10  ========================================================= */
#define SCI1_SSR10_OVF_Pos                (0UL)                     /*!< SCI1 SSR10: OVF (Bit 0)                               */
#define SCI1_SSR10_OVF_Msk                (0x1UL)                   /*!< SCI1 SSR10: OVF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR10_PEF_Pos                (1UL)                     /*!< SCI1 SSR10: PEF (Bit 1)                               */
#define SCI1_SSR10_PEF_Msk                (0x2UL)                   /*!< SCI1 SSR10: PEF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR10_FEF_Pos                (2UL)                     /*!< SCI1 SSR10: FEF (Bit 2)                               */
#define SCI1_SSR10_FEF_Msk                (0x4UL)                   /*!< SCI1 SSR10: FEF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR10_BFF_Pos                (5UL)                     /*!< SCI1 SSR10: BFF (Bit 5)                               */
#define SCI1_SSR10_BFF_Msk                (0x20UL)                  /*!< SCI1 SSR10: BFF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR10_TSF_Pos                (6UL)                     /*!< SCI1 SSR10: TSF (Bit 6)                               */
#define SCI1_SSR10_TSF_Msk                (0x40UL)                  /*!< SCI1 SSR10: TSF (Bitfield-Mask: 0x01)                 */
/* =========================================================  SSR11  ========================================================= */
#define SCI1_SSR11_OVF_Pos                (0UL)                     /*!< SCI1 SSR11: OVF (Bit 0)                               */
#define SCI1_SSR11_OVF_Msk                (0x1UL)                   /*!< SCI1 SSR11: OVF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR11_PEF_Pos                (1UL)                     /*!< SCI1 SSR11: PEF (Bit 1)                               */
#define SCI1_SSR11_PEF_Msk                (0x2UL)                   /*!< SCI1 SSR11: PEF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR11_FEF_Pos                (2UL)                     /*!< SCI1 SSR11: FEF (Bit 2)                               */
#define SCI1_SSR11_FEF_Msk                (0x4UL)                   /*!< SCI1 SSR11: FEF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR11_BFF_Pos                (5UL)                     /*!< SCI1 SSR11: BFF (Bit 5)                               */
#define SCI1_SSR11_BFF_Msk                (0x20UL)                  /*!< SCI1 SSR11: BFF (Bitfield-Mask: 0x01)                 */
#define SCI1_SSR11_TSF_Pos                (6UL)                     /*!< SCI1 SSR11: TSF (Bit 6)                               */
#define SCI1_SSR11_TSF_Msk                (0x40UL)                  /*!< SCI1 SSR11: TSF (Bitfield-Mask: 0x01)                 */
/* =========================================================  SIR10  ========================================================= */
#define SCI1_SIR10_OVCT_Pos               (0UL)                     /*!< SCI1 SIR10: OVCT (Bit 0)                              */
#define SCI1_SIR10_OVCT_Msk               (0x1UL)                   /*!< SCI1 SIR10: OVCT (Bitfield-Mask: 0x01)                */
#define SCI1_SIR10_PECT_Pos               (1UL)                     /*!< SCI1 SIR10: PECT (Bit 1)                              */
#define SCI1_SIR10_PECT_Msk               (0x2UL)                   /*!< SCI1 SIR10: PECT (Bitfield-Mask: 0x01)                */
#define SCI1_SIR10_FECT_Pos               (2UL)                     /*!< SCI1 SIR10: FECT (Bit 2)                              */
#define SCI1_SIR10_FECT_Msk               (0x4UL)                   /*!< SCI1 SIR10: FECT (Bitfield-Mask: 0x01)                */
/* =========================================================  SIR11  ========================================================= */
#define SCI1_SIR11_OVCT_Pos               (0UL)                     /*!< SCI1 SIR11: OVCT (Bit 0)                              */
#define SCI1_SIR11_OVCT_Msk               (0x1UL)                   /*!< SCI1 SIR11: OVCT (Bitfield-Mask: 0x01)                */
#define SCI1_SIR11_PECT_Pos               (1UL)                     /*!< SCI1 SIR11: PECT (Bit 1)                              */
#define SCI1_SIR11_PECT_Msk               (0x2UL)                   /*!< SCI1 SIR11: PECT (Bitfield-Mask: 0x01)                */
#define SCI1_SIR11_FECT_Pos               (2UL)                     /*!< SCI1 SIR11: FECT (Bit 2)                              */
#define SCI1_SIR11_FECT_Msk               (0x4UL)                   /*!< SCI1 SIR11: FECT (Bitfield-Mask: 0x01)                */
/* =========================================================  SMR10  ========================================================= */
#define SCI1_SMR10_MD_Pos                 (0UL)                     /*!< SCI1 SMR10: MD (Bit 0)                                */
#define SCI1_SMR10_MD_Msk                 (0x7UL)                   /*!< SCI1 SMR10: MD (Bitfield-Mask: 0x07)                  */
#define SCI1_SMR10_SIS_Pos                (6UL)                     /*!< SCI1 SMR10: SIS (Bit 6)                               */
#define SCI1_SMR10_SIS_Msk                (0x40UL)                  /*!< SCI1 SMR10: SIS (Bitfield-Mask: 0x01)                 */
#define SCI1_SMR10_STS_Pos                (8UL)                     /*!< SCI1 SMR10: STS (Bit 8)                               */
#define SCI1_SMR10_STS_Msk                (0x100UL)                 /*!< SCI1 SMR10: STS (Bitfield-Mask: 0x01)                 */
#define SCI1_SMR10_CCS_Pos                (14UL)                    /*!< SCI1 SMR10: CCS (Bit 14)                              */
#define SCI1_SMR10_CCS_Msk                (0x4000UL)                /*!< SCI1 SMR10: CCS (Bitfield-Mask: 0x01)                 */
#define SCI1_SMR10_CKS_Pos                (15UL)                    /*!< SCI1 SMR10: CKS (Bit 15)                              */
#define SCI1_SMR10_CKS_Msk                (0x8000UL)                /*!< SCI1 SMR10: CKS (Bitfield-Mask: 0x01)                 */
/* =========================================================  SMR11  ========================================================= */
#define SCI1_SMR11_MD_Pos                 (0UL)                     /*!< SCI1 SMR11: MD (Bit 0)                                */
#define SCI1_SMR11_MD_Msk                 (0x7UL)                   /*!< SCI1 SMR11: MD (Bitfield-Mask: 0x07)                  */
#define SCI1_SMR11_SIS_Pos                (6UL)                     /*!< SCI1 SMR11: SIS (Bit 6)                               */
#define SCI1_SMR11_SIS_Msk                (0x40UL)                  /*!< SCI1 SMR11: SIS (Bitfield-Mask: 0x01)                 */
#define SCI1_SMR11_STS_Pos                (8UL)                     /*!< SCI1 SMR11: STS (Bit 8)                               */
#define SCI1_SMR11_STS_Msk                (0x100UL)                 /*!< SCI1 SMR11: STS (Bitfield-Mask: 0x01)                 */
#define SCI1_SMR11_CCS_Pos                (14UL)                    /*!< SCI1 SMR11: CCS (Bit 14)                              */
#define SCI1_SMR11_CCS_Msk                (0x4000UL)                /*!< SCI1 SMR11: CCS (Bitfield-Mask: 0x01)                 */
#define SCI1_SMR11_CKS_Pos                (15UL)                    /*!< SCI1 SMR11: CKS (Bit 15)                              */
#define SCI1_SMR11_CKS_Msk                (0x8000UL)                /*!< SCI1 SMR11: CKS (Bitfield-Mask: 0x01)                 */
/* =========================================================  SCR10  ========================================================= */
#define SCI1_SCR10_DLS_Pos                (0UL)                     /*!< SCI1 SCR10: DLS (Bit 0)                               */
#define SCI1_SCR10_DLS_Msk                (0xfUL)                   /*!< SCI1 SCR10: DLS (Bitfield-Mask: 0x0f)                 */
#define SCI1_SCR10_SLC_Pos                (4UL)                     /*!< SCI1 SCR10: SLC (Bit 4)                               */
#define SCI1_SCR10_SLC_Msk                (0x30UL)                  /*!< SCI1 SCR10: SLC (Bitfield-Mask: 0x03)                 */
#define SCI1_SCR10_DIR_Pos                (7UL)                     /*!< SCI1 SCR10: DIR (Bit 7)                               */
#define SCI1_SCR10_DIR_Msk                (0x80UL)                  /*!< SCI1 SCR10: DIR (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR10_PTC_Pos                (8UL)                     /*!< SCI1 SCR10: PTC (Bit 8)                               */
#define SCI1_SCR10_PTC_Msk                (0x300UL)                 /*!< SCI1 SCR10: PTC (Bitfield-Mask: 0x03)                 */
#define SCI1_SCR10_CKP_Pos                (12UL)                    /*!< SCI1 SCR10: CKP (Bit 12)                              */
#define SCI1_SCR10_CKP_Msk                (0x1000UL)                /*!< SCI1 SCR10: CKP (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR10_DAP_Pos                (13UL)                    /*!< SCI1 SCR10: DAP (Bit 13)                              */
#define SCI1_SCR10_DAP_Msk                (0x2000UL)                /*!< SCI1 SCR10: DAP (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR10_RXE_Pos                (14UL)                    /*!< SCI1 SCR10: RXE (Bit 14)                              */
#define SCI1_SCR10_RXE_Msk                (0x4000UL)                /*!< SCI1 SCR10: RXE (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR10_TXE_Pos                (15UL)                    /*!< SCI1 SCR10: TXE (Bit 15)                              */
#define SCI1_SCR10_TXE_Msk                (0x8000UL)                /*!< SCI1 SCR10: TXE (Bitfield-Mask: 0x01)                 */
/* =========================================================  SCR11  ========================================================= */
#define SCI1_SCR11_DLS_Pos                (0UL)                     /*!< SCI1 SCR11: DLS (Bit 0)                               */
#define SCI1_SCR11_DLS_Msk                (0xfUL)                   /*!< SCI1 SCR11: DLS (Bitfield-Mask: 0x0f)                 */
#define SCI1_SCR11_SLC_Pos                (4UL)                     /*!< SCI1 SCR11: SLC (Bit 4)                               */
#define SCI1_SCR11_SLC_Msk                (0x30UL)                  /*!< SCI1 SCR11: SLC (Bitfield-Mask: 0x03)                 */
#define SCI1_SCR11_DIR_Pos                (7UL)                     /*!< SCI1 SCR11: DIR (Bit 7)                               */
#define SCI1_SCR11_DIR_Msk                (0x80UL)                  /*!< SCI1 SCR11: DIR (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR11_PTC_Pos                (8UL)                     /*!< SCI1 SCR11: PTC (Bit 8)                               */
#define SCI1_SCR11_PTC_Msk                (0x300UL)                 /*!< SCI1 SCR11: PTC (Bitfield-Mask: 0x03)                 */
#define SCI1_SCR11_CKP_Pos                (12UL)                    /*!< SCI1 SCR11: CKP (Bit 12)                              */
#define SCI1_SCR11_CKP_Msk                (0x1000UL)                /*!< SCI1 SCR11: CKP (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR11_DAP_Pos                (13UL)                    /*!< SCI1 SCR11: DAP (Bit 13)                              */
#define SCI1_SCR11_DAP_Msk                (0x2000UL)                /*!< SCI1 SCR11: DAP (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR11_RXE_Pos                (14UL)                    /*!< SCI1 SCR11: RXE (Bit 14)                              */
#define SCI1_SCR11_RXE_Msk                (0x4000UL)                /*!< SCI1 SCR11: RXE (Bitfield-Mask: 0x01)                 */
#define SCI1_SCR11_TXE_Pos                (15UL)                    /*!< SCI1 SCR11: TXE (Bit 15)                              */
#define SCI1_SCR11_TXE_Msk                (0x8000UL)                /*!< SCI1 SCR11: TXE (Bitfield-Mask: 0x01)                 */
/* ==========================================================  SE1  ========================================================== */
#define SCI1_SE1_SE10_Pos                 (0UL)                     /*!< SCI1 SE1: SE10 (Bit 0)                                */
#define SCI1_SE1_SE10_Msk                 (0x1UL)                   /*!< SCI1 SE1: SE10 (Bitfield-Mask: 0x01)                  */
#define SCI1_SE1_SE11_Pos                 (1UL)                     /*!< SCI1 SE1: SE11 (Bit 1)                                */
#define SCI1_SE1_SE11_Msk                 (0x2UL)                   /*!< SCI1 SE1: SE11 (Bitfield-Mask: 0x01)                  */
/* ==========================================================  SS1  ========================================================== */
#define SCI1_SS1_SS10_Pos                 (0UL)                     /*!< SCI1 SS1: SS10 (Bit 0)                                */
#define SCI1_SS1_SS10_Msk                 (0x1UL)                   /*!< SCI1 SS1: SS10 (Bitfield-Mask: 0x01)                  */
#define SCI1_SS1_SS11_Pos                 (1UL)                     /*!< SCI1 SS1: SS11 (Bit 1)                                */
#define SCI1_SS1_SS11_Msk                 (0x2UL)                   /*!< SCI1 SS1: SS11 (Bitfield-Mask: 0x01)                  */
/* ==========================================================  ST1  ========================================================== */
#define SCI1_ST1_ST10_Pos                 (0UL)                     /*!< SCI1 ST1: ST10 (Bit 0)                                */
#define SCI1_ST1_ST10_Msk                 (0x1UL)                   /*!< SCI1 ST1: ST10 (Bitfield-Mask: 0x01)                  */
#define SCI1_ST1_ST11_Pos                 (1UL)                     /*!< SCI1 ST1: ST11 (Bit 1)                                */
#define SCI1_ST1_ST11_Msk                 (0x2UL)                   /*!< SCI1 ST1: ST11 (Bitfield-Mask: 0x01)                  */
/* =========================================================  SPS1  ========================================================== */
#define SCI1_SPS1_PRS10_Pos               (0UL)                     /*!< SCI1 SPS1: PRS10 (Bit 0)                              */
#define SCI1_SPS1_PRS10_Msk               (0xfUL)                   /*!< SCI1 SPS1: PRS10 (Bitfield-Mask: 0x0f)                */
#define SCI1_SPS1_PRS11_Pos               (4UL)                     /*!< SCI1 SPS1: PRS11 (Bit 4)                              */
#define SCI1_SPS1_PRS11_Msk               (0xf0UL)                  /*!< SCI1 SPS1: PRS11 (Bitfield-Mask: 0x0f)                */
/* ==========================================================  SO1  ========================================================== */
#define SCI1_SO1_SO10_Pos                 (0UL)                     /*!< SCI1 SO1: SO10 (Bit 0)                                */
#define SCI1_SO1_SO10_Msk                 (0x1UL)                   /*!< SCI1 SO1: SO10 (Bitfield-Mask: 0x01)                  */
#define SCI1_SO1_SO11_Pos                 (1UL)                     /*!< SCI1 SO1: SO11 (Bit 1)                                */
#define SCI1_SO1_SO11_Msk                 (0x2UL)                   /*!< SCI1 SO1: SO11 (Bitfield-Mask: 0x01)                  */
#define SCI1_SO1_CKO10_Pos                (8UL)                     /*!< SCI1 SO1: CKO10 (Bit 8)                               */
#define SCI1_SO1_CKO10_Msk                (0x100UL)                 /*!< SCI1 SO1: CKO10 (Bitfield-Mask: 0x01)                 */
#define SCI1_SO1_CKO11_Pos                (9UL)                     /*!< SCI1 SO1: CKO11 (Bit 9)                               */
#define SCI1_SO1_CKO11_Msk                (0x200UL)                 /*!< SCI1 SO1: CKO11 (Bitfield-Mask: 0x01)                 */
/* =========================================================  SOE1  ========================================================== */
#define SCI1_SOE1_SOE10_Pos               (0UL)                     /*!< SCI1 SOE1: SOE10 (Bit 0)                              */
#define SCI1_SOE1_SOE10_Msk               (0x1UL)                   /*!< SCI1 SOE1: SOE10 (Bitfield-Mask: 0x01)                */
#define SCI1_SOE1_SOE11_Pos               (1UL)                     /*!< SCI1 SOE1: SOE11 (Bit 1)                              */
#define SCI1_SOE1_SOE11_Msk               (0x2UL)                   /*!< SCI1 SOE1: SOE11 (Bitfield-Mask: 0x01)                */
/* =========================================================  SOL1  ========================================================== */
#define SCI1_SOL1_SOL10_Pos               (0UL)                     /*!< SCI1 SOL1: SOL10 (Bit 0)                              */
#define SCI1_SOL1_SOL10_Msk               (0x1UL)                   /*!< SCI1 SOL1: SOL10 (Bitfield-Mask: 0x01)                */
/* =========================================================  SSE0  ========================================================== */
#define SCI1_SSE0_SSIEmn_Pos              (0UL)                     /*!< SCI1 SSE0: SSIEmn (Bit 0)                             */
#define SCI1_SSE0_SSIEmn_Msk              (0x3UL)                   /*!< SCI1 SSE0: SSIEmn (Bitfield-Mask: 0x03)               */
/* =========================================================  SSC1  ========================================================== */
#define SCI1_SSC1_SWC1_Pos                (0UL)                     /*!< SCI1 SSC1: SWC1 (Bit 0)                               */
#define SCI1_SSC1_SWC1_Msk                (0x1UL)                   /*!< SCI1 SSC1: SWC1 (Bitfield-Mask: 0x01)                 */
#define SCI1_SSC1_SSEC1_Pos               (1UL)                     /*!< SCI1 SSC1: SSEC1 (Bit 1)                              */
#define SCI1_SSC1_SSEC1_Msk               (0x2UL)                   /*!< SCI1 SSC1: SSEC1 (Bitfield-Mask: 0x01)                */
/* =========================================================  SDR1  ========================================================== */
/* =========================================================  SIO10  ========================================================= */
/* =========================================================  SIO11  ========================================================= */
/* =========================================================  TXD1  ========================================================== */
/* =========================================================  RXD1  ========================================================== */


/* =========================================================================================================================== */
/* ================                                           SCI2                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  SSR20  ========================================================= */
#define SCI2_SSR20_OVF_Pos                (0UL)                     /*!< SCI2 SSR20: OVF (Bit 0)                               */
#define SCI2_SSR20_OVF_Msk                (0x1UL)                   /*!< SCI2 SSR20: OVF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR20_PEF_Pos                (1UL)                     /*!< SCI2 SSR20: PEF (Bit 1)                               */
#define SCI2_SSR20_PEF_Msk                (0x2UL)                   /*!< SCI2 SSR20: PEF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR20_FEF_Pos                (2UL)                     /*!< SCI2 SSR20: FEF (Bit 2)                               */
#define SCI2_SSR20_FEF_Msk                (0x4UL)                   /*!< SCI2 SSR20: FEF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR20_BFF_Pos                (5UL)                     /*!< SCI2 SSR20: BFF (Bit 5)                               */
#define SCI2_SSR20_BFF_Msk                (0x20UL)                  /*!< SCI2 SSR20: BFF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR20_TSF_Pos                (6UL)                     /*!< SCI2 SSR20: TSF (Bit 6)                               */
#define SCI2_SSR20_TSF_Msk                (0x40UL)                  /*!< SCI2 SSR20: TSF (Bitfield-Mask: 0x01)                 */
/* =========================================================  SSR21  ========================================================= */
#define SCI2_SSR21_OVF_Pos                (0UL)                     /*!< SCI2 SSR21: OVF (Bit 0)                               */
#define SCI2_SSR21_OVF_Msk                (0x1UL)                   /*!< SCI2 SSR21: OVF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR21_PEF_Pos                (1UL)                     /*!< SCI2 SSR21: PEF (Bit 1)                               */
#define SCI2_SSR21_PEF_Msk                (0x2UL)                   /*!< SCI2 SSR21: PEF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR21_FEF_Pos                (2UL)                     /*!< SCI2 SSR21: FEF (Bit 2)                               */
#define SCI2_SSR21_FEF_Msk                (0x4UL)                   /*!< SCI2 SSR21: FEF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR21_BFF_Pos                (5UL)                     /*!< SCI2 SSR21: BFF (Bit 5)                               */
#define SCI2_SSR21_BFF_Msk                (0x20UL)                  /*!< SCI2 SSR21: BFF (Bitfield-Mask: 0x01)                 */
#define SCI2_SSR21_TSF_Pos                (6UL)                     /*!< SCI2 SSR21: TSF (Bit 6)                               */
#define SCI2_SSR21_TSF_Msk                (0x40UL)                  /*!< SCI2 SSR21: TSF (Bitfield-Mask: 0x01)                 */
/* =========================================================  SIR20  ========================================================= */
#define SCI2_SIR20_OVCT_Pos               (0UL)                     /*!< SCI2 SIR20: OVCT (Bit 0)                              */
#define SCI2_SIR20_OVCT_Msk               (0x1UL)                   /*!< SCI2 SIR20: OVCT (Bitfield-Mask: 0x01)                */
#define SCI2_SIR20_PECT_Pos               (1UL)                     /*!< SCI2 SIR20: PECT (Bit 1)                              */
#define SCI2_SIR20_PECT_Msk               (0x2UL)                   /*!< SCI2 SIR20: PECT (Bitfield-Mask: 0x01)                */
#define SCI2_SIR20_FECT_Pos               (2UL)                     /*!< SCI2 SIR20: FECT (Bit 2)                              */
#define SCI2_SIR20_FECT_Msk               (0x4UL)                   /*!< SCI2 SIR20: FECT (Bitfield-Mask: 0x01)                */
/* =========================================================  SIR21  ========================================================= */
#define SCI2_SIR21_OVCT_Pos               (0UL)                     /*!< SCI2 SIR21: OVCT (Bit 0)                              */
#define SCI2_SIR21_OVCT_Msk               (0x1UL)                   /*!< SCI2 SIR21: OVCT (Bitfield-Mask: 0x01)                */
#define SCI2_SIR21_PECT_Pos               (1UL)                     /*!< SCI2 SIR21: PECT (Bit 1)                              */
#define SCI2_SIR21_PECT_Msk               (0x2UL)                   /*!< SCI2 SIR21: PECT (Bitfield-Mask: 0x01)                */
#define SCI2_SIR21_FECT_Pos               (2UL)                     /*!< SCI2 SIR21: FECT (Bit 2)                              */
#define SCI2_SIR21_FECT_Msk               (0x4UL)                   /*!< SCI2 SIR21: FECT (Bitfield-Mask: 0x01)                */
/* =========================================================  SMR20  ========================================================= */
#define SCI2_SMR20_MD_Pos                 (0UL)                     /*!< SCI2 SMR20: MD (Bit 0)                                */
#define SCI2_SMR20_MD_Msk                 (0x7UL)                   /*!< SCI2 SMR20: MD (Bitfield-Mask: 0x07)                  */
#define SCI2_SMR20_SIS_Pos                (6UL)                     /*!< SCI2 SMR20: SIS (Bit 6)                               */
#define SCI2_SMR20_SIS_Msk                (0x40UL)                  /*!< SCI2 SMR20: SIS (Bitfield-Mask: 0x01)                 */
#define SCI2_SMR20_STS_Pos                (8UL)                     /*!< SCI2 SMR20: STS (Bit 8)                               */
#define SCI2_SMR20_STS_Msk                (0x100UL)                 /*!< SCI2 SMR20: STS (Bitfield-Mask: 0x01)                 */
#define SCI2_SMR20_CCS_Pos                (14UL)                    /*!< SCI2 SMR20: CCS (Bit 14)                              */
#define SCI2_SMR20_CCS_Msk                (0x4000UL)                /*!< SCI2 SMR20: CCS (Bitfield-Mask: 0x01)                 */
#define SCI2_SMR20_CKS_Pos                (15UL)                    /*!< SCI2 SMR20: CKS (Bit 15)                              */
#define SCI2_SMR20_CKS_Msk                (0x8000UL)                /*!< SCI2 SMR20: CKS (Bitfield-Mask: 0x01)                 */
/* =========================================================  SMR21  ========================================================= */
#define SCI2_SMR21_MD_Pos                 (0UL)                     /*!< SCI2 SMR21: MD (Bit 0)                                */
#define SCI2_SMR21_MD_Msk                 (0x7UL)                   /*!< SCI2 SMR21: MD (Bitfield-Mask: 0x07)                  */
#define SCI2_SMR21_SIS_Pos                (6UL)                     /*!< SCI2 SMR21: SIS (Bit 6)                               */
#define SCI2_SMR21_SIS_Msk                (0x40UL)                  /*!< SCI2 SMR21: SIS (Bitfield-Mask: 0x01)                 */
#define SCI2_SMR21_STS_Pos                (8UL)                     /*!< SCI2 SMR21: STS (Bit 8)                               */
#define SCI2_SMR21_STS_Msk                (0x100UL)                 /*!< SCI2 SMR21: STS (Bitfield-Mask: 0x01)                 */
#define SCI2_SMR21_CCS_Pos                (14UL)                    /*!< SCI2 SMR21: CCS (Bit 14)                              */
#define SCI2_SMR21_CCS_Msk                (0x4000UL)                /*!< SCI2 SMR21: CCS (Bitfield-Mask: 0x01)                 */
#define SCI2_SMR21_CKS_Pos                (15UL)                    /*!< SCI2 SMR21: CKS (Bit 15)                              */
#define SCI2_SMR21_CKS_Msk                (0x8000UL)                /*!< SCI2 SMR21: CKS (Bitfield-Mask: 0x01)                 */
/* =========================================================  SCR20  ========================================================= */
#define SCI2_SCR20_DLS_Pos                (0UL)                     /*!< SCI2 SCR20: DLS (Bit 0)                               */
#define SCI2_SCR20_DLS_Msk                (0xfUL)                   /*!< SCI2 SCR20: DLS (Bitfield-Mask: 0x0f)                 */
#define SCI2_SCR20_SLC_Pos                (4UL)                     /*!< SCI2 SCR20: SLC (Bit 4)                               */
#define SCI2_SCR20_SLC_Msk                (0x30UL)                  /*!< SCI2 SCR20: SLC (Bitfield-Mask: 0x03)                 */
#define SCI2_SCR20_DIR_Pos                (7UL)                     /*!< SCI2 SCR20: DIR (Bit 7)                               */
#define SCI2_SCR20_DIR_Msk                (0x80UL)                  /*!< SCI2 SCR20: DIR (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR20_PTC_Pos                (8UL)                     /*!< SCI2 SCR20: PTC (Bit 8)                               */
#define SCI2_SCR20_PTC_Msk                (0x300UL)                 /*!< SCI2 SCR20: PTC (Bitfield-Mask: 0x03)                 */
#define SCI2_SCR20_CKP_Pos                (12UL)                    /*!< SCI2 SCR20: CKP (Bit 12)                              */
#define SCI2_SCR20_CKP_Msk                (0x1000UL)                /*!< SCI2 SCR20: CKP (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR20_DAP_Pos                (13UL)                    /*!< SCI2 SCR20: DAP (Bit 13)                              */
#define SCI2_SCR20_DAP_Msk                (0x2000UL)                /*!< SCI2 SCR20: DAP (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR20_RXE_Pos                (14UL)                    /*!< SCI2 SCR20: RXE (Bit 14)                              */
#define SCI2_SCR20_RXE_Msk                (0x4000UL)                /*!< SCI2 SCR20: RXE (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR20_TXE_Pos                (15UL)                    /*!< SCI2 SCR20: TXE (Bit 15)                              */
#define SCI2_SCR20_TXE_Msk                (0x8000UL)                /*!< SCI2 SCR20: TXE (Bitfield-Mask: 0x01)                 */
/* =========================================================  SCR21  ========================================================= */
#define SCI2_SCR21_DLS_Pos                (0UL)                     /*!< SCI2 SCR21: DLS (Bit 0)                               */
#define SCI2_SCR21_DLS_Msk                (0xfUL)                   /*!< SCI2 SCR21: DLS (Bitfield-Mask: 0x0f)                 */
#define SCI2_SCR21_SLC_Pos                (4UL)                     /*!< SCI2 SCR21: SLC (Bit 4)                               */
#define SCI2_SCR21_SLC_Msk                (0x30UL)                  /*!< SCI2 SCR21: SLC (Bitfield-Mask: 0x03)                 */
#define SCI2_SCR21_DIR_Pos                (7UL)                     /*!< SCI2 SCR21: DIR (Bit 7)                               */
#define SCI2_SCR21_DIR_Msk                (0x80UL)                  /*!< SCI2 SCR21: DIR (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR21_PTC_Pos                (8UL)                     /*!< SCI2 SCR21: PTC (Bit 8)                               */
#define SCI2_SCR21_PTC_Msk                (0x300UL)                 /*!< SCI2 SCR21: PTC (Bitfield-Mask: 0x03)                 */
#define SCI2_SCR21_CKP_Pos                (12UL)                    /*!< SCI2 SCR21: CKP (Bit 12)                              */
#define SCI2_SCR21_CKP_Msk                (0x1000UL)                /*!< SCI2 SCR21: CKP (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR21_DAP_Pos                (13UL)                    /*!< SCI2 SCR21: DAP (Bit 13)                              */
#define SCI2_SCR21_DAP_Msk                (0x2000UL)                /*!< SCI2 SCR21: DAP (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR21_RXE_Pos                (14UL)                    /*!< SCI2 SCR21: RXE (Bit 14)                              */
#define SCI2_SCR21_RXE_Msk                (0x4000UL)                /*!< SCI2 SCR21: RXE (Bitfield-Mask: 0x01)                 */
#define SCI2_SCR21_TXE_Pos                (15UL)                    /*!< SCI2 SCR21: TXE (Bit 15)                              */
#define SCI2_SCR21_TXE_Msk                (0x8000UL)                /*!< SCI2 SCR21: TXE (Bitfield-Mask: 0x01)                 */
/* ==========================================================  SE2  ========================================================== */
#define SCI2_SE2_SE20_Pos                 (0UL)                     /*!< SCI2 SE2: SE20 (Bit 0)                                */
#define SCI2_SE2_SE20_Msk                 (0x1UL)                   /*!< SCI2 SE2: SE20 (Bitfield-Mask: 0x01)                  */
#define SCI2_SE2_SE21_Pos                 (1UL)                     /*!< SCI2 SE2: SE21 (Bit 1)                                */
#define SCI2_SE2_SE21_Msk                 (0x2UL)                   /*!< SCI2 SE2: SE21 (Bitfield-Mask: 0x01)                  */
/* ==========================================================  SS2  ========================================================== */
#define SCI2_SS2_SS20_Pos                 (0UL)                     /*!< SCI2 SS2: SS20 (Bit 0)                                */
#define SCI2_SS2_SS20_Msk                 (0x1UL)                   /*!< SCI2 SS2: SS20 (Bitfield-Mask: 0x01)                  */
#define SCI2_SS2_SS21_Pos                 (1UL)                     /*!< SCI2 SS2: SS21 (Bit 1)                                */
#define SCI2_SS2_SS21_Msk                 (0x2UL)                   /*!< SCI2 SS2: SS21 (Bitfield-Mask: 0x01)                  */
/* ==========================================================  ST2  ========================================================== */
#define SCI2_ST2_ST20_Pos                 (0UL)                     /*!< SCI2 ST2: ST20 (Bit 0)                                */
#define SCI2_ST2_ST20_Msk                 (0x1UL)                   /*!< SCI2 ST2: ST20 (Bitfield-Mask: 0x01)                  */
#define SCI2_ST2_ST21_Pos                 (1UL)                     /*!< SCI2 ST2: ST21 (Bit 1)                                */
#define SCI2_ST2_ST21_Msk                 (0x2UL)                   /*!< SCI2 ST2: ST21 (Bitfield-Mask: 0x01)                  */
/* =========================================================  SPS2  ========================================================== */
#define SCI2_SPS2_PRS20_Pos               (0UL)                     /*!< SCI2 SPS2: PRS20 (Bit 0)                              */
#define SCI2_SPS2_PRS20_Msk               (0xfUL)                   /*!< SCI2 SPS2: PRS20 (Bitfield-Mask: 0x0f)                */
#define SCI2_SPS2_PRS21_Pos               (4UL)                     /*!< SCI2 SPS2: PRS21 (Bit 4)                              */
#define SCI2_SPS2_PRS21_Msk               (0xf0UL)                  /*!< SCI2 SPS2: PRS21 (Bitfield-Mask: 0x0f)                */
/* ==========================================================  SO2  ========================================================== */
#define SCI2_SO2_SO20_Pos                 (0UL)                     /*!< SCI2 SO2: SO20 (Bit 0)                                */
#define SCI2_SO2_SO20_Msk                 (0x1UL)                   /*!< SCI2 SO2: SO20 (Bitfield-Mask: 0x01)                  */
#define SCI2_SO2_SO21_Pos                 (1UL)                     /*!< SCI2 SO2: SO21 (Bit 1)                                */
#define SCI2_SO2_SO21_Msk                 (0x2UL)                   /*!< SCI2 SO2: SO21 (Bitfield-Mask: 0x01)                  */
#define SCI2_SO2_CKO20_Pos                (8UL)                     /*!< SCI2 SO2: CKO20 (Bit 8)                               */
#define SCI2_SO2_CKO20_Msk                (0x100UL)                 /*!< SCI2 SO2: CKO20 (Bitfield-Mask: 0x01)                 */
#define SCI2_SO2_CKO11_Pos                (9UL)                     /*!< SCI2 SO2: CKO11 (Bit 9)                               */
#define SCI2_SO2_CKO11_Msk                (0x200UL)                 /*!< SCI2 SO2: CKO11 (Bitfield-Mask: 0x01)                 */
/* =========================================================  SOE2  ========================================================== */
#define SCI2_SOE2_SOE20_Pos               (0UL)                     /*!< SCI2 SOE2: SOE20 (Bit 0)                              */
#define SCI2_SOE2_SOE20_Msk               (0x1UL)                   /*!< SCI2 SOE2: SOE20 (Bitfield-Mask: 0x01)                */
#define SCI2_SOE2_SOE21_Pos               (1UL)                     /*!< SCI2 SOE2: SOE21 (Bit 1)                              */
#define SCI2_SOE2_SOE21_Msk               (0x2UL)                   /*!< SCI2 SOE2: SOE21 (Bitfield-Mask: 0x01)                */
/* =========================================================  SOL2  ========================================================== */
#define SCI2_SOL2_SOL20_Pos               (0UL)                     /*!< SCI2 SOL2: SOL20 (Bit 0)                              */
#define SCI2_SOL2_SOL20_Msk               (0x1UL)                   /*!< SCI2 SOL2: SOL20 (Bitfield-Mask: 0x01)                */
/* =========================================================  SSE0  ========================================================== */
#define SCI2_SSE0_SSIEmn_Pos              (0UL)                     /*!< SCI2 SSE0: SSIEmn (Bit 0)                             */
#define SCI2_SSE0_SSIEmn_Msk              (0x3UL)                   /*!< SCI2 SSE0: SSIEmn (Bitfield-Mask: 0x03)               */
/* =========================================================  SSC2  ========================================================== */
#define SCI2_SSC2_SWC2_Pos                (0UL)                     /*!< SCI2 SSC2: SWC2 (Bit 0)                               */
#define SCI2_SSC2_SWC2_Msk                (0x1UL)                   /*!< SCI2 SSC2: SWC2 (Bitfield-Mask: 0x01)                 */
#define SCI2_SSC2_SSEC2_Pos               (1UL)                     /*!< SCI2 SSC2: SSEC2 (Bit 1)                              */
#define SCI2_SSC2_SSEC2_Msk               (0x2UL)                   /*!< SCI2 SSC2: SSEC2 (Bitfield-Mask: 0x01)                */
/* =========================================================  SDR2  ========================================================== */
/* =========================================================  SIO20  ========================================================= */
/* =========================================================  SIO21  ========================================================= */
/* =========================================================  TXD2  ========================================================== */
/* =========================================================  RXD2  ========================================================== */


/* =========================================================================================================================== */
/* ================                                          SPIHS0                                           ================ */
/* =========================================================================================================================== */

/* =========================================================  SPIM  ========================================================== */
#define SPI_SPIM_RECMD_Pos             (1UL)                     /*!< SPIHS0 SPIM: RECMD (Bit 1)                            */
#define SPI_SPIM_RECMD_Msk             (0x2UL)                   /*!< SPIHS0 SPIM: RECMD (Bitfield-Mask: 0x01)              */
#define SPI_SPIM_DLS_Pos               (2UL)                     /*!< SPIHS0 SPIM: DLS (Bit 2)                              */
#define SPI_SPIM_DLS_Msk               (0x4UL)                   /*!< SPIHS0 SPIM: DLS (Bitfield-Mask: 0x01)                */
#define SPI_SPIM_INTMD_Pos             (3UL)                     /*!< SPIHS0 SPIM: INTMD (Bit 3)                            */
#define SPI_SPIM_INTMD_Msk             (0x8UL)                   /*!< SPIHS0 SPIM: INTMD (Bitfield-Mask: 0x01)              */
#define SPI_SPIM_DIR_Pos               (4UL)                     /*!< SPIHS0 SPIM: DIR (Bit 4)                              */
#define SPI_SPIM_DIR_Msk               (0x10UL)                  /*!< SPIHS0 SPIM: DIR (Bitfield-Mask: 0x01)                */
#define SPI_SPIM_NSSE_Pos              (5UL)                     /*!< SPIHS0 SPIM: NSSE (Bit 5)                             */
#define SPI_SPIM_NSSE_Msk              (0x20UL)                  /*!< SPIHS0 SPIM: NSSE (Bitfield-Mask: 0x01)               */
#define SPI_SPIM_TRMD_Pos              (6UL)                     /*!< SPIHS0 SPIM: TRMD (Bit 6)                             */
#define SPI_SPIM_TRMD_Msk              (0x40UL)                  /*!< SPIHS0 SPIM: TRMD (Bitfield-Mask: 0x01)               */
#define SPI_SPIM_SPIE_Pos              (7UL)                     /*!< SPIHS0 SPIM: SPIE (Bit 7)                             */
#define SPI_SPIM_SPIE_Msk              (0x80UL)                  /*!< SPIHS0 SPIM: SPIE (Bitfield-Mask: 0x01)               */
/* =========================================================  SPIC  ========================================================== */
#define SPI_SPIC_CKS_Pos               (0UL)                     /*!< SPIHS0 SPIC: CKS (Bit 0)                              */
#define SPI_SPIC_CKS_Msk               (0x7UL)                   /*!< SPIHS0 SPIC: CKS (Bitfield-Mask: 0x07)                */
#define SPI_SPIC_CPHA_Pos              (3UL)                     /*!< SPIHS0 SPIC: CPHA (Bit 3)                             */
#define SPI_SPIC_CPHA_Msk              (0x8UL)                   /*!< SPIHS0 SPIC: CPHA (Bitfield-Mask: 0x01)               */
#define SPI_SPIC_CPOL_Pos              (4UL)                     /*!< SPIHS0 SPIC: CPOL (Bit 4)                             */
#define SPI_SPIC_CPOL_Msk              (0x10UL)                  /*!< SPIHS0 SPIC: CPOL (Bitfield-Mask: 0x01)               */
/* =========================================================  SOTB  ========================================================== */
/* ==========================================================  SIO  ========================================================== */
/* =========================================================  SPIS  ========================================================== */
#define SPI_SPIS_SPTF_Pos              (0UL)                     /*!< SPIHS0 SPIS: SPTF (Bit 0)                             */
#define SPI_SPIS_SPTF_Msk              (0x1UL)                   /*!< SPIHS0 SPIS: SPTF (Bitfield-Mask: 0x01)               */
#define SPI_SPIS_SDRIF_Pos             (1UL)                     /*!< SPIHS0 SPIS: SDRIF (Bit 1)                            */
#define SPI_SPIS_SDRIF_Msk             (0x2UL)                   /*!< SPIHS0 SPIS: SDRIF (Bitfield-Mask: 0x01)              */


/* =========================================================================================================================== */
/* ================                                           IICA0                                           ================ */
/* =========================================================================================================================== */

/* =======================================================  IICCTL00  ======================================================== */
#define IICA_IICCTL00_SPT_Pos            (0UL)                     /*!< IICA0 IICCTL00: SPT (Bit 0)                           */
#define IICA_IICCTL00_SPT_Msk            (0x1UL)                   /*!< IICA0 IICCTL00: SPT (Bitfield-Mask: 0x01)             */
#define IICA_IICCTL00_STT_Pos            (1UL)                     /*!< IICA0 IICCTL00: STT (Bit 1)                           */
#define IICA_IICCTL00_STT_Msk            (0x2UL)                   /*!< IICA0 IICCTL00: STT (Bitfield-Mask: 0x01)             */
#define IICA_IICCTL00_ACKE_Pos           (2UL)                     /*!< IICA0 IICCTL00: ACKE (Bit 2)                          */
#define IICA_IICCTL00_ACKE_Msk           (0x4UL)                   /*!< IICA0 IICCTL00: ACKE (Bitfield-Mask: 0x01)            */
#define IICA_IICCTL00_WTIM_Pos           (3UL)                     /*!< IICA0 IICCTL00: WTIM (Bit 3)                          */
#define IICA_IICCTL00_WTIM_Msk           (0x8UL)                   /*!< IICA0 IICCTL00: WTIM (Bitfield-Mask: 0x01)            */
#define IICA_IICCTL00_SPIE_Pos           (4UL)                     /*!< IICA0 IICCTL00: SPIE (Bit 4)                          */
#define IICA_IICCTL00_SPIE_Msk           (0x10UL)                  /*!< IICA0 IICCTL00: SPIE (Bitfield-Mask: 0x01)            */
#define IICA_IICCTL00_WREL_Pos           (5UL)                     /*!< IICA0 IICCTL00: WREL (Bit 5)                          */
#define IICA_IICCTL00_WREL_Msk           (0x20UL)                  /*!< IICA0 IICCTL00: WREL (Bitfield-Mask: 0x01)            */
#define IICA_IICCTL00_LREL_Pos           (6UL)                     /*!< IICA0 IICCTL00: LREL (Bit 6)                          */
#define IICA_IICCTL00_LREL_Msk           (0x40UL)                  /*!< IICA0 IICCTL00: LREL (Bitfield-Mask: 0x01)            */
#define IICA_IICCTL00_IICE_Pos           (7UL)                     /*!< IICA0 IICCTL00: IICE (Bit 7)                          */
#define IICA_IICCTL00_IICE_Msk           (0x80UL)                  /*!< IICA0 IICCTL00: IICE (Bitfield-Mask: 0x01)            */
/* =======================================================  IICCTL01  ======================================================== */
#define IICA_IICCTL01_PRS_Pos            (0UL)                     /*!< IICA0 IICCTL01: PRS (Bit 0)                           */
#define IICA_IICCTL01_PRS_Msk            (0x1UL)                   /*!< IICA0 IICCTL01: PRS (Bitfield-Mask: 0x01)             */
#define IICA_IICCTL01_DFC_Pos            (2UL)                     /*!< IICA0 IICCTL01: DFC (Bit 2)                           */
#define IICA_IICCTL01_DFC_Msk            (0x4UL)                   /*!< IICA0 IICCTL01: DFC (Bitfield-Mask: 0x01)             */
#define IICA_IICCTL01_SMC_Pos            (3UL)                     /*!< IICA0 IICCTL01: SMC (Bit 3)                           */
#define IICA_IICCTL01_SMC_Msk            (0x8UL)                   /*!< IICA0 IICCTL01: SMC (Bitfield-Mask: 0x01)             */
#define IICA_IICCTL01_DAD_Pos            (4UL)                     /*!< IICA0 IICCTL01: DAD (Bit 4)                           */
#define IICA_IICCTL01_DAD_Msk            (0x10UL)                  /*!< IICA0 IICCTL01: DAD (Bitfield-Mask: 0x01)             */
#define IICA_IICCTL01_CLD_Pos            (5UL)                     /*!< IICA0 IICCTL01: CLD (Bit 5)                           */
#define IICA_IICCTL01_CLD_Msk            (0x20UL)                  /*!< IICA0 IICCTL01: CLD (Bitfield-Mask: 0x01)             */
#define IICA_IICCTL01_WUP_Pos            (7UL)                     /*!< IICA0 IICCTL01: WUP (Bit 7)                           */
#define IICA_IICCTL01_WUP_Msk            (0x80UL)                  /*!< IICA0 IICCTL01: WUP (Bitfield-Mask: 0x01)             */
/* ========================================================  IICWL0  ========================================================= */
/* ========================================================  IICWH0  ========================================================= */
/* =========================================================  SVA0  ========================================================== */
/* ========================================================  IICA00  ========================================================= */
/* =========================================================  IICS0  ========================================================= */
#define IICA_IICS0_MSTS_Pos              (7UL)                     /*!< IICA0 IICS0: MSTS (Bit 7)                             */
#define IICA_IICS0_MSTS_Msk              (0x80UL)                  /*!< IICA0 IICS0: MSTS (Bitfield-Mask: 0x01)               */
#define IICA_IICS0_ALD_Pos               (6UL)                     /*!< IICA0 IICS0: ALD (Bit 6)                              */
#define IICA_IICS0_ALD_Msk               (0x40UL)                  /*!< IICA0 IICS0: ALD (Bitfield-Mask: 0x01)                */
#define IICA_IICS0_EXC_Pos               (5UL)                     /*!< IICA0 IICS0: EXC (Bit 5)                              */
#define IICA_IICS0_EXC_Msk               (0x20UL)                  /*!< IICA0 IICS0: EXC (Bitfield-Mask: 0x01)                */
#define IICA_IICS0_COI_Pos               (4UL)                     /*!< IICA0 IICS0: COI (Bit 4)                              */
#define IICA_IICS0_COI_Msk               (0x10UL)                  /*!< IICA0 IICS0: COI (Bitfield-Mask: 0x01)                */
#define IICA_IICS0_TRC_Pos               (3UL)                     /*!< IICA0 IICS0: TRC (Bit 3)                              */
#define IICA_IICS0_TRC_Msk               (0x8UL)                   /*!< IICA0 IICS0: TRC (Bitfield-Mask: 0x01)                */
#define IICA_IICS0_ACKD_Pos              (2UL)                     /*!< IICA0 IICS0: ACKD (Bit 2)                             */
#define IICA_IICS0_ACKD_Msk              (0x4UL)                   /*!< IICA0 IICS0: ACKD (Bitfield-Mask: 0x01)               */
#define IICA_IICS0_STD_Pos               (1UL)                     /*!< IICA0 IICS0: STD (Bit 1)                              */
#define IICA_IICS0_STD_Msk               (0x2UL)                   /*!< IICA0 IICS0: STD (Bitfield-Mask: 0x01)                */
#define IICA_IICS0_SPD_Pos               (0UL)                     /*!< IICA0 IICS0: SPD (Bit 0)                              */
#define IICA_IICS0_SPD_Msk               (0x1UL)                   /*!< IICA0 IICS0: SPD (Bitfield-Mask: 0x01)                */
/* =========================================================  IICF0  ========================================================= */
#define IICA_IICF0_STCF_Pos              (7UL)                     /*!< IICA0 IICF0: STCF (Bit 7)                             */
#define IICA_IICF0_STCF_Msk              (0x80UL)                  /*!< IICA0 IICF0: STCF (Bitfield-Mask: 0x01)               */
#define IICA_IICF0_IICBSY_Pos            (6UL)                     /*!< IICA0 IICF0: IICBSY (Bit 6)                           */
#define IICA_IICF0_IICBSY_Msk            (0x40UL)                  /*!< IICA0 IICF0: IICBSY (Bitfield-Mask: 0x01)             */
#define IICA_IICF0_STCEN_Pos             (1UL)                     /*!< IICA0 IICF0: STCEN (Bit 1)                            */
#define IICA_IICF0_STCEN_Msk             (0x2UL)                   /*!< IICA0 IICF0: STCEN (Bitfield-Mask: 0x01)              */
#define IICA_IICF0_IICRSV_Pos            (0UL)                     /*!< IICA0 IICF0: IICRSV (Bit 0)                           */
#define IICA_IICF0_IICRSV_Msk            (0x1UL)                   /*!< IICA0 IICF0: IICRSV (Bitfield-Mask: 0x01)             */


/* =========================================================================================================================== */
/* ================                                           IRDA                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  IRCR  ========================================================== */
#define IRDA_IRCR_IRRXINV_Pos             (2UL)                     /*!< IRDA IRCR: IRRXINV (Bit 2)                            */
#define IRDA_IRCR_IRRXINV_Msk             (0x4UL)                   /*!< IRDA IRCR: IRRXINV (Bitfield-Mask: 0x01)              */
#define IRDA_IRCR_IRTXINV_Pos             (3UL)                     /*!< IRDA IRCR: IRTXINV (Bit 3)                            */
#define IRDA_IRCR_IRTXINV_Msk             (0x8UL)                   /*!< IRDA IRCR: IRTXINV (Bitfield-Mask: 0x01)              */
#define IRDA_IRCR_IRCKS_Pos               (4UL)                     /*!< IRDA IRCR: IRCKS (Bit 4)                              */
#define IRDA_IRCR_IRCKS_Msk               (0x70UL)                  /*!< IRDA IRCR: IRCKS (Bitfield-Mask: 0x07)                */
#define IRDA_IRCR_IRE_Pos                 (7UL)                     /*!< IRDA IRCR: IRE (Bit 7)                                */
#define IRDA_IRCR_IRE_Msk                 (0x80UL)                  /*!< IRDA IRCR: IRE (Bitfield-Mask: 0x01)                  */


/* =========================================================================================================================== */
/* ================                                            LCD                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  LCDM0  ========================================================= */
#define LCD_LCDM0_LBAS_Pos                (0UL)                     /*!< LCD LCDM0: LBAS (Bit 0)                               */
#define LCD_LCDM0_LBAS_Msk                (0x3UL)                   /*!< LCD LCDM0: LBAS (Bitfield-Mask: 0x03)                 */
#define LCD_LCDM0_LDTY_Pos                (2UL)                     /*!< LCD LCDM0: LDTY (Bit 2)                               */
#define LCD_LCDM0_LDTY_Msk                (0x1cUL)                  /*!< LCD LCDM0: LDTY (Bitfield-Mask: 0x07)                 */
#define LCD_LCDM0_LWAVE_Pos               (5UL)                     /*!< LCD LCDM0: LWAVE (Bit 5)                              */
#define LCD_LCDM0_LWAVE_Msk               (0x20UL)                  /*!< LCD LCDM0: LWAVE (Bitfield-Mask: 0x01)                */
#define LCD_LCDM0_MDSET_Pos               (6UL)                     /*!< LCD LCDM0: MDSET (Bit 6)                              */
#define LCD_LCDM0_MDSET_Msk               (0xc0UL)                  /*!< LCD LCDM0: MDSET (Bitfield-Mask: 0x03)                */
/* =========================================================  LCDM1  ========================================================= */
#define LCD_LCDM1_LCDVLM_Pos              (0UL)                     /*!< LCD LCDM1: LCDVLM (Bit 0)                             */
#define LCD_LCDM1_LCDVLM_Msk              (0x1UL)                   /*!< LCD LCDM1: LCDVLM (Bitfield-Mask: 0x01)               */
#define LCD_LCDM1_LCDSEL_Pos              (3UL)                     /*!< LCD LCDM1: LCDSEL (Bit 3)                             */
#define LCD_LCDM1_LCDSEL_Msk              (0x8UL)                   /*!< LCD LCDM1: LCDSEL (Bitfield-Mask: 0x01)               */
#define LCD_LCDM1_BLON_Pos                (4UL)                     /*!< LCD LCDM1: BLON (Bit 4)                               */
#define LCD_LCDM1_BLON_Msk                (0x10UL)                  /*!< LCD LCDM1: BLON (Bitfield-Mask: 0x01)                 */
#define LCD_LCDM1_VLCON_Pos               (5UL)                     /*!< LCD LCDM1: VLCON (Bit 5)                              */
#define LCD_LCDM1_VLCON_Msk               (0x20UL)                  /*!< LCD LCDM1: VLCON (Bitfield-Mask: 0x01)                */
#define LCD_LCDM1_SCOC_Pos                (6UL)                     /*!< LCD LCDM1: SCOC (Bit 6)                               */
#define LCD_LCDM1_SCOC_Msk                (0x40UL)                  /*!< LCD LCDM1: SCOC (Bitfield-Mask: 0x01)                 */
#define LCD_LCDM1_LCDON_Pos               (7UL)                     /*!< LCD LCDM1: LCDON (Bit 7)                              */
#define LCD_LCDM1_LCDON_Msk               (0x80UL)                  /*!< LCD LCDM1: LCDON (Bitfield-Mask: 0x01)                */
/* =========================================================  LCDC0  ========================================================= */
/* =========================================================  VLCD  ========================================================== */
/* ==========================================================  SEG  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            DMA                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  DMAEN  ========================================================= */
/* ========================================================  DMABAR  ========================================================= */
/* =========================================================  DMSET  ========================================================= */
/* =========================================================  DMCLR  ========================================================= */


/* =========================================================================================================================== */
/* ================                                          DMAVEC                                           ================ */
/* =========================================================================================================================== */

/* ==========================================================  VEC  ========================================================== */


/* =========================================================================================================================== */
/* ================                                            ELC                                            ================ */
/* =========================================================================================================================== */

/* =======================================================  ELSELR00  ======================================================== */
/* =======================================================  ELSELR01  ======================================================== */
/* =======================================================  ELSELR02  ======================================================== */
/* =======================================================  ELSELR03  ======================================================== */
/* =======================================================  ELSELR04  ======================================================== */
/* =======================================================  ELSELR05  ======================================================== */
/* =======================================================  ELSELR06  ======================================================== */
/* =======================================================  ELSELR07  ======================================================== */
/* =======================================================  ELSELR08  ======================================================== */
/* =======================================================  ELSELR09  ======================================================== */
/* =======================================================  ELSELR10  ======================================================== */
/* =======================================================  ELSELR11  ======================================================== */
/* =======================================================  ELSELR12  ======================================================== */
/* =======================================================  ELSELR13  ======================================================== */
/* =======================================================  ELSELR14  ======================================================== */
/* =======================================================  ELSELR15  ======================================================== */


/* =========================================================================================================================== */
/* ================                                            INT                                            ================ */
/* =========================================================================================================================== */



/* =========================================================================================================================== */
/* ================                                           INTM                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  EGP0  ========================================================== */
#define INTM_EGP0_EGP0_Pos                (0UL)                     /*!< INTM EGP0: EGP0 (Bit 0)                               */
#define INTM_EGP0_EGP0_Msk                (0x1UL)                   /*!< INTM EGP0: EGP0 (Bitfield-Mask: 0x01)                 */
#define INTM_EGP0_EGP1_Pos                (1UL)                     /*!< INTM EGP0: EGP1 (Bit 1)                               */
#define INTM_EGP0_EGP1_Msk                (0x2UL)                   /*!< INTM EGP0: EGP1 (Bitfield-Mask: 0x01)                 */
#define INTM_EGP0_EGP2_Pos                (2UL)                     /*!< INTM EGP0: EGP2 (Bit 2)                               */
#define INTM_EGP0_EGP2_Msk                (0x4UL)                   /*!< INTM EGP0: EGP2 (Bitfield-Mask: 0x01)                 */
#define INTM_EGP0_EGP3_Pos                (3UL)                     /*!< INTM EGP0: EGP3 (Bit 3)                               */
#define INTM_EGP0_EGP3_Msk                (0x8UL)                   /*!< INTM EGP0: EGP3 (Bitfield-Mask: 0x01)                 */
#define INTM_EGP0_EGP4_Pos                (4UL)                     /*!< INTM EGP0: EGP4 (Bit 4)                               */
#define INTM_EGP0_EGP4_Msk                (0x10UL)                  /*!< INTM EGP0: EGP4 (Bitfield-Mask: 0x01)                 */
#define INTM_EGP0_EGP5_Pos                (5UL)                     /*!< INTM EGP0: EGP5 (Bit 5)                               */
#define INTM_EGP0_EGP5_Msk                (0x20UL)                  /*!< INTM EGP0: EGP5 (Bitfield-Mask: 0x01)                 */
/* =========================================================  EGN0  ========================================================== */
#define INTM_EGN0_EGN0_Pos                (0UL)                     /*!< INTM EGN0: EGN0 (Bit 0)                               */
#define INTM_EGN0_EGN0_Msk                (0x1UL)                   /*!< INTM EGN0: EGN0 (Bitfield-Mask: 0x01)                 */
#define INTM_EGN0_EGN1_Pos                (1UL)                     /*!< INTM EGN0: EGN1 (Bit 1)                               */
#define INTM_EGN0_EGN1_Msk                (0x2UL)                   /*!< INTM EGN0: EGN1 (Bitfield-Mask: 0x01)                 */
#define INTM_EGN0_EGN2_Pos                (2UL)                     /*!< INTM EGN0: EGN2 (Bit 2)                               */
#define INTM_EGN0_EGN2_Msk                (0x4UL)                   /*!< INTM EGN0: EGN2 (Bitfield-Mask: 0x01)                 */
#define INTM_EGN0_EGN3_Pos                (3UL)                     /*!< INTM EGN0: EGN3 (Bit 3)                               */
#define INTM_EGN0_EGN3_Msk                (0x8UL)                   /*!< INTM EGN0: EGN3 (Bitfield-Mask: 0x01)                 */
#define INTM_EGN0_EGN4_Pos                (4UL)                     /*!< INTM EGN0: EGN4 (Bit 4)                               */
#define INTM_EGN0_EGN4_Msk                (0x10UL)                  /*!< INTM EGN0: EGN4 (Bitfield-Mask: 0x01)                 */
#define INTM_EGN0_EGN5_Pos                (5UL)                     /*!< INTM EGN0: EGN5 (Bit 5)                               */
#define INTM_EGN0_EGN5_Msk                (0x20UL)                  /*!< INTM EGN0: EGN5 (Bitfield-Mask: 0x01)                 */


/* =========================================================================================================================== */
/* ================                                            KEY                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  KRM  ========================================================== */


/* =========================================================================================================================== */
/* ================                                          PPORGA                                           ================ */
/* =========================================================================================================================== */

/* ==========================================================  PMS  ========================================================== */
/* ========================================================  GDIDIS  ========================================================= */
/* ========================================================  ISCLCD  ========================================================= */
#define PPORGA_ISCLCD_ISCCAP_Pos          (0UL)                     /*!< PPORGA ISCLCD: ISCCAP (Bit 0)                         */
#define PPORGA_ISCLCD_ISCCAP_Msk          (0x1UL)                   /*!< PPORGA ISCLCD: ISCCAP (Bitfield-Mask: 0x01)           */
#define PPORGA_ISCLCD_ISCVL_Pos           (1UL)                     /*!< PPORGA ISCLCD: ISCVL (Bit 1)                          */
#define PPORGA_ISCLCD_ISCVL_Msk           (0x2UL)                   /*!< PPORGA ISCLCD: ISCVL (Bitfield-Mask: 0x01)            */
/* ========================================================  SEGEN0  ========================================================= */
/* ========================================================  SEGEN1  ========================================================= */
/* ========================================================  SEGEN2  ========================================================= */
/* ========================================================  SEGEN3  ========================================================= */


/* =========================================================================================================================== */
/* ================                                           MISC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  NFEN0  ========================================================= */
#define MISC_NFEN0_TNFEN00_Pos            (0UL)                     /*!< MISC NFEN0: TNFEN00 (Bit 0)                           */
#define MISC_NFEN0_TNFEN00_Msk            (0x1UL)                   /*!< MISC NFEN0: TNFEN00 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN0_TNFEN01_Pos            (1UL)                     /*!< MISC NFEN0: TNFEN01 (Bit 1)                           */
#define MISC_NFEN0_TNFEN01_Msk            (0x2UL)                   /*!< MISC NFEN0: TNFEN01 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN0_TNFEN02_Pos            (2UL)                     /*!< MISC NFEN0: TNFEN02 (Bit 2)                           */
#define MISC_NFEN0_TNFEN02_Msk            (0x4UL)                   /*!< MISC NFEN0: TNFEN02 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN0_TNFEN03_Pos            (3UL)                     /*!< MISC NFEN0: TNFEN03 (Bit 3)                           */
#define MISC_NFEN0_TNFEN03_Msk            (0x8UL)                   /*!< MISC NFEN0: TNFEN03 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN0_TNFEN04_Pos            (4UL)                     /*!< MISC NFEN0: TNFEN04 (Bit 4)                           */
#define MISC_NFEN0_TNFEN04_Msk            (0x10UL)                  /*!< MISC NFEN0: TNFEN04 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN0_TNFEN05_Pos            (5UL)                     /*!< MISC NFEN0: TNFEN05 (Bit 5)                           */
#define MISC_NFEN0_TNFEN05_Msk            (0x20UL)                  /*!< MISC NFEN0: TNFEN05 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN0_TNFEN06_Pos            (6UL)                     /*!< MISC NFEN0: TNFEN06 (Bit 6)                           */
#define MISC_NFEN0_TNFEN06_Msk            (0x40UL)                  /*!< MISC NFEN0: TNFEN06 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN0_TNFEN07_Pos            (7UL)                     /*!< MISC NFEN0: TNFEN07 (Bit 7)                           */
#define MISC_NFEN0_TNFEN07_Msk            (0x80UL)                  /*!< MISC NFEN0: TNFEN07 (Bitfield-Mask: 0x01)             */
/* =========================================================  NFEN1  ========================================================= */
#define MISC_NFEN1_TNFEN10_Pos            (0UL)                     /*!< MISC NFEN1: TNFEN10 (Bit 0)                           */
#define MISC_NFEN1_TNFEN10_Msk            (0x1UL)                   /*!< MISC NFEN1: TNFEN10 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN1_TNFEN11_Pos            (1UL)                     /*!< MISC NFEN1: TNFEN11 (Bit 1)                           */
#define MISC_NFEN1_TNFEN11_Msk            (0x2UL)                   /*!< MISC NFEN1: TNFEN11 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN1_TNFEN12_Pos            (2UL)                     /*!< MISC NFEN1: TNFEN12 (Bit 2)                           */
#define MISC_NFEN1_TNFEN12_Msk            (0x4UL)                   /*!< MISC NFEN1: TNFEN12 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN1_TNFEN13_Pos            (3UL)                     /*!< MISC NFEN1: TNFEN13 (Bit 3)                           */
#define MISC_NFEN1_TNFEN13_Msk            (0x8UL)                   /*!< MISC NFEN1: TNFEN13 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN1_TNFEN14_Pos            (4UL)                     /*!< MISC NFEN1: TNFEN14 (Bit 4)                           */
#define MISC_NFEN1_TNFEN14_Msk            (0x10UL)                  /*!< MISC NFEN1: TNFEN14 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN1_TNFEN15_Pos            (5UL)                     /*!< MISC NFEN1: TNFEN15 (Bit 5)                           */
#define MISC_NFEN1_TNFEN15_Msk            (0x20UL)                  /*!< MISC NFEN1: TNFEN15 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN1_TNFEN16_Pos            (6UL)                     /*!< MISC NFEN1: TNFEN16 (Bit 6)                           */
#define MISC_NFEN1_TNFEN16_Msk            (0x40UL)                  /*!< MISC NFEN1: TNFEN16 (Bitfield-Mask: 0x01)             */
#define MISC_NFEN1_TNFEN17_Pos            (7UL)                     /*!< MISC NFEN1: TNFEN17 (Bit 7)                           */
#define MISC_NFEN1_TNFEN17_Msk            (0x80UL)                  /*!< MISC NFEN1: TNFEN17 (Bitfield-Mask: 0x01)             */
/* ==========================================================  ISC  ========================================================== */
#define MISC_ISC_ISC0_Pos                 (0UL)                     /*!< MISC ISC: ISC0 (Bit 0)                                */
#define MISC_ISC_ISC0_Msk                 (0x1UL)                   /*!< MISC ISC: ISC0 (Bitfield-Mask: 0x01)                  */
#define MISC_ISC_ISC1_Pos                 (1UL)                     /*!< MISC ISC: ISC1 (Bit 1)                                */
#define MISC_ISC_ISC1_Msk                 (0x2UL)                   /*!< MISC ISC: ISC1 (Bitfield-Mask: 0x01)                  */
//#define MISC_ISC_SSIE00_Pos               (7UL)                     /*!< MISC ISC: SSIE00 (Bit 7)                              */
//#define MISC_ISC_SSIE00_Msk               (0x80UL)                  /*!< MISC ISC: SSIE00 (Bitfield-Mask: 0x01)                */
/* =========================================================  TIOS0  ========================================================= */
/* =========================================================  RTCCL  ========================================================= */
#define MISC_RTCCL_RTCCKS_Pos             (0UL)                     /*!< MISC RTCCL: RTCCKS (Bit 0)                            */
#define MISC_RTCCL_RTCCKS_Msk             (0x3UL)                   /*!< MISC RTCCL: RTCCKS (Bitfield-Mask: 0x03)              */
#define MISC_RTCCL_RTCCL5_Pos             (5UL)                     /*!< MISC RTCCL: RTCCL5 (Bit 5)                            */
#define MISC_RTCCL_RTCCL5_Msk             (0x20UL)                  /*!< MISC RTCCL: RTCCL5 (Bitfield-Mask: 0x01)              */
#define MISC_RTCCL_RTCCL6_Pos             (6UL)                     /*!< MISC RTCCL: RTCCL6 (Bit 6)                            */
#define MISC_RTCCL_RTCCL6_Msk             (0x40UL)                  /*!< MISC RTCCL: RTCCL6 (Bitfield-Mask: 0x01)              */
#define MISC_RTCCL_RTCCL7_Pos             (7UL)                     /*!< MISC RTCCL: RTCCL7 (Bit 7)                            */
#define MISC_RTCCL_RTCCL7_Msk             (0x80UL)                  /*!< MISC RTCCL: RTCCL7 (Bitfield-Mask: 0x01)              */


/* =========================================================================================================================== */
/* ================                                            FMC                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  FLSTS  ========================================================= */
#define FMC_FLSTS_OVF_Pos                 (0UL)                     /*!< FMC FLSTS: OVF (Bit 0)                                */
#define FMC_FLSTS_OVF_Msk                 (0x1UL)                   /*!< FMC FLSTS: OVF (Bitfield-Mask: 0x01)                  */

/* ========================================================  FLOPMD1  ======================================================== */
/* ========================================================  FLOPMD2  ======================================================== */
/* ========================================================  FLERMD  ========================================================= */
/* =======================================================  FLCERCNT  ======================================================== */
/* =======================================================  FLSERCNT  ======================================================== */
/* =======================================================  FLNVSCNT  ======================================================== */
/* =======================================================  FLPROCNT  ======================================================== */
/* ========================================================  FLPROT  ========================================================= */
/* =======================================================  FLRCVCNT  ======================================================== */
#define FMC_FLRCVCNT_FLPRVCNT_Pos         (0UL)                     /*!< FMC FLRCVCNT: FLPRVCNT (Bit 0)                        */
#define FMC_FLRCVCNT_FLPRVCNT_Msk         (0x1fffUL)                /*!< FMC FLRCVCNT: FLPRVCNT (Bitfield-Mask: 0x1fff)        */
#define FMC_FLRCVCNT_LOAD0_Pos            (15UL)                    /*!< FMC FLRCVCNT: LOAD0 (Bit 15)                          */
#define FMC_FLRCVCNT_LOAD0_Msk            (0x8000UL)                /*!< FMC FLRCVCNT: LOAD0 (Bitfield-Mask: 0x01)             */
#define FMC_FLRCVCNT_FLERVCNT_Pos         (16UL)                    /*!< FMC FLRCVCNT: FLERVCNT (Bit 16)                       */
#define FMC_FLRCVCNT_FLERVCNT_Msk         (0x7fff0000UL)            /*!< FMC FLRCVCNT: FLERVCNT (Bitfield-Mask: 0x7fff)        */
#define FMC_FLRCVCNT_LOAD1_Pos            (31UL)                    /*!< FMC FLRCVCNT: LOAD1 (Bit 31)                          */
#define FMC_FLRCVCNT_LOAD1_Msk            (0x80000000UL)            /*!< FMC FLRCVCNT: LOAD1 (Bitfield-Mask: 0x01)             */
/* ========================================================  FLSECPR  ======================================================== */
#define FMC_FLSECPR_SECPR_Pos             (0UL)                     /*!< FMC FLSECPR: SECPR (Bit 0)                            */
#define FMC_FLSECPR_SECPR_Msk             (0xfUL)                   /*!< FMC FLSECPR: SECPR (Bitfield-Mask: 0x0f)              */
#define FMC_FLSECPR_KEY_Pos               (8UL)                     /*!< FMC FLSECPR: KEY (Bit 8)                              */
#define FMC_FLSECPR_KEY_Msk               (0xffffff00UL)            /*!< FMC FLSECPR: KEY (Bitfield-Mask: 0xffffff)            */


/* =========================================================================================================================== */
/* ================                                            SAF                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  CRC0CTL  ======================================================== */
#define SAF_CRC0CTL_CRC0EN_Pos            (7UL)                     /*!< SAF CRC0CTL: CRC0EN (Bit 7)                           */
#define SAF_CRC0CTL_CRC0EN_Msk            (0x80UL)                  /*!< SAF CRC0CTL: CRC0EN (Bitfield-Mask: 0x01)             */
#define SAF_CRC0CTL_FEA_Pos               (0UL)                     /*!< SAF CRC0CTL: FEA (Bit 0)                              */
#define SAF_CRC0CTL_FEA_Msk               (0x7fUL)                  /*!< SAF CRC0CTL: FEA (Bitfield-Mask: 0x7f)                */
/* ========================================================  PGCRCL  ========================================================= */
/* =========================================================  CRCIN  ========================================================= */
/* =========================================================  CRCD  ========================================================== */
/* ========================================================  RPECTL  ========================================================= */
#define SAF_RPECTL_RPEF_Pos               (0UL)                     /*!< SAF RPECTL: RPEF (Bit 0)                              */
#define SAF_RPECTL_RPEF_Msk               (0x1UL)                   /*!< SAF RPECTL: RPEF (Bitfield-Mask: 0x01)                */
#define SAF_RPECTL_RPERDIS_Pos            (7UL)                     /*!< SAF RPECTL: RPERDIS (Bit 7)                           */
#define SAF_RPECTL_RPERDIS_Msk            (0x80UL)                  /*!< SAF RPECTL: RPERDIS (Bitfield-Mask: 0x01)             */
/* =========================================================  SFRGD  ========================================================= */
#define SAF_SFRGD_GCSC_Pos                (0UL)                     /*!< SAF SFRGD: GCSC (Bit 0)                               */
#define SAF_SFRGD_GCSC_Msk                (0x1UL)                   /*!< SAF SFRGD: GCSC (Bitfield-Mask: 0x01)                 */
#define SAF_SFRGD_GINT_Pos                (1UL)                     /*!< SAF SFRGD: GINT (Bit 1)                               */
#define SAF_SFRGD_GINT_Msk                (0x2UL)                   /*!< SAF SFRGD: GINT (Bitfield-Mask: 0x01)                 */
#define SAF_SFRGD_GPORT_Pos               (2UL)                     /*!< SAF SFRGD: GPORT (Bit 2)                              */
#define SAF_SFRGD_GPORT_Msk               (0x4UL)                   /*!< SAF SFRGD: GPORT (Bitfield-Mask: 0x01)                */
#define SAF_SFRGD_GCOMP_Pos               (3UL)                     /*!< SAF SFRGD: GCOMP (Bit 3)                              */
#define SAF_SFRGD_GCOMP_Msk               (0x8UL)                   /*!< SAF SFRGD: GCOMP (Bitfield-Mask: 0x01)                */


/* =========================================================================================================================== */
/* ================                                           OSDC                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  SCMCTL  ========================================================= */
#define OSDC_SCMCTL_OSDCCMP_Pos           (0UL)                     /*!< OSDC SCMCTL: OSDCCMP (Bit 0)                          */
#define OSDC_SCMCTL_OSDCCMP_Msk           (0xfffUL)                 /*!< OSDC SCMCTL: OSDCCMP (Bitfield-Mask: 0xfff)           */
#define OSDC_SCMCTL_OSCDE_Pos             (15UL)                    /*!< OSDC SCMCTL: OSCDE (Bit 15)                           */
#define OSDC_SCMCTL_OSCDE_Msk             (0x8000UL)                /*!< OSDC SCMCTL: OSCDE (Bitfield-Mask: 0x01)              */
/* =========================================================  SCMMD  ========================================================= */
#define OSDC_SCMMD_CKSEL_Pos              (0UL)                     /*!< OSDC SCMMD: CKSEL (Bit 0)                             */
#define OSDC_SCMMD_CKSEL_Msk              (0x1UL)                   /*!< OSDC SCMMD: CKSEL (Bitfield-Mask: 0x01)               */
#define OSDC_SCMMD_MDSEL_Pos              (1UL)                     /*!< OSDC SCMMD: MDSEL (Bit 1)                             */
#define OSDC_SCMMD_MDSEL_Msk              (0x2UL)                   /*!< OSDC SCMMD: MDSEL (Bitfield-Mask: 0x01)               */
/* =========================================================  SCMST  ========================================================= */
#define OSDC_SCMST_OSTDF_Pos              (0UL)                     /*!< OSDC SCMST: OSTDF (Bit 0)                             */
#define OSDC_SCMST_OSTDF_Msk              (0x1UL)                   /*!< OSDC SCMST: OSTDF (Bitfield-Mask: 0x01)               */


/* =========================================================================================================================== */
/* ================                                           OCRV                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  HOCOFC  ========================================================= */
#define OCRV_HOCOFC_FCST_Pos              (0UL)                     /*!< OCRV HOCOFC: FCST (Bit 0)                             */
#define OCRV_HOCOFC_FCST_Msk              (0x1UL)                   /*!< OCRV HOCOFC: FCST (Bitfield-Mask: 0x01)               */
#define OCRV_HOCOFC_FCEND_Pos             (4UL)                     /*!< OCRV HOCOFC: FCEND (Bit 4)                            */
#define OCRV_HOCOFC_FCEND_Msk             (0x10UL)                  /*!< OCRV HOCOFC: FCEND (Bitfield-Mask: 0x01)              */
#define OCRV_HOCOFC_FCREF_Pos             (5UL)                     /*!< OCRV HOCOFC: FCREF (Bit 5)                            */
#define OCRV_HOCOFC_FCREF_Msk             (0x20UL)                  /*!< OCRV HOCOFC: FCREF (Bitfield-Mask: 0x01)              */
#define OCRV_HOCOFC_FCMD_Pos              (7UL)                     /*!< OCRV HOCOFC: FCMD (Bit 7)                             */
#define OCRV_HOCOFC_FCMD_Msk              (0x80UL)                  /*!< OCRV HOCOFC: FCMD (Bitfield-Mask: 0x01)               */


/* =========================================================================================================================== */
/* ================                                            DBG                                            ================ */
/* =========================================================================================================================== */

/* ========================================================  DBGSTR  ========================================================= */
#define DBG_DBGSTR_CDBGPWRUPACK_Pos       (29UL)                    /*!< DBG DBGSTR: CDBGPWRUPACK (Bit 29)                     */
#define DBG_DBGSTR_CDBGPWRUPACK_Msk       (0x20000000UL)            /*!< DBG DBGSTR: CDBGPWRUPACK (Bitfield-Mask: 0x01)        */
#define DBG_DBGSTR_CDBGPWRUPREQ_Pos       (28UL)                    /*!< DBG DBGSTR: CDBGPWRUPREQ (Bit 28)                     */
#define DBG_DBGSTR_CDBGPWRUPREQ_Msk       (0x10000000UL)            /*!< DBG DBGSTR: CDBGPWRUPREQ (Bitfield-Mask: 0x01)        */
/* =======================================================  DBGSTOPCR  ======================================================= */
#define DBG_DBGSTOPCR_SWDIS_Pos           (24UL)                    /*!< DBG DBGSTOPCR: SWDIS (Bit 24)                         */
#define DBG_DBGSTOPCR_SWDIS_Msk           (0x1000000UL)             /*!< DBG DBGSTOPCR: SWDIS (Bitfield-Mask: 0x01)            */
#define DBG_DBGSTOPCR_RPERMSK_Pos         (16UL)                    /*!< DBG DBGSTOPCR: RPERMSK (Bit 16)                       */
#define DBG_DBGSTOPCR_RPERMSK_Msk         (0x10000UL)               /*!< DBG DBGSTOPCR: RPERMSK (Bitfield-Mask: 0x01)          */
#define DBG_DBGSTOPCR_RESMSK_Pos          (2UL)                     /*!< DBG DBGSTOPCR: RESMSK (Bit 2)                         */
#define DBG_DBGSTOPCR_RESMSK_Msk          (0x4UL)                   /*!< DBG DBGSTOPCR: RESMSK (Bitfield-Mask: 0x01)           */
#define DBG_DBGSTOPCR_FRZEN1_Pos          (1UL)                     /*!< DBG DBGSTOPCR: FRZEN1 (Bit 1)                         */
#define DBG_DBGSTOPCR_FRZEN1_Msk          (0x2UL)                   /*!< DBG DBGSTOPCR: FRZEN1 (Bitfield-Mask: 0x01)           */
#define DBG_DBGSTOPCR_FRZEN0_Pos          (0UL)                     /*!< DBG DBGSTOPCR: FRZEN0 (Bit 0)                         */
#define DBG_DBGSTOPCR_FRZEN0_Msk          (0x1UL)                   /*!< DBG DBGSTOPCR: FRZEN0 (Bitfield-Mask: 0x01)           */


/* =========================================================================================================================== */
/* ================                                            TSN                                            ================ */
/* =========================================================================================================================== */

/* =========================================================  TSN85  ========================================================= */
/* =========================================================  TSN25  ========================================================= */


/* =========================================================================================================================== */
/* ================                                            UID                                            ================ */
/* =========================================================================================================================== */

/* ==========================================================  UID  ========================================================== */

/** @} */ /* End of group PosMask_peripherals */

#ifdef USE_STDPERIPH_DRIVER
  #include "BAT32G127_conf.h"
#endif /* USE_STDPERIPH_DRIVER */

#ifdef __cplusplus
}
#endif

#endif /* BAT32G127_H */


/** @} */ /* End of group BAT32G127 */

/** @} */ /* End of group Cmsemicon */
